# coding: utf-8
from sqlalchemy import Column, DECIMAL, Date, DateTime, String, TIMESTAMP, Text, text
from sqlalchemy.dialects.mysql import INTEGER, MEDIUMTEXT, TINYINT
from sqlalchemy.ext.declarative import declarative_base
from app.model.base import Base, BaseModel


class CompanyInfo(Base, BaseModel):
    __tablename__ = 'company_info'
    __table_args__ = {'comment': '˾Ϣ'}

    id = Column(String(64), primary_key=True)
    p_company_id = Column(String(64), comment='˾id')
    company_name = Column(String(255), comment='˾ȫ')
    company_short_name = Column(String(80), comment='˾ļ')
    company_english_name = Column(String(255), comment='ȫƣӢģ')
    company_type = Column(INTEGER(11), comment='˾ͣ1-˽ļ֤ȯͶʡ2-ļ˾3-С4-֤ȯ˾5-й˾6-ƻ7-ɹʣ8-Ͷʹʣ9-,10-й˾11-ڻ˾12-˾ӹ˾13ң14-˽ļȨͶʣ15-֤ȯ˾ӹ˾16-ڻ˾ӹ˾17-˽ļҵͶʣ-1-˽ļͶ')
    organization_number = Column(String(20), comment='֯')
    establish_date = Column(Date, comment='˾')
    domicile_id = Column(INTEGER(11), comment='˾עң1-й½2-ۡ3-¼¡4-Ⱥ5-̨塢6-ӢάȺBVI-1-')
    company_address = Column(String(255), comment='˾עַ')
    company_address2 = Column(String(255), comment='칫ַ')
    city = Column(String(100), comment='')
    province = Column(String(100), comment='ʡ')
    country = Column(String(100), comment='')
    reg_city = Column(String(100), comment='ע')
    reg_province = Column(String(100), comment='עʡ')
    reg_country = Column(String(100), comment='ע')
    contact_phone = Column(String(20), comment='ϵ绰')
    post_code = Column(String(40), comment='')
    fax = Column(String(20), comment='')
    email = Column(String(40), comment='')
    website = Column(String(255), comment='˾ַ')
    registered_capital = Column(DECIMAL(22, 6), comment='˾עʱ<٣Ԫ>\t')
    company_profile = Column(Text, comment='˾')
    offshore_fund = Column(INTEGER(11), comment='Ƿк0-1-ǣ-1-')
    philosopy = Column(Text, comment='Ͷ')
    company_status = Column(INTEGER(11), comment='˾״̬1-У2-ע')
    base_currency_crc = Column(INTEGER(11), comment='˾עʱҵλ1-ң2-۱ң3-Ԫ-1-')
    register_number = Column(String(20), comment='')
    register_status = Column(INTEGER(4), comment='״̬0-δ,1-ע,2-')
    register_date = Column(Date, comment='')
    register_number_address = Column(String(255), comment='ַ')
    is_member = Column(TINYINT(4), comment='ǷԱ1-ǣ0-')
    join_date = Column(Date, comment='ʱ')
    member_type = Column(INTEGER(4), comment='Աͣ1-ͨԱ2-ϯԱ3-۲Ա4-رԱ')
    fund_category_ori = Column(String(50), comment='ҪлЭͬ')
    business_type = Column(String(50), comment='ҵ')
    nature_business_type = Column(INTEGER(4), comment='ҵ:1 ҵ 2ҵ 3ҵ 4 5̶ҵ 6')
    capital_paid_rate = Column(DECIMAL(22, 6), comment='עʱʵɱ')
    logo = Column(String(255), comment='˾logo')
    isvisible = Column(INTEGER(11), comment='˾Ƿǰ̨ɼ')
    paid_capital = Column(DECIMAL(22, 6), comment='ʵʱ(Ԫ)()')
    company_asset_size = Column(INTEGER(4), comment='˾ʲģ 1:0-1 2:1-10 3:10-20 4:20-50 5:50-100 6:100')
    legal_representative = Column(String(100), comment='˴')
    representative_experience = Column(MEDIUMTEXT, comment='˴')
    is_qualify = Column(INTEGER(11), comment='Ƿ֤ 0: 1:')
    get_qualify_method = Column(String(50), comment='˴ҵʸ÷ʽ')
    employee_cnts = Column(INTEGER(11), comment='Ա')
    integrity_info = Column(String(500), comment='Ϣ')
    special_tips = Column(String(300), comment='ʾϢ')
    amac_link = Column(String(200), comment='Эվ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='ɾʶ')


class CompanyTnaPersonnel(Base, BaseModel):
    __tablename__ = 'company_tna_personnel'
    __table_args__ = {'comment': '˾ʲԱ䶯ͳ'}

    id = Column(String(64), primary_key=True, comment='ID')
    company_id = Column(String(64), nullable=False, comment='˾id')
    stat_date = Column(Date, nullable=False, comment='ͳ')
    trust_fund_asset_size = Column(DECIMAL(22, 6), comment='йʲģ<٣Ԫ>')
    special_account_asset_size = Column(DECIMAL(22, 6), comment='רʲģ<٣Ԫ>')
    ltdco_fund_asset_size = Column(DECIMAL(22, 6), comment='޺ϻʲģ<٣Ԫ>')
    offshore_fund_asset_size = Column(DECIMAL(22, 6), comment='ʲģ<٣Ԫ>')
    fund_num = Column(INTEGER(11), comment='')
    staff_num = Column(INTEGER(11), comment='˾')
    analyst_num = Column(INTEGER(11), comment='ͶԱ')
    total_asset_size = Column(DECIMAL(22, 6), comment='ʲģ<٣Ԫ>\t')
    create_by = Column(String(64))
    create_time = Column(DateTime)
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(INTEGER(11), nullable=False, server_default=text("'0'"))


class ConfidenceIndex(Base, BaseModel):
    __tablename__ = 'confidence_index'
    __table_args__ = {'comment': 'Գָ'}

    id = Column(String(64), primary_key=True)
    index_id = Column(String(64), nullable=False, index=True, comment='ָid')
    index_name = Column(String(50), nullable=False, comment='ָȫ')
    index_date = Column(Date, nullable=False, comment='ָ')
    index_value = Column(DECIMAL(22, 6), nullable=False, comment='ֵָ')
    market_estimation_index = Column(DECIMAL(22, 6), nullable=False, comment='AгԤֵָ')
    position_plan_index = Column(DECIMAL(22, 6), nullable=False, comment='λͶʼƻֵָ')
    me_extrem_optimistic = Column(DECIMAL(22, 6), nullable=False, comment='гԤļֹٷֱ<٣%>')
    me_optimistic = Column(DECIMAL(22, 6), nullable=False, comment='гԤֹٷֱ<٣%>')
    me_netural = Column(DECIMAL(22, 6), nullable=False, comment='гԤֹٷֱ<٣%>')
    me_pessimistic = Column(DECIMAL(22, 6), nullable=False, comment='гԤıٷֱ<٣%>')
    me_extrem_pessimistic = Column(DECIMAL(22, 6), nullable=False, comment='гԤļȱٷֱ<٣%>')
    pp_increase_significant = Column(DECIMAL(22, 6), nullable=False, comment='ƻٷֱ<٣%>')
    pp_increase = Column(DECIMAL(22, 6), nullable=False, comment='ƻٷֱ<٣%>')
    pp_unchange = Column(DECIMAL(22, 6), nullable=False, comment='ƻλٷֱ<٣%>')
    pp_reduce = Column(DECIMAL(22, 6), nullable=False, comment='ƻٷֱ<٣%>')
    pp_reduce_significant = Column(DECIMAL(22, 6), nullable=False, comment='ƻٷֱ<٣%>')
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(11), nullable=False, server_default=text("'0'"))


class ContractTemplateManage(Base, BaseModel):
    __tablename__ = 'contract_template_manage'
    __table_args__ = {'comment': 'ָͬϹ'}

    id = Column(String(64), primary_key=True, comment='Ψһ')
    fund_id = Column(String(64), nullable=False, comment='Ʒid')
    trading_rules = Column(String(255), comment='׹')
    expense_subscription = Column(String(255), comment='ܷ-/깺')
    expense_ratio = Column(DECIMAL(22, 6), comment='Ϲ')
    expense_manage = Column(String(255), comment='ܷ-')
    expense_manage_ratio = Column(DECIMAL(22, 6), comment='')
    expense_achievement = Column(String(255), comment='ܷ-ҵ')
    expense_achievement_ratio = Column(DECIMAL(22, 6), comment='ܷ-ҵ')
    ifa_subscription = Column(String(255), comment='ʦֳ-/깺')
    ifa_subscription_ratio = Column(DECIMAL(22, 6), comment='ʦֳ-/깺ѱ')
    ifa_manage = Column(String(255), comment='ʦֳ-')
    ifa_manage_ratio = Column(DECIMAL(22, 6), comment='ʦֳ-ѱ')
    ifa_achievement = Column(String(255), comment='ʦֳ-ҵ')
    ifa_achievement_ratio = Column(DECIMAL(22, 6), comment='ʦֳ-ҵ')
    create_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    creart_by = Column(String(64))
    update_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    update_by = Column(String(64))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"), comment='ɾ־λ:0:δɾ,1:ɾ')


class FileDesc(Base, BaseModel):
    __tablename__ = 'file_desc'
    __table_args__ = {'comment': 'ļ'}

    id = Column(String(64), primary_key=True)
    rel_id = Column(String(64), nullable=False, index=True, server_default=text("''"), comment='ļid')
    info = Column(MEDIUMTEXT, nullable=False)
    create_by = Column(String(64), nullable=False, server_default=text("''"))
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    update_by = Column(String(64))
    update_time = Column(TIMESTAMP)
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundAssetSize(Base, BaseModel):
    __tablename__ = 'fund_asset_size'
    __table_args__ = {'comment': 'ʲģ'}

    id = Column(String(64), primary_key=True)
    fund_id = Column(String(64))
    fund_asset_size_date = Column(Date, comment='ģ')
    fund_asset_size = Column(DECIMAL(22, 6), comment='ʲģ')
    create_by = Column(String(64))
    create_time = Column(DateTime)
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(TINYINT(3), nullable=False, server_default=text("'0'"))


class FundAttribute(Base, BaseModel):
    __tablename__ = 'fund_attributes'
    __table_args__ = {'comment': ''}

    id = Column(String(64), primary_key=True, comment='id')
    master_feeder_fund = Column(INTEGER(11), comment='ǷΪmaster feeder fund:1-')
    target_return_fund = Column(INTEGER(11), comment='ǷΪĿرͻ1-')
    risk_buffer_fund = Column(INTEGER(11), comment='ǷΪջͻ1-')
    umbrella_fund = Column(INTEGER(11), comment='ǷΪɡβƷ1-')
    share_class = Column(INTEGER(11), comment='ּݶʶ1-')
    multi_advisor = Column(INTEGER(11), comment='Ͷˣ1-')
    pro_class_m = Column(INTEGER(11), comment='ǷΪּĸ1-')
    pro_class_s = Column(INTEGER(11), comment='ǷΪּӻ1-')
    tot_sign = Column(TINYINT(4), comment='ǷTOT(һһ:1-;0-')
    create_by = Column(String(64))
    create_time = Column(DateTime)
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(TINYINT(4))


class FundBank(Base, BaseModel):
    __tablename__ = 'fund_bank'
    __table_args__ = {'comment': 'йϢ'}

    fund_id = Column(String(64), primary_key=True)
    bank_code = Column(String(32), comment='code')
    bank_id = Column(String(32))
    bank_name = Column(String(64), nullable=False, comment='')
    fund_account = Column(String(64), nullable=False, comment='˺id')
    account_name = Column(String(32), nullable=False, comment='')
    create_by = Column(String(64), nullable=False)
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    update_by = Column(String(64), nullable=False)
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundCombineInfo(Base, BaseModel):
    __tablename__ = 'fund_combine_info'
    __table_args__ = {'comment': 'ϻ'}

    id = Column(String(64), primary_key=True)
    p_fund_id = Column(String(64), nullable=False, comment='ϻid')
    fund_id = Column(String(64), nullable=False, comment='id')
    change_date = Column(Date, comment='±䶯')
    proportion_ratio = Column(DECIMAL(22, 6), comment='ռ')
    compare_last = Column(DECIMAL(22, 6), comment='ϴƼֱֲ䶯')
    flag = Column(INTEGER(3), comment='ϻʶ 0ǰ 1ʷ')
    create_time = Column(DateTime)
    create_by = Column(String(64))
    update_time = Column(DateTime)
    update_by = Column(String(64))
    delete_tag = Column(INTEGER(3), server_default=text("'0'"))


class FundCombineInfoLog(Base, BaseModel):
    __tablename__ = 'fund_combine_info_log'
    __table_args__ = {'comment': 'ϻ¼'}

    id = Column(String(64), primary_key=True)
    p_fund_id = Column(String(64), nullable=False, comment='ϻid')
    fund_id = Column(String(64), nullable=False, comment='id')
    change_date = Column(Date, comment='䶯')
    proportion_ratio = Column(DECIMAL(22, 6), comment='ռ')
    compare_last = Column(DECIMAL(22, 6), comment='ϴγֱֲ䶯')
    create_time = Column(DateTime)
    create_by = Column(String(64))
    update_time = Column(DateTime)
    update_by = Column(String(64))
    delete_tag = Column(INTEGER(3), server_default=text("'0'"))


class FundCount(Base, BaseModel):
    __tablename__ = 'fund_count'
    __table_args__ = {'comment': 'ʷҵ'}

    id = Column(String(64), primary_key=True)
    fund_id = Column(String(64), nullable=False, unique=True, comment='id')
    strategy = Column(INTEGER(4), index=True, comment='Է')
    substrategy = Column(INTEGER(4), comment="ӲԷ:1010-۶ͷ 1020-Ʊ 1030-ͷ 2010-۲ 3010- 3020- 3030- 3040- 3050-ڻ 4010- 4020- 4030-ڽ 4040-¼ 5010-Ʊг 5020- 5030-Լֵ 6010-ծ 6020-ǿծ 6030-ո 7010-MOM 7020-FOF 8010-۶ 8020- -1-'")
    type = Column(INTEGER(3), nullable=False, server_default=text("'0'"), comment='ǷԤԼ 0:ԤԼ 1:ԤԼ')
    end_date = Column(Date, comment='')
    price_date = Column(Date, comment='ۼƾֵ')
    net_nav = Column(DECIMAL(22, 6), comment='λֵ')
    cumulative_nav = Column(DECIMAL(22, 6), comment='ۼƾֵ')
    ret_1day = Column(DECIMAL(22, 6), comment='һ')
    ret_1day_bm1 = Column(DECIMAL(22, 6), comment='һ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_1w = Column(DECIMAL(22, 6), comment='һ')
    ret_1w_bm1 = Column(DECIMAL(22, 6), comment='һܻ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_1m = Column(DECIMAL(22, 6), comment='һ')
    ret_1m_bm1 = Column(DECIMAL(22, 6), comment='һ»׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_3m = Column(DECIMAL(22, 6), comment='')
    ret_3m_bm1 = Column(DECIMAL(22, 6), comment='»׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_6m = Column(DECIMAL(22, 6), comment='')
    ret_6m_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_1y = Column(DECIMAL(22, 6), comment='һ')
    ret_1y_bm1 = Column(DECIMAL(22, 6), comment='һ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_2y = Column(DECIMAL(22, 6), comment='')
    ret_2y_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_2y_a = Column(DECIMAL(22, 6), comment='ʣ껯')
    ret_2y_bm1_a = Column(DECIMAL(22, 6), comment='׼ָʣ껯׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_3y = Column(DECIMAL(22, 6), comment='')
    ret_3y_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_3y_a = Column(DECIMAL(22, 6), comment='ʣ껯')
    ret_3y_bm1_a = Column(DECIMAL(22, 6), comment='׼ָʣ껯׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_4y = Column(DECIMAL(22, 6), comment='')
    ret_4y_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_4y_a = Column(DECIMAL(22, 6), comment='ʣ껯')
    ret_4y_bm1_a = Column(DECIMAL(22, 6), comment='׼ָʣ껯׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_5y = Column(DECIMAL(22, 6), comment='')
    ret_5y_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_5y_a = Column(DECIMAL(22, 6), comment='ʣ껯')
    ret_5y_bm1_a = Column(DECIMAL(22, 6), comment='׼ָʣ껯׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_ytd = Column(DECIMAL(22, 6), comment='')
    ret_ytd_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_incep = Column(DECIMAL(22, 6), comment='')
    ret_incep_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_incep_a = Column(DECIMAL(22, 6), comment='ʣ껯')
    ret_incep_bm1_a = Column(DECIMAL(22, 6), comment='׼ָʣ껯׼ָbm1=300ȡڻ趨Ļ׼ָ')
    sharperatio_1y = Column(DECIMAL(22, 6), comment='һձ')
    sharperatio_2y = Column(DECIMAL(22, 6), comment='ձ')
    sharperatio_3y = Column(DECIMAL(22, 6), comment='ձ')
    sharperatio_4y = Column(DECIMAL(22, 6), comment='ձ')
    sharperatio_5y = Column(DECIMAL(22, 6), comment='ձ')
    sharperatio_incep = Column(DECIMAL(22, 6), comment='ձ')
    stddev_1y = Column(DECIMAL(22, 6), comment='һ껯')
    stddev_2y = Column(DECIMAL(22, 6), comment='껯')
    stddev_3y = Column(DECIMAL(22, 6), comment='껯')
    stddev_4y = Column(DECIMAL(22, 6), comment='껯')
    stddev_5y = Column(DECIMAL(22, 6), comment='껯')
    stddev_10y = Column(DECIMAL(22, 6), comment='ʮ껯')
    stddev_incep = Column(DECIMAL(22, 6), comment='껯')
    stddev_ytd = Column(DECIMAL(22, 6), comment='껯')
    maxdrawdown_1y = Column(DECIMAL(22, 6), comment='һس')
    maxdrawdown_2y = Column(DECIMAL(22, 6), comment='س')
    maxdrawdown_3y = Column(DECIMAL(22, 6), comment='س')
    maxdrawdown_4y = Column(DECIMAL(22, 6), comment='س')
    maxdrawdown_5y = Column(DECIMAL(22, 6), comment='س')
    maxdrawdown_10y = Column(DECIMAL(22, 6), comment='ʮس')
    maxdrawdown_incep = Column(DECIMAL(22, 6), comment='س')
    data_sources = Column(INTEGER(3), nullable=False, server_default=text("'1'"), comment='Դ 1:tanpu2:˽ļ 3:ָ')
    update_time = Column(TIMESTAMP, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    status = Column(INTEGER(3), nullable=False, server_default=text("'0'"), comment='0:ϼ  1ϼ 2¼')
    sort = Column(INTEGER(11), server_default=text("'0'"), comment='')
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundDistribution(Base, BaseModel):
    __tablename__ = 'fund_distribution'
    __table_args__ = {'comment': 'ֺ'}

    id = Column(String(64), primary_key=True)
    fund_id = Column(String(64), nullable=False, index=True, comment='Id')
    distribute_date = Column(Date, nullable=False, comment='')
    distribute_type = Column(INTEGER(11), nullable=False, comment='ͱ־-1-1-ֺ죬2- 3-ҵ -1-')
    distribution = Column(DECIMAL(22, 6), comment='ֺ/ֱ')
    create_by = Column(String(64))
    create_time = Column(DateTime)
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(INTEGER(11), nullable=False, server_default=text("'0'"))


class FundExplain(Base, BaseModel):
    __tablename__ = 'fund_explain'
    __table_args__ = {'comment': 'Ʒ'}

    id = Column(String(64), primary_key=True, comment='id')
    fund_id = Column(String(64), nullable=False, comment='id')
    title = Column(String(128), nullable=False, comment='')
    content = Column(String(2000), nullable=False, comment='')
    sort = Column(INTEGER(11), nullable=False, server_default=text("'0'"), comment='')
    create_by = Column(String(64), nullable=False, comment='')
    create_time = Column(DateTime, nullable=False, comment='ʱ')
    update_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='ʱ')
    delete_tag = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='ɾʶ')


class FundFileRecord(Base, BaseModel):
    __tablename__ = 'fund_file_record'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ref_id = Column(String(64), index=True, comment='ID')
    file_name = Column(String(128), comment='ļԭʼ')
    original_url = Column(String(256), comment='ļԭ')
    type = Column(INTEGER(5), nullable=False, server_default=text("'1'"), comment='1:,2:,3:̽б')
    file_suffix = Column(String(128), comment='ļ׺')
    logical_name = Column(String(128), comment='ļ߼')
    logical_path = Column(String(256), index=True, comment='ļ·')
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"), comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"), comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='ɾʶ')
    task_id = Column(String(100), comment='id')
    status = Column(INTEGER(1), comment='״̬ 0 ת  1Ѿת  2תʧ')


class FundFuturestypeMapping(Base, BaseModel):
    __tablename__ = 'fund_futurestype_mapping'
    __table_args__ = {'comment': 'ͶƷϢ'}

    id = Column(String(64), primary_key=True)
    fund_id = Column(String(64), nullable=False)
    futures_type = Column(TINYINT(4), comment='ͶƷ:1-Ʒڻ2-ڻ3-Ʊ4-ծȯ͡5-ָ͡6-Ȩ͡7-͡8-塢-1-;')
    create_by = Column(String(64))
    create_time = Column(DateTime)
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(TINYINT(3), nullable=False)


class FundInfo(Base, BaseModel):
    __tablename__ = 'fund_info'
    __table_args__ = {'comment': 'Ϣ'}

    id = Column(String(64), primary_key=True, comment='id')
    p_fund_id = Column(String(64), comment='ƷID')
    fund_name = Column(String(255), nullable=False, comment='ȫ')
    fund_short_name = Column(String(80), nullable=False, comment='ļ')
    fund_structure = Column(INTEGER(11), comment='ʽ1-˾ͣ2-ϻͣ3-Լͣ-1-')
    fund_type = Column(INTEGER(4), comment='˽ļͣ1-мƻ2-޺ϻ3-ȯʹܣ4-ļר5-˻6-֤ȯͶʻ7-8-ڻʹܣ9-ʹܡ10-ҵͶʻ11-ȨͶʻ12-ơ13-С-1Ͷʻ   \t\t\\nļͣ1-͡2-ծȯ͡3-ծȯ4-ӻ5-͡6-ծȯָ7-͡8-͡9-QDII10-Ʊָ11-QDII-ָ12-Ʊ͡13-̶桢14-ּܸˡ15-ETF-ڡ16-QDII-ETF17-ծȯ-ڡ18-ʽ')
    type = Column(INTEGER(3), nullable=False, server_default=text("'0'"), comment='ǷԤԼ 0:ԤԼ 1:ԤԼ')
    raise_type = Column(INTEGER(4), comment='ļʽ1-˽ļ2-ļ')
    fund_characteristic = Column(Text, comment='ȯʹܲƷص')
    base_currency = Column(INTEGER(11), comment=',1-ң2-۱ң3-Ԫ4-ݣ-1-')
    inception_date = Column(Date, comment='')
    domicile = Column(INTEGER(4), comment='ע,1-й½2-ۡ3-¼¡4-Ⱥ5-̨塢6-ӢάȺBVI-1-')
    primary_benchmark_id = Column(String(64), comment="ָid'IN'ͷ(36Ʊʽ,8λ㣩 IN00000001")
    lockup_period = Column(INTEGER(4), comment=' (:λ£-1ȷ0޷)')
    open_day = Column(String(400), comment='')
    apply_day = Column(DateTime, comment='ԤԼ')
    redeem_day = Column(DateTime, comment='ؿ')
    duration = Column(INTEGER(11), comment='Ʒڣλ¡-1ȷ0޹̶ޣ999999')
    investment_scope = Column(Text, comment='ͶʷΧ')
    investment_restriction = Column(Text, comment='Ͷ')
    fund_investment_philosophy = Column(Text, comment='Ͷ')
    fund_strategy_description = Column(Text, comment='Ͷʲ')
    advisor_id = Column(String(64), comment='Ͷʹid')
    custodian_id = Column(String(64), comment='йId')
    broker_id = Column(String(64), comment='֤ȯId')
    broker_future_id = Column(String(64), comment='ڻid')
    liquidation_agency_id = Column(String(64), comment='Id')
    trust_id = Column(String(64), comment='˾Id')
    investment_consultant_id = Column(String(64), comment='ͶʹId')
    administrator_id = Column(String(64), comment='Id')
    legal_counsel_id = Column(String(64), comment='ɹId')
    auditor_id = Column(String(64), comment='ƻ')
    nav_frequency = Column(INTEGER(3), comment='ֵ¶Ƶ 1: 2 3 4 5')
    performance_disclosure_mark = Column(INTEGER(4), comment='Ʒҵ¶ʶ1-AAA2-AA3-A4-A-5-A+')
    register_number = Column(String(20), comment='')
    register_date = Column(Date, comment='')
    isvisible = Column(INTEGER(4), comment='ǰ̨Ƿɼ:1-ɼ 0-ɼ')
    istiered = Column(INTEGER(4), comment='Ƿּ1-ּ0-ּ;')
    is_ranking = Column(INTEGER(4), comment='Ƿ1- 0- \t')
    is_rating = Column(INTEGER(4), comment='Ƿ1- 0-\t')
    special_tips = Column(String(300), comment='Эرʾ')
    amac_url = Column(String(255), comment='Э')
    nav_source_type = Column(INTEGER(4), comment='ֵԴ˵1-й2-ȯ̹3-˽ļ')
    combine_target = Column(Text, comment='Ŀ')
    fit_group = Column(Text, comment='ʺȺ')
    combine_comment = Column(Text, comment='ϵ')
    transfer_comment = Column(Text, comment='ֵ')
    desc_info = Column(String(512), comment='')
    strategy = Column(INTEGER(4), comment='ǲԷ࣬1-Ʊԣ2-۲ԣ3-ڻ4-¼5-Լֵԣ6-̶ԣ7-ϻ8-ϲԣ-1-')
    substrategy = Column(INTEGER(4), comment="ӲԷ:1010-۶ͷ 1020-Ʊ 1030-ͷ 2010-۲ 3010- 3020- 3030- 3040- 3050-ڻ 4010- 4020- 4030-ڽ 4040-¼ 5010-Ʊг 5020- 5030-Լֵ 6010-ծ 6020-ǿծ 6030-ո 7010-MOM 7020-FOF 8010-۶ 8020- -1-'")
    risk_level = Column(INTEGER(1), comment='յȼ')
    create_by = Column(String(64))
    create_time = Column(DateTime)
    update_by = Column(String(64))
    update_time = Column(DateTime)
    data_sources = Column(INTEGER(5), nullable=False, server_default=text("'1'"), comment='Դ 1:tanpu2:˽ļ')
    status = Column(INTEGER(1), comment='0:ϼ  1ϼ 2¼')
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"), comment='ɾʶ 0: 1:')
    sort = Column(INTEGER(10), nullable=False, server_default=text("'0'"), comment='')


class FundManagerMapping(Base, BaseModel):
    __tablename__ = 'fund_manager_mapping'
    __table_args__ = {'comment': ''}

    id = Column(String(64), primary_key=True)
    fund_id = Column(String(64), nullable=False, index=True, comment='id')
    fund_manager_id = Column(String(64), index=True, comment='idԱid')
    management_start_date = Column(Date, comment='ʼʱ')
    management_end_date = Column(Date, comment='ʱ')
    isvisible = Column(INTEGER(11), comment='ǰ̨Ƿɼ,1-ɼ 0-ɼ')
    create_by = Column(String(64))
    create_time = Column(DateTime)
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(INTEGER(11), nullable=False, server_default=text("'0'"))


class FundMarketIndex(Base, BaseModel):
    __tablename__ = 'fund_market_indexes'
    __table_args__ = {'comment': 'ָ'}

    id = Column(String(64), primary_key=True)
    index_id = Column(String(10), nullable=False)
    index_code = Column(String(20), nullable=False, comment='ָ')
    price_date = Column(Date, comment='')
    preclose = Column(DECIMAL(22, 6))
    open = Column(DECIMAL(22, 6))
    high = Column(DECIMAL(22, 6))
    low = Column(DECIMAL(22, 6))
    close = Column(DECIMAL(22, 6))
    trade_volumen = Column(DECIMAL(22, 6))
    trade_amount = Column(DECIMAL(22, 6))
    wave_range = Column(DECIMAL(22, 6))
    day_price_limit = Column(DECIMAL(22, 6))
    duration = Column(DECIMAL(22, 6))
    convexity = Column(String(22))
    create_time = Column(DateTime)
    create_by = Column(String(64))
    update_time = Column(DateTime)
    update_by = Column(String(64))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundNav(Base, BaseModel):
    __tablename__ = 'fund_nav'
    __table_args__ = {'comment': 'ֵ'}

    id = Column(String(64), primary_key=True)
    fund_id = Column(String(64), nullable=False, index=True, comment="id'HF'ͷ(36Ʊʽ,8λ㣩 HF00000001")
    price_date = Column(Date, nullable=False, comment='ֵ')
    nav = Column(DECIMAL(22, 6), nullable=False, comment='λֵ')
    cumulative_nav = Column(DECIMAL(22, 6), comment='ǷֺͶʵĵλۼƾֵ')
    cumulative_nav_withdrawal = Column(DECIMAL(22, 6), comment='ֺ첻Ͷʵĵλۼƾֵ')
    ishigh_or_low = Column(INTEGER(11), comment='ֵ¸߻µͱ־1-ʷ¸ߣ2-ʷµͣ3-ûдʷ¸Ҳûдʷµ;-1-')
    tohigh_nav_ratio = Column(DECIMAL(22, 6), comment='ʷ¸ߵľ룬ʷۼƾֵ-ۼƾֵ*100%/ۼƾֵ')
    create_by = Column(String(64), server_default=text("'admin'"))
    create_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    update_by = Column(String(64), nullable=False, server_default=text("'admin'"))
    update_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundPerformance(Base, BaseModel):
    __tablename__ = 'fund_performance'
    __table_args__ = {'comment': 'ʷҵ'}

    id = Column(String(64), primary_key=True)
    fund_id = Column(String(64), nullable=False, index=True, comment='id')
    end_date = Column(Date, nullable=False, comment='')
    price_date = Column(Date, comment='ۼƾֵ')
    cumulative_nav = Column(DECIMAL(22, 6), comment='ۼƾֵ')
    ret_1day = Column(DECIMAL(22, 6), comment='һ')
    ret_1day_bm1 = Column(DECIMAL(22, 6), comment='һ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_1w = Column(DECIMAL(22, 6), comment='һ')
    ret_1w_bm1 = Column(DECIMAL(22, 6), comment='һܻ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_1m = Column(DECIMAL(22, 6), comment='һ')
    ret_cum_1m = Column(DECIMAL(22, 6), comment='һۼ')
    ret_1m_bm1 = Column(DECIMAL(22, 6), comment='һ»׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_cum_1m_bm1 = Column(DECIMAL(22, 6), comment='һۼƻ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_3m = Column(DECIMAL(22, 6), comment='')
    ret_3m_bm1 = Column(DECIMAL(22, 6), comment='»׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_cum_3m = Column(DECIMAL(22, 6), comment='ۼ')
    ret_cum_3m_bm1 = Column(DECIMAL(22, 6), nullable=False, comment='ۼƻ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_6m = Column(DECIMAL(22, 6), comment='')
    ret_cum_6m = Column(DECIMAL(22, 6), comment='ۼ')
    ret_6m_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_cum_6m_bm1 = Column(DECIMAL(22, 6), comment='ۼƻ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_1y = Column(DECIMAL(22, 6), comment='һ')
    ret_cum_1y = Column(DECIMAL(22, 6), comment='һۼ')
    ret_1y_bm1 = Column(DECIMAL(22, 6), comment='һ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_cum_1y_bm1 = Column(DECIMAL(22, 6), comment='һۼƻ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_2y = Column(DECIMAL(22, 6), comment='')
    ret_cum_2y = Column(DECIMAL(22, 6), comment='ۼ')
    ret_2y_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_cum_2y_bm1 = Column(DECIMAL(22, 6), comment='ۼƻ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_2y_a = Column(DECIMAL(22, 6), comment='ʣ껯')
    ret_2y_bm1_a = Column(DECIMAL(22, 6), comment='׼ָʣ껯׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_3y = Column(DECIMAL(22, 6), comment='')
    ret_cum_3y = Column(DECIMAL(22, 6), comment='ۼ')
    ret_3y_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_cum_3y_bm1 = Column(DECIMAL(22, 6), comment='ۼƻ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_3y_a = Column(DECIMAL(22, 6), comment='ʣ껯')
    ret_3y_bm1_a = Column(DECIMAL(22, 6), comment='׼ָʣ껯׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_4y = Column(DECIMAL(22, 6), comment='')
    ret_cum_4y = Column(DECIMAL(22, 6), comment='ۼ')
    ret_4y_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_cum_4y_bm1 = Column(DECIMAL(22, 6), comment='ۼƻ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_4y_a = Column(DECIMAL(22, 6), comment='ʣ껯')
    ret_4y_bm1_a = Column(DECIMAL(22, 6), comment='׼ָʣ껯׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_5y = Column(DECIMAL(22, 6), comment='')
    ret_cum_5y = Column(DECIMAL(22, 6), comment='ۼ')
    ret_5y_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_cum_5y_bm1 = Column(DECIMAL(22, 6), comment='ۼƻ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_5y_a = Column(DECIMAL(22, 6), comment='ʣ껯')
    ret_5y_bm1_a = Column(DECIMAL(22, 6), comment='׼ָʣ껯׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_ytd = Column(DECIMAL(22, 6), comment='')
    ret_cum_ytd = Column(DECIMAL(22, 6), comment='ۼ')
    ret_ytd_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_cum_ytd_bm1 = Column(DECIMAL(22, 6), comment='ۼƻ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_incep = Column(DECIMAL(22, 6), comment='')
    ret_cum_incep = Column(DECIMAL(22, 6), comment='ۼ')
    ret_incep_bm1 = Column(DECIMAL(22, 6), comment='׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_cum_incep_bm1 = Column(DECIMAL(22, 6), comment='ۼƻ׼ָʣ׼ָbm1=300ȡڻ趨Ļ׼ָ')
    ret_incep_a = Column(DECIMAL(22, 6), comment='ʣ껯')
    ret_incep_bm1_a = Column(DECIMAL(22, 6), comment='׼ָʣ껯׼ָbm1=300ȡڻ趨Ļ׼ָ')
    update_time = Column(TIMESTAMP, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundPerformanceRanking(Base, BaseModel):
    __tablename__ = 'fund_performance_ranking'
    __table_args__ = {'comment': 'ҵ'}

    id = Column(String(64), primary_key=True)
    class_id = Column(INTEGER(11), nullable=False, comment=',1:Ʒͣ2Ͷʲ')
    fund_id = Column(String(64), nullable=False, index=True, comment='id')
    end_date = Column(String(10), nullable=False, comment='')
    absrank_ret_1m = Column(INTEGER(11), comment='һʵľ')
    perrank_ret_1m = Column(INTEGER(11), comment='һʵ(%)')
    absrank_ret_3m = Column(INTEGER(11), comment='ʵľ')
    perrank_ret_3m = Column(INTEGER(11), comment='ʵ(%)')
    absrank_ret_6m = Column(INTEGER(11), comment='ʵľ')
    perrank_ret_6m = Column(INTEGER(11), comment='ʵ(%)')
    absrank_ret_1y = Column(INTEGER(11), comment='һʵľ')
    perrank_ret_1y = Column(INTEGER(11), comment='һʵ(%)')
    absrank_ret_2y = Column(INTEGER(11), comment='ʵľ')
    perrank_ret_2y = Column(INTEGER(11), comment='ʵ(%)')
    absrank_ret_3y = Column(INTEGER(11), comment='ʵľ')
    perrank_ret_3y = Column(INTEGER(11), comment='ʵ(%)')
    absrank_ret_4y = Column(INTEGER(11), comment='ʵľ')
    perrank_ret_4y = Column(INTEGER(11), comment='ʵ(%)')
    absrank_ret_5y = Column(INTEGER(11), comment='ʵľ')
    perrank_ret_5y = Column(INTEGER(11), comment='ʵ(%)')
    absrank_ret_ytd = Column(INTEGER(11), comment='ʵľ')
    perrank_ret_ytd = Column(INTEGER(11), comment='ʵ(%)')
    absrank_ret_incep = Column(INTEGER(11), comment='')
    perrank_ret_incep = Column(INTEGER(11), comment='(%)')
    absrank_maxdrawdown_1y = Column(INTEGER(11), comment='һسľ')
    perrank_maxdrawdown_1y = Column(INTEGER(11), comment='һس')
    absrank_maxdrawdown_2y = Column(INTEGER(11), comment='سľ')
    perrank_maxdrawdown_2y = Column(INTEGER(11), comment='س')
    absrank_maxdrawdown_3y = Column(INTEGER(11), comment='سľ')
    perrank_maxdrawdown_3y = Column(INTEGER(11), comment='س')
    absrank_maxdrawdown_4y = Column(INTEGER(11), comment='سľ')
    perrank_maxdrawdown_4y = Column(INTEGER(11), comment='س')
    absrank_maxdrawdown_5y = Column(INTEGER(11), comment='سľ')
    perrank_maxdrawdown_5y = Column(INTEGER(11), comment='س')
    absrank_adjret_1y = Column(INTEGER(11), comment='һյľ')
    perrank_adjret_1y = Column(INTEGER(11), comment='һյ')
    absrank_adjret_2y = Column(INTEGER(11), comment='յľ')
    perrank_adjret_2y = Column(INTEGER(11), comment='յ')
    absrank_adjret_3y = Column(INTEGER(11), comment='յľ')
    perrank_adjret_3y = Column(INTEGER(11), comment='յ')
    absrank_adjret_4y = Column(INTEGER(11), comment='յľ')
    perrank_adjret_4y = Column(INTEGER(11), comment='յ')
    absrank_adjret_5y = Column(INTEGER(11), comment='յľ')
    perrank_adjret_5y = Column(INTEGER(11), comment='յ')
    absrank_upsidecaptureratio_1y = Column(INTEGER(11), comment='һвʵľ')
    perrank_upsidecaptureratio_1y = Column(INTEGER(11), comment='һвʵ')
    absrank_upsidecaptureratio_2y = Column(INTEGER(11), comment='вʵľ')
    perrank_upsidecaptureratio_2y = Column(INTEGER(11), comment='вʵ')
    absrank_upsidecaptureratio_3y = Column(INTEGER(11), comment='вʵľ')
    perrank_upsidecaptureratio_3y = Column(INTEGER(11), comment='вʵ')
    absrank_upsidecaptureratio_4y = Column(INTEGER(11), comment='вʵľ')
    perrank_upsidecaptureratio_4y = Column(INTEGER(11), comment='вʵ')
    absrank_upsidecaptureratio_5y = Column(INTEGER(11), comment='вʵľ')
    perrank_upsidecaptureratio_5y = Column(INTEGER(11), comment='вʵ')
    absrank_downsidecaptureratio_1y = Column(INTEGER(11), comment='һвʵľ')
    perrank_downsidecaptureratio_1y = Column(INTEGER(11), comment='һвʵ')
    absrank_downsidecaptureratio_2y = Column(INTEGER(11), comment='вʵľ')
    perRank_downsidecaptureratio_2y = Column(INTEGER(11), comment='вʵ')
    absrank_downsidecaptureratio_3y = Column(INTEGER(11), comment='вʵľ')
    perrank_downsidecaptureratio_3y = Column(INTEGER(11), comment='вʵ')
    absrank_downsidecaptureratio_4y = Column(INTEGER(11), comment='вʵľ')
    perrank_downsidecaptureratio_4y = Column(INTEGER(11), comment='вʵ')
    absrank_downsidecaptureratio_5y = Column(INTEGER(11), comment='вʵľ')
    perrank_downsidecaptureratio_5y = Column(INTEGER(11), comment='вʵ')
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundPerformanceStrategyRating(Base, BaseModel):
    __tablename__ = 'fund_performance_strategy_rating'
    __table_args__ = {'comment': ''}

    id = Column(String(64), primary_key=True)
    fund_id = Column(String(64), nullable=False, index=True, comment='id')
    class_id = Column(String(64), nullable=False, index=True, comment='id')
    end_date = Column(String(10), nullable=False, comment='')
    strategy = Column(INTEGER(11), nullable=False, server_default=text("'-1'"), comment='ǲԷ࣬1-Ʊԣ2-۲ԣ3-ڻ4-¼5-Լֵԣ6-ծȯԣ7-ϻ8-ϲԣ-1-')
    substrategy = Column(INTEGER(11), nullable=False, server_default=text("'-1'"), comment='ɣӲԷࣺ   ')
    rating_1y = Column(INTEGER(11), comment='һ')
    ret_rating_1y = Column(String(20), comment='һȼ')
    risk_rating_1y = Column(String(20), comment='һյȼ')
    style_1y = Column(String(20), comment='һ')
    rating_2y = Column(INTEGER(11), comment='')
    ret_rating_2y = Column(String(20), comment='ȼ')
    risk_rating_2y = Column(String(20), comment='յȼ')
    style_2y = Column(String(20), comment='')
    rating_3y = Column(INTEGER(11), comment='')
    ret_rating_3y = Column(String(20), comment='ȼ')
    risk_rating_3y = Column(String(20), comment='յȼ')
    style_3y = Column(String(20), comment='')
    rating_4y = Column(INTEGER(11), comment='')
    ret_rating_4y = Column(String(20), comment='ȼ')
    risk_rating_4y = Column(String(20), comment='յȼ')
    style_4y = Column(String(20), comment='')
    rating_5y = Column(INTEGER(11), comment='')
    ret_rating_5y = Column(String(20), comment='ȼ')
    risk_rating_5y = Column(String(20), comment='յȼ')
    style_5y = Column(String(20), comment='')
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundPortfolio(Base, BaseModel):
    __tablename__ = 'fund_portfolio'
    __table_args__ = {'comment': 'زͳ'}

    id = Column(String(64), primary_key=True, comment='id')
    fund_id = Column(String(64), nullable=False, index=True, comment='id')
    portfolio_date = Column(Date, nullable=False, comment='ͳ')
    sec_code = Column(String(64), nullable=False, index=True, comment='֤ȯ')
    sec_type = Column(INTEGER(11), nullable=False, server_default=text("'1'"), comment='֤ȯͣ1-Ʊ2-3-ծȯ4-Ȩ֤-1-')
    sec_market_value = Column(DECIMAL(22, 6), comment='ֻ֤ȯֵ,<٣Ԫ>')
    net_value_ratio = Column(DECIMAL(22, 6), comment='ռֵ,<:%>')
    holding_num = Column(DECIMAL(22, 6), comment='ֲ,<٣>')
    holding_ratio = Column(DECIMAL(22, 6), comment='ռͨ,<:%> ֶֻƷݣfund_type=2 or 3')
    uni_code = Column(String(64), index=True, comment='Ĵ(base_underlying_information)')
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"), comment='޸ʱ;һδʱCreatTimeֵͬ޸ʱ޸ʱͬ')
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"), comment='ʱ,Ĭϵһδgetdate()ʱ')
    delete_tag = Column(INTEGER(3), server_default=text("'0'"))


class FundPosition(Base, BaseModel):
    __tablename__ = 'fund_position'
    __table_args__ = {'comment': 'ʲ'}

    id = Column(String(64), primary_key=True)
    fund_id = Column(String(64), nullable=False, index=True, comment='id')
    position_date = Column(Date, nullable=False, comment='λͳ')
    sec_type = Column(TINYINT(4), comment='֤ȯͣ1-Ʊ2-3-ծȯ4-Ȩ֤5-ʽ-1-(ȯʹܲƷ)')
    market_valule = Column(DECIMAL(22, 6), comment='ֵ<٣Ԫ>')
    position = Column(DECIMAL(22, 6), comment='λ<٣%>')
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    create_by = Column(String(64), index=True, comment='Id,Ĭϵһδƣ󲻱')
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"), comment='ʱ,Ĭϵһδgetdate()ʱ')
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundQa(Base, BaseModel):
    __tablename__ = 'fund_qa'
    __table_args__ = {'comment': 'ƷQA'}

    id = Column(String(64), primary_key=True)
    qa_type = Column(INTEGER(1), nullable=False, comment='  1 2ش')
    fund_id = Column(String(64), nullable=False, comment='ƷID')
    content = Column(Text, nullable=False, comment='/ش')
    ask_id = Column(String(64), comment='ID')
    status = Column(INTEGER(1), comment='0 :δش  1ѻش')
    verify_status = Column(INTEGER(1), nullable=False, comment='״̬ 0  1ͨ  2δͨ')
    user_head = Column(String(255), comment='ûͷ')
    user_nickname = Column(String(50), comment='ûǳ')
    qa_source = Column(String(50), comment='1Ӫ 2ƽ̨û')
    sort = Column(INTEGER(3), nullable=False, server_default=text("'0'"))
    create_by = Column(String(64), nullable=False, comment='/شID')
    create_time = Column(DateTime, nullable=False, comment='/شʱ')
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundRateMapping(Base, BaseModel):
    __tablename__ = 'fund_rate_mapping'
    __table_args__ = {'comment': ''}

    fund_id = Column(String(64), primary_key=True, comment="id(˽ļţ'HF'ͷ(36Ʊʽ,8λ㣩 HF00000001)")
    initial_unit_value = Column(String(255), comment='λֵ')
    initial_size = Column(DECIMAL(22, 6), comment='ʼģ,<٣>')
    min_investment_share = Column(DECIMAL(22, 6), comment='Ϲ,<٣> ȯʹܲƷΪ<Ԫ>')
    subsequent_investment_share = Column(DECIMAL(22, 6), comment='׷Ӷ,<٣> ȯʹܲƷΪ<Ԫ>')
    subscription_fee = Column(DECIMAL(22, 6), comment='Ϲѣ<%>')
    subscription_fee_note = Column(String(255), comment='ϣ꣩˵')
    redemption_fee = Column(DECIMAL(22, 6), comment='طѣ<%>')
    redemption_fee_note = Column(String(255), comment='طѣ<%>')
    managementfee_deduction_frequency = Column(String(255), comment='Ѽڣ<٣>')
    managementfee_consult = Column(DECIMAL(22, 6), comment='Ͷʹʹѣ<٣%>')
    managementfee_trust = Column(DECIMAL(22, 6), comment='˹ѣ<٣%>')
    managementfee_bank = Column(DECIMAL(22, 6), comment='йܷѣ<٣%>')
    performance_fee = Column(DECIMAL(22, 6), comment='߼Чѣ<%>')
    performance_fee_deduction_method = Column(INTEGER(11), comment='ҵ᷽ʽ:0-δ 1-ݶ 2-ֵ 3-')
    performance_fee_note = Column(Text, comment='Ч˵')
    dividend_rule = Column(Text, comment='ֺ')
    other_fee_note = Column(String(255), comment='˵')
    guard_line = Column(DECIMAL(22, 6), comment='ߣ<٣%>')
    stop_loss_line = Column(DECIMAL(22, 6), comment='ֹߣ<٣%>')
    return_guarantees = Column(DECIMAL(22, 6), comment='ʣ<٣%>')
    expected_return = Column(DECIMAL(22, 6), comment='Ԥ')
    hurdle_rate = Column(DECIMAL(22, 6), comment='ǰʣҵǰʣ<%>')
    leverage = Column(String(10), comment='ʸܸ˱')
    manager_participate_asset = Column(String(255), comment='˲ʲ')
    posterior = Column(DECIMAL(22, 6), comment='Ӻ󼶸ܸ˱')
    intermediate = Column(DECIMAL(22, 6), comment='м伶ܸ˱')
    priority = Column(DECIMAL(22, 6), comment='ȼܸ˱')
    outsourcing_fee = Column(DECIMAL(22, 6), comment='ѣ<%>')
    create_by = Column(String(64))
    create_time = Column(DateTime)
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundRiskStat(Base, BaseModel):
    __tablename__ = 'fund_risk_stats'
    __table_args__ = {'comment': 'ָ'}

    id = Column(String(64), primary_key=True)
    fund_id = Column(String(64), nullable=False, index=True, comment='id')
    end_date = Column(Date, nullable=False, comment='')
    stddev_1y = Column(DECIMAL(22, 6), comment='һ껯')
    stddev_2y = Column(DECIMAL(22, 6), comment='껯')
    stddev_3y = Column(DECIMAL(22, 6), comment='껯')
    stddev_4y = Column(DECIMAL(22, 6), comment='껯')
    stddev_5y = Column(DECIMAL(22, 6), comment='껯')
    stddev_10y = Column(DECIMAL(22, 6), comment='ʮ껯')
    stddev_incep = Column(DECIMAL(22, 6), comment='껯')
    stddev_ytd = Column(DECIMAL(22, 6), comment='껯')
    downsidedev_1y = Column(DECIMAL(22, 6), comment='һз')
    downsidedev_2y = Column(DECIMAL(22, 6), comment='з')
    downsidedev_3y = Column(DECIMAL(22, 6), comment='з')
    downsidedev_4y = Column(DECIMAL(22, 6), comment='з')
    downsidedev_5y = Column(DECIMAL(22, 6), comment='з')
    downsidedev_10y = Column(DECIMAL(22, 6), comment='ʮз')
    downsidedev_incep = Column(DECIMAL(22, 6), comment='з')
    downsidedev_ytd = Column(DECIMAL(22, 6), comment='з')
    alpha_1y = Column(DECIMAL(22, 6), comment='һİ')
    alpha_2y = Column(DECIMAL(22, 6), comment='İ')
    alpha_3y = Column(DECIMAL(22, 6), comment='İ')
    alpha_4y = Column(DECIMAL(22, 6), comment='İ')
    alpha_5y = Column(DECIMAL(22, 6), comment='İ')
    alpha_10y = Column(DECIMAL(22, 6), comment='ʮİ')
    alpha_incep = Column(DECIMAL(22, 6), comment='İ')
    alpha_ytd = Column(DECIMAL(22, 6), comment='İ')
    beta_1y = Column(DECIMAL(22, 6), comment='һı')
    beta_2y = Column(DECIMAL(22, 6), comment='ı')
    beta_3y = Column(DECIMAL(22, 6), comment='ı')
    beta_4y = Column(DECIMAL(22, 6), comment='ı')
    beta_5y = Column(DECIMAL(22, 6), comment='ı')
    beta_10y = Column(DECIMAL(22, 6), comment='ʮı')
    beta_incep = Column(DECIMAL(22, 6), comment='ı')
    beta_ytd = Column(DECIMAL(22, 6), comment='ı')
    r2_1y = Column(DECIMAL(22, 6), comment='һŶ')
    r2_2y = Column(DECIMAL(22, 6), comment='Ŷ')
    r2_3y = Column(DECIMAL(22, 6), comment='Ŷ')
    r2_4y = Column(DECIMAL(22, 6), comment='Ŷ')
    r2_5y = Column(DECIMAL(22, 6), comment='Ŷ')
    r2_10y = Column(DECIMAL(22, 6), comment='ʮŶ')
    r2_incep = Column(DECIMAL(22, 6), comment='Ŷ')
    r2_ytd = Column(DECIMAL(22, 6), comment='Ŷ')
    skewness_1y = Column(DECIMAL(22, 6), comment='һƫ')
    skewness_2y = Column(DECIMAL(22, 6), comment='ƫ')
    skewness_3y = Column(DECIMAL(22, 6), comment='ƫ')
    skewness_4y = Column(DECIMAL(22, 6), comment='ƫ')
    skewness_5y = Column(DECIMAL(22, 6), comment='ƫ')
    skewness_10y = Column(DECIMAL(22, 6), comment='ʮƫ')
    skewness_incep = Column(DECIMAL(22, 6), comment='ƫ')
    skewness_ytd = Column(DECIMAL(22, 6), comment='ƫ')
    kurtosis_1y = Column(DECIMAL(22, 6), comment='һķ')
    kurtosis_2y = Column(DECIMAL(22, 6), comment='ķ')
    kurtosis_3y = Column(DECIMAL(22, 6), comment='ķ')
    kurtosis_4y = Column(DECIMAL(22, 6), comment='ķ')
    kurtosis_5y = Column(DECIMAL(22, 6), comment='ķ')
    kurtosis_10y = Column(DECIMAL(22, 6), comment='ʮķ')
    kurtosis_incep = Column(DECIMAL(22, 6), comment='ķ')
    kurtosis_ytd = Column(DECIMAL(22, 6), comment='ķ')
    worstmonth_1y = Column(DECIMAL(22, 6), comment='һĵµ')
    worstmonth_2y = Column(DECIMAL(22, 6), comment='ĵµ')
    worstmonth_3y = Column(DECIMAL(22, 6), comment='ĵµ')
    worstmonth_4y = Column(DECIMAL(22, 6), comment='ĵµ')
    worstmonth_5y = Column(DECIMAL(22, 6), comment='ĵµ')
    worstmonth_10y = Column(DECIMAL(22, 6), comment='ʮĵµ')
    worstmonth_incep = Column(DECIMAL(22, 6), comment='ĵµ')
    worstmonth_ytd = Column(DECIMAL(22, 6), comment='ĵµ')
    downmonth_percent_1y = Column(DECIMAL(22, 6), comment='һµ·ݱ')
    downmonth_percent_2y = Column(DECIMAL(22, 6), comment='µ·ݱ')
    downmonth_percent_3y = Column(DECIMAL(22, 6), comment='µ·ݱ')
    downmonth_percent_4y = Column(DECIMAL(22, 6), comment='µ·ݱ')
    downmonth_percent_5y = Column(DECIMAL(22, 6), comment='µ·ݱ')
    downmonth_percent_10y = Column(DECIMAL(22, 6), comment='ʮµ·ݱ')
    downmonth_percent_incep = Column(DECIMAL(22, 6), comment='µ·ݱ')
    downmonth_percent_ytd = Column(DECIMAL(22, 6), comment='µ·ݱ')
    battingaverage_1y = Column(DECIMAL(22, 6), comment='һӮָ·ݱ')
    battingaverage_2y = Column(DECIMAL(22, 6), comment='Ӯָ·ݱ')
    battingaverage_3y = Column(DECIMAL(22, 6), comment='Ӯָ·ݱ')
    battingaverage_4y = Column(DECIMAL(22, 6), comment='Ӯָ·ݱ')
    battingaverage_5y = Column(DECIMAL(22, 6), comment='Ӯָ·ݱ')
    battingaverage_10y = Column(DECIMAL(22, 6), comment='Ӯָ·ݱ')
    battingaverage_incep = Column(DECIMAL(22, 6), comment='Ӯָ·ݱ')
    battingaverage_ytd = Column(DECIMAL(22, 6), comment='Ӯָ·ݱ')
    gainloss_ratio_1y = Column(DECIMAL(22, 6), comment='һӯ/')
    gainloss_ratio_2y = Column(DECIMAL(22, 6), comment='ӯ/')
    gainloss_ratio_3y = Column(DECIMAL(22, 6), comment='ӯ/')
    gainloss_ratio_4y = Column(DECIMAL(22, 6), comment='ӯ/')
    gainloss_ratio_5y = Column(DECIMAL(22, 6), comment='µ·')
    gainloss_ratio_10y = Column(DECIMAL(22, 6), comment='ʮµ·')
    gainloss_ratio_incep = Column(DECIMAL(22, 6), comment='µ·')
    gainloss_ratio_ytd = Column(DECIMAL(22, 6), comment='µ·')
    longestdown_months_1y = Column(INTEGER(11), comment='һµ·')
    longestdown_months_2y = Column(INTEGER(11), comment='µ·')
    longestdown_months_3y = Column(INTEGER(11), comment='µ·')
    longestdown_months_4y = Column(INTEGER(11), comment='µ·')
    longestdown_months_5y = Column(INTEGER(11), comment='µ·')
    longestdown_months_10y = Column(INTEGER(11), comment='ʮµ·')
    longestdown_months_incep = Column(INTEGER(11), comment='µ·')
    longestdown_months_ytd = Column(INTEGER(11), comment='µ·')
    maxdrawdown_3m = Column(DECIMAL(22, 6), comment='һس')
    maxdrawdown_ytd = Column(DECIMAL(22, 6))
    maxdrawdown_months_ytd = Column(DECIMAL(22, 6))
    maxdrawdown_peakdate_ytd = Column(DECIMAL(22, 6))
    maxdrawdown_valleydate_ytd = Column(DECIMAL(22, 6))
    maxdrawdown_1y = Column(DECIMAL(22, 6), comment='һس')
    maxdrawdown_months_1y = Column(INTEGER(11), comment='һس·')
    maxdrawdown_peakdate_1y = Column(String(10), comment='һسķֵֵʼ')
    maxdrawdown_valleydate_1y = Column(String(10), comment='һسĹֵֹ')
    maxdrawdown_recoverydate_1y = Column(String(10), comment='һس޸')
    maxdrawdown_recoverymonths_1y = Column(INTEGER(11), comment='һس޸·')
    maxdrawdown_2y = Column(DECIMAL(22, 6), comment='س')
    maxdrawdown_months_2y = Column(INTEGER(11), comment='س·')
    maxdrawdown_peakdate_2y = Column(String(11), comment='سķֵֵʼ')
    maxdrawdown_valleydate_2y = Column(String(11), comment='سĹֵֹ')
    maxdrawdown_recoverydate_2y = Column(INTEGER(11), comment='س޸')
    maxdrawdown_recoverymonths_2y = Column(INTEGER(11), comment='س޸·')
    maxdrawdown_3y = Column(DECIMAL(22, 6), comment='س')
    maxdrawdown_months_3y = Column(INTEGER(11), comment='س·')
    maxdrawdown_peakdate_3y = Column(String(10), comment='سķֵֵʼ')
    maxdrawdown_valleydate_3y = Column(String(10), comment='سĹֵֹ')
    maxdrawdown_recoverydate_3y = Column(String(10), comment='سĹֵֹ')
    maxdrawdown_recoverymonths_3y = Column(INTEGER(11), comment='س޸·')
    maxdrawdown_4y = Column(DECIMAL(22, 6), comment='س')
    maxdrawdown_months_4y = Column(INTEGER(11), comment='س·')
    maxdrawdown_peakdate_4y = Column(String(10), comment='سķֵֵʼ')
    maxdrawdown_valleydate_4y = Column(String(10), comment='سĹֵֹ')
    maxdrawdown_recoverydate_4y = Column(String(10), comment='س޸')
    maxdrawdown_recoverymonths_4y = Column(INTEGER(11), comment='س޸·')
    maxdrawdown_5y = Column(DECIMAL(22, 6), comment='س')
    maxdrawdown_10y = Column(DECIMAL(22, 6), comment='ʮس')
    maxdrawdown_months_5y = Column(INTEGER(11), comment='س·')
    maxdrawdown_peakdate_5y = Column(String(10), comment='سķֵֵʼ')
    maxdrawdown_valleydate_5y = Column(String(10), comment='سĹֵֹ')
    maxdrawdown_recoverydate_5y = Column(String(10), comment='س޸')
    maxdrawdown_recoverymonths_5y = Column(INTEGER(11), comment='س޸·')
    maxdrawdown_months_10y = Column(INTEGER(11), comment='ʮس·')
    maxdrawdown_peakdate_10y = Column(String(10), comment='ʮسķֵֵʼ')
    maxdrawdown_valleydate_10y = Column(String(10), comment='ʮسĹֵֹ')
    maxdrawdown_recoverydate_10y = Column(String(10), comment='ʮس޸')
    maxdrawdown_recoverymonths_10y = Column(INTEGER(11), comment='ʮس޸·')
    maxdrawdown_incep = Column(DECIMAL(22, 6), comment='س')
    maxdrawdown_months_incep = Column(INTEGER(11), comment='س·')
    maxdrawdown_peakdate_incep = Column(String(10), comment='سķֵֵʼ')
    maxdrawdown_valleydate_incep = Column(String(10), comment='سĹֵֹ')
    maxdrawdown_recoverydate_incep = Column(String(10), comment='س޸')
    maxdrawdown_recoverymonths_incep = Column(INTEGER(11), comment='س޸·')
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundRiskadjretStat(Base, BaseModel):
    __tablename__ = 'fund_riskadjret_stats'
    __table_args__ = {'comment': 'յָ'}

    id = Column(String(64), primary_key=True)
    fund_id = Column(String(64), nullable=False, index=True, comment='id')
    end_date = Column(Date, nullable=False, comment='')
    sharperatio_1y = Column(DECIMAL(22, 6), comment='һձ')
    sharperatio_2y = Column(DECIMAL(22, 6), comment='ձ')
    sharperatio_3y = Column(DECIMAL(22, 6), comment='ձ')
    sharperatio_4y = Column(DECIMAL(22, 6), comment='ձ')
    sharperatio_5y = Column(DECIMAL(22, 6), comment='ձ')
    sharperatio_incep = Column(DECIMAL(22, 6), comment='ձ')
    sortinoratio_1y = Column(DECIMAL(22, 6), comment='һŵ')
    sortinoratio_2y = Column(DECIMAL(22, 6), comment='ŵ')
    sortinoratio_3y = Column(DECIMAL(22, 6), comment='ŵ')
    sortinoratio_4y = Column(DECIMAL(22, 6), comment='ŵ')
    sortinoratio_5y = Column(DECIMAL(22, 6), comment='ŵ')
    sortinoratio_incep = Column(DECIMAL(22, 6), comment='ŵ')
    sortinoratio_MAR_1y = Column(DECIMAL(22, 6), comment='һŵ(MAR)')
    sortinoratio_MAR_2y = Column(DECIMAL(22, 6), comment='ŵ(MAR)')
    sortinoratio_MAR_3y = Column(DECIMAL(22, 6), comment='ŵ(MAR)')
    sortinoratio_MAR_4y = Column(DECIMAL(22, 6), comment='ŵ(MAR)')
    sortinoratio_MAR_5y = Column(DECIMAL(22, 6), comment='ŵ(MAR)')
    sortinoratio_MAR_incep = Column(DECIMAL(22, 6), comment='ŵ(MAR)')
    treynorratio_1y = Column(DECIMAL(22, 6), comment='һŵ')
    treynorratio_2y = Column(DECIMAL(22, 6), comment='ŵ')
    treynorratio_3y = Column(DECIMAL(22, 6), comment='ŵ')
    treynorratio_4y = Column(DECIMAL(22, 6), comment='ŵ')
    treynorratio_5y = Column(DECIMAL(22, 6), comment='ŵ')
    treynorratio_incep = Column(DECIMAL(22, 6), comment='ŵ')
    jensen_1y = Column(DECIMAL(22, 6), comment='һղɭָ')
    jensen_2y = Column(DECIMAL(22, 6), comment='ղɭָ')
    jensen_3y = Column(DECIMAL(22, 6), comment='ղɭָ')
    jensen_4y = Column(DECIMAL(22, 6), comment='ղɭָ')
    jensen_5y = Column(DECIMAL(22, 6), comment='ղɭָ')
    jensen_incep = Column(DECIMAL(22, 6), comment='ղɭָ')
    calmarratio_1y = Column(DECIMAL(22, 6), comment='һĿ')
    calmarratio_2y = Column(DECIMAL(22, 6), comment='Ŀ')
    calmarratio_3y = Column(DECIMAL(22, 6), comment='Ŀ')
    calmarratio_4y = Column(DECIMAL(22, 6), comment='Ŀ')
    calmarratio_5y = Column(DECIMAL(22, 6), comment='Ŀ')
    calmarratio_incep = Column(DECIMAL(22, 6), comment='Ŀ')
    omegaratio_1y = Column(DECIMAL(22, 6), comment='һŷѱ')
    omegaratio_2y = Column(DECIMAL(22, 6), comment='ŷѱ')
    omegaratio_3y = Column(DECIMAL(22, 6), comment='ŷѱ')
    omegaratio_4y = Column(DECIMAL(22, 6), comment='ŷѱ')
    omegaratio_5y = Column(DECIMAL(22, 6), comment='ŷѱ')
    omegaratio_incep = Column(DECIMAL(22, 6), comment='ŷѱ')
    kapparatio_1y = Column(DECIMAL(22, 6), comment='һĿ')
    kapparatio_2y = Column(DECIMAL(22, 6), comment='Ŀ')
    kapparatio_3y = Column(DECIMAL(22, 6), comment='Ŀ')
    kapparatio_4y = Column(DECIMAL(22, 6), comment='Ŀ')
    kapparatio_5y = Column(DECIMAL(22, 6), comment='Ŀ')
    kapparatio_incep = Column(DECIMAL(22, 6), comment='Ŀ')
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundStatu(Base, BaseModel):
    __tablename__ = 'fund_status'
    __table_args__ = {'comment': '״̬'}

    id = Column(String(64), primary_key=True, comment='Id')
    fund_status = Column(String(10), comment='״̬1-ļС2-С3-С4-ǰ㡢5-㡢6-ʧܡ7-ˡ-1-')
    status_start_date = Column(Date, comment='ļʼʱ')
    status_end_date = Column(Date, comment='ļʱ')
    liquidate_date = Column(Date, comment='')
    create_by = Column(String(64))
    create_time = Column(DateTime)
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(INTEGER(3), nullable=False)


class FundStrategyRanknum(Base, BaseModel):
    __tablename__ = 'fund_strategy_ranknum'
    __table_args__ = {'comment': ''}

    id = Column(String(64), primary_key=True)
    strategy = Column(INTEGER(11), comment='')
    end_date = Column(String(10), nullable=False, comment='')
    rankfunds_1m = Column(INTEGER(11), comment='Ŀһ£')
    rankfunds_3m = Column(INTEGER(11))
    rankfunds_6m = Column(INTEGER(11))
    rankfunds_1y = Column(INTEGER(11))
    rankfunds_2y = Column(INTEGER(11))
    rankfunds_3y = Column(INTEGER(11))
    rankfunds_4y = Column(INTEGER(11))
    rankfunds_5y = Column(INTEGER(11))
    rankfunds_ytd = Column(INTEGER(11))
    ratingnum_1y = Column(INTEGER(11))
    ratingnum_2y = Column(INTEGER(11))
    ratingnum_3y = Column(INTEGER(11))
    ratingnum_4y = Column(INTEGER(11))
    ratingnum_5y = Column(INTEGER(11))
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class FundStyleStat(Base, BaseModel):
    __tablename__ = 'fund_style_stats'
    __table_args__ = {'comment': 'ָ'}

    id = Column(String(64), primary_key=True)
    fund_id = Column(String(64), nullable=False, index=True, comment='id')
    end_date = Column(String(10), nullable=False, comment='')
    upsidecapture_ret_1y = Column(DECIMAL(22, 6), comment='һв')
    upsidecapture_ret_2y = Column(DECIMAL(22, 6), comment='в')
    upsidecapture_ret_3y = Column(DECIMAL(22, 6), comment='в')
    upsidecapture_ret_4y = Column(DECIMAL(22, 6), comment='в')
    upsidecapture_ret_5y = Column(DECIMAL(22, 6), comment='в')
    upsidecapture_ret_incep = Column(DECIMAL(22, 6), comment='в')
    downsidecapture_ret_1y = Column(DECIMAL(22, 6), comment='һв')
    downsidecapture_ret_2y = Column(DECIMAL(22, 6), comment='в')
    downsidecapture_ret_3y = Column(DECIMAL(22, 6), comment='в')
    downsidecapture_ret_4y = Column(DECIMAL(22, 6), comment='в')
    downsidecapture_ret_5y = Column(DECIMAL(22, 6), comment='в')
    downsidecapture_ret_incep = Column(DECIMAL(22, 6), comment='в')
    upsidecapture_ratio_1y = Column(DECIMAL(22, 6), comment='һв')
    upsidecapture_ratio_2y = Column(DECIMAL(22, 6), comment='в')
    upsidecapture_ratio_3y = Column(DECIMAL(22, 6), comment='в')
    upsidecapture_ratio_4y = Column(DECIMAL(22, 6), comment='в')
    upsidecapture_ratio_5y = Column(DECIMAL(22, 6), comment='в')
    upsidecapture_ratio_incep = Column(DECIMAL(22, 6), comment='в')
    downsidecapture_ratio_1y = Column(DECIMAL(22, 6), comment='һв')
    downsidecapture_ratio_2y = Column(DECIMAL(22, 6), comment='в')
    downsidecapture_ratio_3y = Column(DECIMAL(22, 6), comment='в')
    downsidecapture_ratio_4y = Column(DECIMAL(22, 6), comment='в')
    downsidecapture_ratio_5y = Column(DECIMAL(22, 6), comment='в')
    downsidecapture_ratio_incep = Column(DECIMAL(22, 6), comment='в')
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class IndexesProfile(Base, BaseModel):
    __tablename__ = 'indexes_profile'
    __table_args__ = {'comment': 'ָϢ'}

    id = Column(String(64), primary_key=True, comment='ָId')
    index_id = Column(String(10), comment='ָID')
    index_type_id = Column(INTEGER(11), comment='ָͣ1-Գָ2-ָ3-ļָ4-۹Ʊָ5-ȫƱָ6-ָ7-޷ʡ-1-')
    index_code = Column(String(60), comment='ָ')
    index_name = Column(String(255), comment='ָȫ')
    index_short_name = Column(String(80), comment='ָļ')
    index_area_flag = Column(INTEGER(11), comment='1-й2-ȫ')
    index_family_id = Column(String(64), comment='ָṩID')
    pricing_frequency = Column(INTEGER(11), comment='ָڣ1-նȡ2-ܡ3-¶ȡ4-ȡ5-ȡ6-')
    inception_date = Column(Date, comment='ָڣָʼ')
    index_initial_value = Column(DECIMAL(22, 6), comment='ָ')
    base_currency = Column(INTEGER(11), comment='ָʹõĻң1-ң2-۱ң3-Ԫ4-¼Ԫ-1-')
    calculation_method = Column(String(80), comment='ָʹõļ㷽')
    weighting_scheme = Column(String(80), comment='ɷݻȨصķ')
    selection_scheme = Column(String(80), comment='ɷݻɸѡ')
    create_by = Column(String(64))
    create_time = Column(DateTime)
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class PersonnelCompanyMapping(Base, BaseModel):
    __tablename__ = 'personnel_company_mapping'
    __table_args__ = {'comment': 'Ա˾ƥ'}

    id = Column(String(62), primary_key=True)
    personnel_id = Column(String(64), nullable=False)
    company_id = Column(String(64), nullable=False, comment='ְ˾id')
    company_order = Column(INTEGER(11), comment='˾')
    personnel_order = Column(INTEGER(11), comment='')
    address = Column(String(80), comment='ϵַ')
    is_keyfigure = Column(INTEGER(11), comment='ǷΪ־1-ǣ0--1-')
    is_include = Column(INTEGER(11), comment='ǷŶϢ')
    is_visible = Column(INTEGER(11), comment='Ƿǰ̨ɼ1-ɼ0-ֹʾ')
    is_leave = Column(INTEGER(11), comment='Ƿְ1-ǣ0-')
    is_default = Column(INTEGER(11), comment='Ĭְ˾1-ǣ0-')
    is_senior = Column(TINYINT(4), comment='Ƿ߹ܣ1-ǣ0-')
    is_represent = Column(TINYINT(4), comment='Ƿˣ1-ǣ0-')
    start_date = Column(Date, comment='ְʼ')
    end_date = Column(Date, comment='ְ')
    create_by = Column(String(64))
    create_time = Column(DateTime)
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class PersonnelCompanyPositionMapping(Base, BaseModel):
    __tablename__ = 'personnel_company_position_mapping'
    __table_args__ = {'comment': 'Աڹ˾ְϢ'}

    id = Column(String(64), primary_key=True)
    personnel_id = Column(String(64), nullable=False, comment='id')
    company_id = Column(String(64), nullable=False, comment='˾id')
    personnel_type = Column(INTEGER(11), nullable=False, comment='Ա:1- 2-Ͷ 3-ϵ 4-г 5-Ϲ 6-˾߹ 7-˾ -1-')
    position = Column(String(40), nullable=False, comment='ǰְλ')
    department = Column(String(50), comment='ְ')
    is_default = Column(INTEGER(11), comment='ǷĬְλϢ1-ǣ0-')
    start_date = Column(Date, comment='ְʼ')
    end_date = Column(Date, comment='ְ')
    position_order = Column(INTEGER(11), comment='ְλ')
    create_by = Column(String(64))
    create_time = Column(DateTime)
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class PersonnelInfo(Base, BaseModel):
    __tablename__ = 'personnel_info'
    __table_args__ = {'comment': 'Ϣ'}

    id = Column(String(64), primary_key=True, comment='Աid')
    personnel_name = Column(String(40), nullable=False, comment='')
    avatar = Column(String(255), comment='Աͷ')
    personnel_type = Column(INTEGER(11), server_default=text("'-1'"), comment='Ա1-2-оԱ3-ϵˡ-1-')
    profession_background = Column(TINYINT(4), server_default=text("'-1'"), comment='ְҵ1-ọ̇2-ļ3-ڻ4-ý壬5-⣬6-䣬7-ڻ8-ʵҵ9-ѧߡ10-С11-С12-ա13-˽ļ-1-')
    key_figure = Column(INTEGER(11), server_default=text("'-1'"), comment='ǷΪ־1-ǣ0--1-')
    company_id = Column(String(64), index=True, comment='ְ˾id')
    position = Column(String(64), comment='ǰְλ')
    career_start_year = Column(String(4), comment='ҵʼ')
    investment_experience = Column(INTEGER(11), nullable=False, server_default=text("'-1'"), comment='ҵޣ<٣>,-1:ҵ޲')
    sex = Column(INTEGER(11), comment='Ա1-У2-Ů-1-')
    graduateschool = Column(String(100), server_default=text("''"), comment='ҵԺУ')
    education = Column(INTEGER(11), server_default=text("'0'"), comment='ѧ1-Сѧ2-ѧ3-ר4-ƣ5-˶ʿ6-ʿ7-ʿ-1-')
    major = Column(String(40), server_default=text("''"), comment='רҵ')
    profile = Column(Text, comment='')
    porder = Column(INTEGER(11), server_default=text("'0'"), comment='')
    ifinclude = Column(INTEGER(11), server_default=text("'0'"), comment='ǷŶϢ')
    isvisible = Column(INTEGER(3), server_default=text("'1'"), comment='Ƿǰ̨ɼ1-ɼ0-ֹʾ')
    is_qualify = Column(TINYINT(4), comment='Ƿдҵʸ:1-ǣ2-')
    topic = Column(Text, comment='')
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"), comment='ʱ')
    update_time = Column(TIMESTAMP, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"), comment='޸ʱ;һδʱCreatTimeֵͬ޸ʱ޸ʱͬ')
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"), comment='¼Чԣ1-Ч0-Ч')


class QrQualitativeReport(Base, BaseModel):
    __tablename__ = 'qr_qualitative_report'
    __table_args__ = {'comment': '˾ԱϢ'}

    id = Column(String(64), primary_key=True, comment='ԱID')
    company_id = Column(String(64), comment='˾id')
    organization_name = Column(String(80), nullable=False, comment='˾')
    report_name = Column(String(180), nullable=False, comment='')
    report_date = Column(Date, comment='')
    linkman = Column(String(50), comment='ϵ')
    linkman_position = Column(String(30), comment='ϵְλ')
    linkman_mobile = Column(String(20), comment='ϵ˵绰')
    linkman_email = Column(String(50), comment='ϵ')
    visiting_personnel = Column(String(50), comment='߷Ա')
    visit_date = Column(Date, comment='߷ʱ')
    visit_way = Column(INTEGER(11), comment='߷÷ʽ1-绰 2-ֳ߷')
    report_source = Column(TINYINT(4), comment='Դ1- 2-ϴʦ')
    source_id = Column(INTEGER(11), comment='ԴID,ϴʦûģID. 0=ģ')
    report_status = Column(TINYINT(4), comment='״̬0-ݸ 1-')
    is_admin = Column(TINYINT(4), comment='ǷԱд 0- 1-\t')
    completion_rate = Column(DECIMAL(22, 6), comment='ɱ')
    create_by = Column(String(64))
    create_time = Column(DateTime)
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class RzIndex(Base, BaseModel):
    __tablename__ = 'rz_index'
    __table_args__ = {'comment': 'ָ'}

    id = Column(String(64), primary_key=True)
    index_id = Column(String(64), nullable=False, index=True, comment='ָIDindex_profileindex_id')
    index_code = Column(String(64), nullable=False, index=True, comment='ָԴindexes_profile')
    end_date = Column(Date, nullable=False, comment='ָֹ·')
    index_value = Column(DECIMAL(22, 0), nullable=False, comment='ָ')
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class StockIndustryType(Base, BaseModel):
    __tablename__ = 'stock_industry_type'
    __table_args__ = {'comment': 'Ʊҵ'}

    id = Column(String(64), primary_key=True)
    stock_industry_id = Column(INTEGER(11), nullable=False, server_default=text("'-1'"), comment='Ʊҵࣨҵࣩ:1-ũ桢2-ɾ3-4-ɫ5-ɫ6-ġ7-е豸8-Ԫ9-豸10-Ϣ豸11-õ12-ʳƷϡ13-֯װ14-Ṥ졢15-ҽҩ16-ҵ17-ͨ䡢18-ز19-ڷ20-ҵóס21-Ρ22-Ϣ23-ۺϡ-1-')
    stock_industry_type = Column(String(64), nullable=False, comment='Ʊҵ')
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"), comment='ʱ,Ĭϵһδgetdate()ʱ')
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"), comment='޸ʱ;һδʱCreatTimeֵͬ޸ʱ޸ʱͬ')
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class StockInfo(Base, BaseModel):
    __tablename__ = 'stock_info'
    __table_args__ = {'comment': 'ƱϢ'}

    id = Column(String(64), primary_key=True)
    stock_code = Column(String(64), nullable=False, index=True, comment='Ʊ')
    stock_type = Column(String(3), nullable=False, comment='Ʊ')
    stock_name = Column(String(64), nullable=False, comment='Ʊ')
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class UserComposeFundCount(Base, BaseModel):
    __tablename__ = 'user_compose_fund_count'
    __table_args__ = {'comment': 'ûϻ'}

    id = Column(String(64), primary_key=True)
    user_id = Column(String(255), nullable=False)
    fund_id = Column(String(255), nullable=False)
    profit_ratio = Column(String(255))
    profit_ratio_total = Column(DECIMAL(10, 0))
    fund_index = Column(DECIMAL(22, 6))
    create_time = Column(DateTime)
    create_by = Column(String(64))
    update_by = Column(String(64))
    update_time = Column(DateTime)
    delete_tag = Column(INTEGER(3), nullable=False)


class UserHoldFundInfo(Base, BaseModel):
    __tablename__ = 'user_hold_fund_info'
    __table_args__ = {'comment': 'ûֲϢ'}

    id = Column(String(64), primary_key=True, comment='Ψһ')
    user_id = Column(String(64), nullable=False, comment='ûID')
    p_fund_id = Column(String(64), comment='ϻID')
    fund_id = Column(String(64), nullable=False, comment='ID')
    buy_fee_ratio = Column(DECIMAL(22, 6), comment='깺')
    confirm_share = Column(DECIMAL(22, 6), comment='ȷϷݶ')
    confirm_share_date = Column(DateTime, comment='ȷϷݶ')
    confirm_amount = Column(INTEGER(11), comment='ȷϽλ֣')
    fund_nav_id = Column(String(64), comment='ȷϵλֵ')
    fund_nav = Column(DECIMAL(22, 6), comment='ȷϵλֵ')
    init_weight = Column(DECIMAL(22, 6), comment='ʼȨ')
    cost_amount = Column(INTEGER(11), comment='ɱ(λ)')
    market_value = Column(INTEGER(11), comment='ֵλ֣')
    profit_loss = Column(INTEGER(11), comment='ӯλ֣')
    match_ratio = Column(DECIMAL(22, 6), comment='')
    create_time = Column(DateTime)
    create_by = Column(String(64))
    update_time = Column(DateTime)
    update_by = Column(String(64))
    delete_tag = Column(INTEGER(3), nullable=False)


class UserHoldFundInfoHistory(Base, BaseModel):
    __tablename__ = 'user_hold_fund_info_history'
    __table_args__ = {'comment': 'ûʷֱֲ䶯'}

    id = Column(String(64), primary_key=True, comment='Ψһ')
    user_id = Column(String(64), nullable=False, comment='ûID')
    p_fund_id = Column(String(64), comment='ϻID')
    fund_id = Column(String(64), nullable=False, comment='ID')
    buy_fee_ratio = Column(DECIMAL(22, 6), comment='깺')
    confirm_share = Column(DECIMAL(22, 6), comment='ȷϷݶ')
    confirm_share_date = Column(DateTime, comment='ȷϷݶ')
    confirm_amount = Column(INTEGER(11), comment='ȷϽλ֣')
    fund_nav_id = Column(String(64), comment='ȷϵλֵ')
    fund_nav = Column(DECIMAL(22, 6), comment='ȷϵλֵ')
    init_weight = Column(DECIMAL(22, 6), comment='ʼȨ')
    cost_amount = Column(INTEGER(11), comment='ɱ(λ)')
    market_value = Column(INTEGER(11), comment='ֵλ֣')
    profit_loss = Column(INTEGER(11), comment='ӯλ֣')
    match_ratio = Column(DECIMAL(22, 6), comment='')
    ratio_transfer = Column(DECIMAL(22, 6), comment='ϴε')
    create_time = Column(DateTime)
    create_by = Column(String(64))
    update_time = Column(DateTime)
    update_by = Column(String(64))
    delete_tag = Column(INTEGER(3), nullable=False)


class UserSingleFundCount(Base, BaseModel):
    __tablename__ = 'user_single_fund_count'
    __table_args__ = {'comment': 'ûֻͳ'}

    id = Column(String(64), primary_key=True)
    user_id = Column(String(64), nullable=False, comment='ûID')
    fund_id = Column(String(64), nullable=False, comment='ID')
    count_date = Column(Date, nullable=False, comment='ͳ')
    profit_radio = Column(DECIMAL(22, 6), comment='')
    retracement_radio = Column(DECIMAL(22, 6), comment='س')
    create_time = Column(DateTime)
    create_by = Column(String(64))
    update_time = Column(DateTime)
    update_by = Column(String(64))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))
