# coding: utf-8
from sqlalchemy import Column, DECIMAL, Date, DateTime, ForeignKeyConstraint, Index, LargeBinary, String, TIMESTAMP, Table, Text, text
from sqlalchemy.dialects.mysql import BIGINT, INTEGER, MEDIUMTEXT, SMALLINT, VARCHAR
from sqlalchemy.orm import relationship
from sqlalchemy.ext.declarative import declarative_base
from app.model.base import Base, BaseModel


class Account(Base, BaseModel):
    __tablename__ = 'account'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ac_pay_pwd = Column(String(64), comment='֧')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class AccountAmount(Base, BaseModel):
    __tablename__ = 'account_amount'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    aa_balance = Column(BIGINT(12), comment='˻')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class AccountAmountChangerecord(Base, BaseModel):
    __tablename__ = 'account_amount_changerecord'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    aad_type = Column(String(3), comment='䶯')
    aad_balance_before = Column(BIGINT(12), comment='䶯ǰ˻')
    aad_balance_after = Column(BIGINT(12), comment='䶯˻')
    aad_balance = Column(BIGINT(12), comment='䶯')
    aad_reason = Column(String(512), comment='䶯ԭ')
    aad_refid = Column(String(64), comment='¼ID')
    aad_ext = Column(String(64), comment='չֶ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class AccountBill(Base, BaseModel):
    __tablename__ = 'account_bill'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ab_price = Column(BIGINT(12), comment='ԭ')
    ab_score_deduct = Column(BIGINT(12), comment='ֵֿ')
    ab_realpay = Column(BIGINT(12), comment='ʵ')
    ab_type = Column(String(3), comment='')
    ab_refid = Column(String(64), comment='¼ID')
    ab_desc = Column(String(256), comment='')
    ab_limitation = Column(String(3), comment='ʱЧ')
    ab_limitation_starttime = Column(DateTime, comment='ʱЧʼʱ')
    ab_limitation_endtime = Column(DateTime, comment='ʱЧʱ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class AccountScore(Base, BaseModel):
    __tablename__ = 'account_score'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    as_total_score = Column(BIGINT(10), comment='ܻ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class AccountScoreChangerecord(Base, BaseModel):
    __tablename__ = 'account_score_changerecord'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    asc_type = Column(String(3), comment='䶯')
    asc_score_before = Column(BIGINT(10), comment='䶯ǰܻ')
    asc_score_after = Column(BIGINT(10), comment='䶯ܻ')
    asc_score = Column(BIGINT(10), comment='䶯')
    asd_reason = Column(String(512), comment='䶯ԭ')
    asc_refid = Column(String(64), comment='¼ID')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class Activity(Base, BaseModel):
    __tablename__ = 'activity'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    at_img = Column(String(256), comment='ͼ')
    at_name = Column(String(64), comment='')
    at_type = Column(String(3), comment='')
    at_starttime = Column(DateTime, comment='ʼ')
    at_endtime = Column(DateTime, comment='')
    at_desc = Column(String(1024), comment='')
    at_detail_imgs = Column(Text, comment='ͼƬ')
    at_city = Column(String(128), comment='')
    at_adress = Column(String(1024), comment='ַ')
    at_begintime = Column(DateTime, comment='ʼʱ')
    at_finishtime = Column(DateTime, comment='ʱ')
    at_fa_isconfirm = Column(String(3), comment='ʦǷȷ 0 1')
    org_team = Column(String(512), comment='ܹ֯')
    org_id = Column(String(64), comment='Id')
    ac_auditor = Column(String(512), comment='ǩ')
    at_share_desc = Column(String(512), comment='İ')
    at_tem_type = Column(String(3), comment='ģ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    at_share_logo = Column(String(256), comment='logo')
    at_product = Column(String(64), comment='Ʒ')
    at_genre = Column(String(32), comment='')
    at_detail_status = Column(INTEGER(3), server_default=text("'0'"), comment='')
    at_detail_rich = Column(Text)
    qrCode = Column(String(256), comment='ά')
    codeInfo = Column(String(64), comment='ά')
    page_url = Column(String(250), comment='ҳurl')
    bm_type = Column(INTEGER(1), comment='1  2  3 Ϻ')
    task_notice = Column(INTEGER(3), nullable=False, server_default=text("'1'"), comment='1:֪ͨ 2:֪ͨ')


class ActivityBaoming(Base, BaseModel):
    __tablename__ = 'activity_baoming'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ab_actid = Column(String(64), comment='ID')
    user_name = Column(String(32), comment='')
    user_phone = Column(String(16), comment='ֻ')
    user_danwei = Column(String(32), comment='λ')
    user_zhiwei = Column(String(32), comment='ְλ')
    user_source = Column(String(32), comment='Դ')
    ab_inviter = Column(String(64), comment='')
    ab_status = Column(String(3), comment='״̬')
    ab_customer_status = Column(String(3), comment='ͻ״̬0ͻ 1Ǳͻ 2ɽͻ')
    ab_member_id = Column(String(64), comment='Ա')
    ab_confirm_status = Column(String(3), comment='ȷ״̬')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    ab_fission_userid = Column(String(64), comment='ѱ')
    ab_fission_path = Column(Text, comment='ѱ·')
    task_pro_send = Column(String(255), comment='֪ͨ')
    org_id = Column(String(64))
    status = Column(INTEGER(11), comment='״̬')
    is_online = Column(INTEGER(11), comment='뷽ʽ')
    ext_data = Column(String(255), comment='չ')


class ActivityCustomerFollow(Base, BaseModel):
    __tablename__ = 'activity_customer_follow'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    acf_actid = Column(String(64), comment='ID')
    acf_baoming_id = Column(String(64), comment='¼ID')
    acf_customer_status = Column(String(3), comment='ͻ״̬')
    acf_beizhu = Column(String(256), comment='ͻע')
    acf_member_id = Column(String(64), comment='Ա')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class AdditionalInfo(Base, BaseModel):
    __tablename__ = 'additional_info'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ai_target_id = Column(String(64), comment='ĿId')
    ai_target_category = Column(INTEGER(1), comment='Ŀ')
    ai_source_category = Column(INTEGER(1), comment='Դ')
    ai_source_id = Column(String(1024), comment='ԴId')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class AdsPosition(Base, BaseModel):
    __tablename__ = 'ads_position'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    ap_type = Column(INTEGER(3), comment='')
    ap_imgurl = Column(String(256), comment='ͼƬַ')
    ap_link = Column(String(1024), comment='ӵַ')
    ap_isshow = Column(INTEGER(3), comment='Ƿչʾ')
    create_time = Column(DateTime, comment='ʱ')
    rel_content = Column(String(200), comment='')
    rel_type = Column(INTEGER(1), comment='')
    rel_id = Column(String(64), comment='id')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    sort_priority = Column(INTEGER(11), server_default=text("'0'"), comment='')


class AiScanResult(Base, BaseModel):
    __tablename__ = 'ai_scan_result'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    asr_taskid = Column(String(64), comment='ID')
    asr_faid = Column(String(64), comment='ʦID')
    asr_userid = Column(String(64), comment='ûID')
    asr_interest = Column(INTEGER(3), comment='Ȥֵ')
    sc_lastbrowsetime = Column(DateTime, comment='ʱ')
    sc_pro_browsenum = Column(BIGINT(11), comment='Ʒ')
    sc_article_browsenum = Column(BIGINT(11), comment='')
    sc_mp_browsenum = Column(BIGINT(11), comment='Ƭ')
    sc_company_browsenum = Column(BIGINT(11), comment='˾')
    sc_dayreport_browsenum = Column(BIGINT(11), comment='ձ')
    sc_total_browsenum = Column(BIGINT(11), comment='ϼ')
    sc_pro_timelong = Column(BIGINT(11), comment='Ʒʱ')
    sc_article_timelong = Column(BIGINT(11), comment='ʱ')
    sc_mp_timelong = Column(BIGINT(11), comment='Ƭʱ')
    sc_company_timelong = Column(BIGINT(11), comment='˾ʱ')
    sc_dayreport_timelong = Column(BIGINT(11), comment='ձʱ')
    sc_total_timelong = Column(BIGINT(11), comment='ʱϼ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class AiScanTask(Base, BaseModel):
    __tablename__ = 'ai_scan_task'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ast_taskid = Column(String(64), comment='ID')
    ast_cycle = Column(String(3), comment='')
    ast_timelong = Column(BIGINT(8), comment='ʱ')
    ast_browsenum = Column(BIGINT(8), comment='')
    ast_obj = Column(String(128), comment='ɨ')
    ast_status = Column(String(16), comment='ɨ״̬')
    ast_totalnum = Column(INTEGER(11), comment='ɨ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class AppMessage(Base, BaseModel):
    __tablename__ = 'app_message'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    type = Column(INTEGER(5), comment='')
    sub_type = Column(INTEGER(5), comment='')
    content = Column(String(1024), comment='')
    fa_id = Column(String(64), comment='ʦID')
    read_status = Column(INTEGER(3), comment='Ķ״̬')
    remind_userid = Column(String(64))
    ref_id = Column(String(64), comment='ID')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(String(3), comment='ɾʶ')


class AppVersion(Base, BaseModel):
    __tablename__ = 'app_version'
    __table_args__ = {'comment': 'App汾Ϣ'}

    id = Column(String(64), primary_key=True)
    proname = Column(String(64), nullable=False, comment='Ʒ')
    pt = Column(String(16), nullable=False, comment='ƽ̨ ios | android')
    release_channel = Column(String(64), comment='')
    version_num = Column(String(64), nullable=False, comment='汾')
    build_num = Column(String(16), nullable=False, comment='汾')
    down_mode = Column(INTEGER(3), comment='طʽ 0: Ӧг 1:')
    down_url = Column(String(512), comment='صַ')
    up_desc = Column(String(1024), comment='˵')
    alert_flag = Column(String(64), comment='ʶ')
    min_flag = Column(String(64), comment='Ϳð汾')
    release_status = Column(INTEGER(3), comment='״̬ 0:δ 1:ѷ')
    release_time = Column(DateTime, comment='ʱ')
    create_time = Column(DateTime)
    create_by = Column(String(64))
    update_time = Column(DateTime)
    update_by = Column(String(64))
    delete_tag = Column(INTEGER(3), nullable=False)


class ApplicationTemplateQuestion(Base, BaseModel):
    __tablename__ = 'application_template_question'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    q_type = Column(String(3), comment='Ŀ')
    q_title = Column(String(512), comment='')
    q_option = Column(String(1024), comment='ѡ')
    q_required = Column(INTEGER(3), comment='Ƿ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    q_choice = Column(INTEGER(3), comment='Ƿʦ 0: ʦд 1: ʦд 2: Ҫд')


class ArLabel(Base, BaseModel):
    __tablename__ = 'ar_labels'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ut_tem = Column(String(64), comment='ǩ')
    org_id = Column(String(64), comment='')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class Article(Base, BaseModel):
    __tablename__ = 'article'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ar_title = Column(String(128), comment='')
    ar_abstract = Column(String(1024), comment='ժҪ')
    ar_review_headurl = Column(String(256), comment='ͷ')
    ar_review = Column(Text, comment='')
    ar_thumbnail = Column(String(256), comment='ͼ')
    ar_backgroundimg = Column(String(256), comment='ͼ')
    ar_showtype = Column(String(3), comment='չʾͼ')
    ar_type = Column(String(64), comment='')
    ar_subject = Column(String(64), comment='')
    ar_column = Column(String(64), comment='ר')
    ar_label = Column(String(128), comment='ǩ')
    ar_author = Column(String(32), comment='')
    ar_source = Column(String(32), comment='Դ')
    ar_crawler_source = Column(String(32), comment='ץȡԴ')
    ar_crawler_url = Column(String(3000), comment='ץȡԴUrl')
    ar_content = Column(MEDIUMTEXT, comment='')
    ar_releasetime = Column(DateTime, comment='ʱ')
    ar_hot = Column(String(3), server_default=text("'0'"), comment='Ƽʶ')
    ar_status = Column(INTEGER(3), comment='״̬')
    ar_praise_basenum = Column(BIGINT(20), comment='')
    ar_praise_actualnum = Column(BIGINT(20), comment='ʵ')
    ar_collect_basenum = Column(BIGINT(20), comment='ղ')
    ar_collect_actualnum = Column(BIGINT(20), comment='ղʵ')
    ar_read_basenum = Column(BIGINT(9), comment='Ķ')
    ar_read_actualnum = Column(BIGINT(9), comment='ʵĶ')
    ar_settop_time = Column(DateTime, comment='öʱ')
    ar_settop_expiry_date = Column(DateTime, comment='öЧ')
    ar_settop_state = Column(String(3), comment='Ƿö')
    ar_source_type = Column(String(3), comment='Դ 0̨ 1ϵͳץȡ 2appû΢ץȡ')
    ar_fee_type = Column(String(3), comment='շ 0 1շ')
    ar_vip_price = Column(BIGINT(12), comment='vipԱ۸')
    ar_common_price = Column(BIGINT(12), comment='ͨԱ۸')
    ar_crawlarticletime = Column(DateTime, comment='ץȡµԭʱ')
    ar_audio = Column(VARCHAR(256), comment='Ƶ')
    ar_audio_length = Column(INTEGER(11), comment='Ƶʱ')
    ar_review_by = Column(String(128), comment='')
    ar_review_time = Column(DateTime, comment='ʱ')
    ar_submit_by = Column(String(128), comment='ύ')
    ar_push_labels = Column(Text, comment='ͱǩ')
    ar_pt = Column(String(128), comment='ƽ̨')
    ar_partne_planid = Column(String(64), comment='ID')
    ar_plan_type = Column(String(3))
    ar_tag = Column(String(2048), comment='±ǩ')
    share_msg = Column(String(2048), comment='Ϣ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    ar_solt_by = Column(String(64), comment='¼')
    ar_solt_time = Column(DateTime, comment='¼ʱ')
    ar_soltout_time = Column(DateTime, comment='Ԥ¼ʱ')
    ar_product = Column(String(64), comment='Ʒ')


class ArticlePushLabel(Base, BaseModel):
    __tablename__ = 'article_push_label'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    label_name = Column(String(128), comment='')
    label_sort = Column(INTEGER(5), comment='')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class Auth(Base, BaseModel):
    __tablename__ = 'auth'
    __table_args__ = {'comment': 'Ȩ޶'}

    id = Column(String(64), primary_key=True)
    ur_code = Column(String(16), nullable=False, unique=True, comment='ȨΨһ')
    ur_coll = Column(String(64), nullable=False, comment='ɫǼ,Ȩ')
    ur_desc = Column(String(255), comment='Ȩ')
    ur_name = Column(String(128), nullable=False, comment='ûɫ̨չʾã')
    ur_action = Column(String(64), nullable=False, comment='㵱ǰȨҪִеĶ')
    ur_action_desc = Column(String(128), nullable=False, comment='')
    ur_type = Column(INTEGER(3), nullable=False, comment='ɫ 0:ܽɫ 1:ݽɫ')
    create_by = Column(String(64), nullable=False)
    create_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    update_by = Column(String(64))
    update_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(1), nullable=False, server_default=text("'0'"))
    priority = Column(INTEGER(11), nullable=False, server_default=text("'0'"), comment='ȼ')


class AuthBusinessRel(Base, BaseModel):
    __tablename__ = 'auth_business_rel'
    __table_args__ = {'comment': 'Ȩҵϵ'}

    id = Column(String(64), primary_key=True)
    ua_type = Column(String(16), nullable=False, comment='Ȩ')
    ua_roles = Column(String(64), nullable=False, comment='ȨޣѡegR1&S1')
    ua_source_id = Column(String(64), nullable=False, comment='ԴID')
    ua_desc = Column(String(255), nullable=False, comment='')
    create_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    update_by = Column(String(64))
    update_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))
    create_by = Column(String(64))


class AuthInformation(Base, BaseModel):
    __tablename__ = 'auth_information'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='')
    user_name = Column(String(64), comment='')
    user_phone = Column(String(64), comment='ֻ')
    user_zhiwei = Column(String(64), comment='ְλ')
    user_email = Column(String(64), comment='')
    staff_no = Column(String(64), comment='')
    user_info_id = Column(String(64), comment='ûId')
    org_id = Column(String(64), comment='Id')
    user_teamid = Column(String(64), comment='ŶID')
    status = Column(INTEGER(128), comment='״̬')
    reviewer = Column(String(64), comment='')
    review_time = Column(DateTime, comment='ʱ')
    user_role = Column(String(3), comment='ɫ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class AuthTask(Base, BaseModel):
    __tablename__ = 'auth_task'
    __table_args__ = {'comment': 'Ȩ'}

    id = Column(String(64), primary_key=True, comment='')
    auth_code = Column(String(16), nullable=False, comment='Ȩcode')
    task_code = Column(String(16), nullable=False, comment='')
    task_param = Column(String(16), nullable=False, comment='ֵ')
    add_auth_code = Column(String(16), nullable=False, comment='ӵȨ')
    start_time = Column(DateTime, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"), comment='ʼʱ')
    end_time = Column(DateTime, server_default=text("'0000-00-00 00:00:00'"), comment='ʱ')
    create_by = Column(String(64), comment='')
    create_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP"), comment='ʱ')
    update_by = Column(String(64), comment='޸')
    update_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"), comment='޸ʱ')
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"), comment='ɾʶ 0: 1:')


class Banner(Base, BaseModel):
    __tablename__ = 'banner'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    type = Column(INTEGER(5), comment='')
    img_url = Column(String(128), comment='ͼƬַ')
    ref_id = Column(String(64), comment='ID')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(String(3), comment='ɾʶ')


class CompositeIndexLog(Base, BaseModel):
    __tablename__ = 'composite_index_log'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    currentdate = Column(Date, comment='ǰ')
    indexcode = Column(String(80), comment='ָ')
    indexname = Column(String(80), comment='ָ')
    indextype = Column(String(80), comment='ָ(1ڣ2ȫ)')
    indexendprice = Column(String(80), comment='ֵָ')
    indexchangeprice = Column(String(80), comment='ǵ')
    indexchangepricerate = Column(String(80), comment='ǵ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class ConstantDatum(Base, BaseModel):
    __tablename__ = 'constant_data'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    cd_type = Column(String(32), comment='')
    cd_value = Column(String(256), comment='ֵ')
    cd_desc = Column(String(256), comment='')
    org_id = Column(String(64), comment='')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class CooperateCustomer(Base, BaseModel):
    __tablename__ = 'cooperate_customer'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    cc_customer_id = Column(String(64), comment='ͻid')
    cc_customer_phone = Column(String(16))
    cc_customer_name = Column(String(64))
    cc_partner_teamid = Column(String(64), comment='Ŷ')
    cc_partnerid = Column(String(64), comment='ID')
    manager_id = Column(String(64), comment='ؾId')
    cc_planid = Column(String(64), comment='ʹ÷')
    cc_process_status = Column(String(32), comment='״̬')
    cc_userrecord_id = Column(String(64), comment='ûΪ¼ID')
    cc_userlinks = Column(Text, comment='û·')
    cc_articleid = Column(String(64))
    org_id = Column(String(64), comment='Id')
    cc_type = Column(String(3), comment=' 0ҵ 1ֱ')
    ext = Column(String(5120), comment='չϢ')
    share_status = Column(String(3), comment='״̬ 0δ 1ѷ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class CooperateCustomerProces(Base, BaseModel):
    __tablename__ = 'cooperate_customer_process'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    cc_ccid = Column(String(64), comment='¼ID')
    ccp_process_status = Column(String(32), comment='Ŀ׶')
    ccp_comm = Column(BIGINT(8), comment='Ӷ')
    ccp_beizhu = Column(String(256), comment='ע')
    ccp_planid = Column(String(64), comment='ID')
    ccp_teamid = Column(String(64), comment='Ŷ')
    cc_partnerid = Column(String(64), comment='ID')
    manager_id = Column(String(64), comment='ؾId')
    cc_customerid = Column(String(64), comment='ͻID')
    cc_imgurls = Column(String(256), comment='ͼƬ')
    org_id = Column(String(64), comment='Id')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class CooperateExistingCustomer(Base, BaseModel):
    __tablename__ = 'cooperate_existing_customer'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    plan_id = Column(String(64), comment='ID')
    customer_name = Column(String(64), comment='ͻ')
    customer_mobilephone = Column(String(20), comment='ͻֻ')
    activated = Column(INTEGER(1), comment='Ƿ񼤻')
    org_id = Column(String(64), comment='Id')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class CooperatePartner(Base, BaseModel):
    __tablename__ = 'cooperate_partner'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    cp_openid = Column(String(64), comment='openid')
    cp_name = Column(String(64), comment='')
    cp_phone = Column(String(64), comment='ֻ')
    cp_userid = Column(String(64), comment='ҵԱID')
    cp_teamid = Column(String(64), comment='ںŶ')
    cp_status = Column(String(3), comment='״̬')
    cp_beizhu = Column(String(256), comment='ע')
    org_id = Column(String(64), comment='Id')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class CooperatePlan(Base, BaseModel):
    __tablename__ = 'cooperate_plan'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    plan_name = Column(String(64), comment='')
    plan_status = Column(String(3), comment='״̬')
    plan_coustomer_target = Column(String(1024), comment='ͻĿ')
    plan_detail = Column(String(1024), comment='')
    org_id = Column(String(64), comment='Id')
    plan_type = Column(String(3), comment=' 0ҵ 1ֱ')
    validation_switch = Column(INTEGER(1), comment='Ƿֻ֤')
    share_switch = Column(INTEGER(1), comment='')
    share_articleid = Column(String(64), comment='')
    ext = Column(String(5120), comment='չϢ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class CooperateTeam(Base, BaseModel):
    __tablename__ = 'cooperate_team'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ct_name = Column(String(64), comment='Ŷ')
    ct_controteam = Column(String(3), comment='ǷҵԱŶ')
    org_id = Column(String(64), comment='Id')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class CrawlerConfigure(Base, BaseModel):
    __tablename__ = 'crawler_configure'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    weburlorwechatsubs = Column(String(256), comment='ȡַں')
    wechatuid = Column(String(64), comment='΢Źںuid')
    wxcrawletype = Column(String(3), comment='΢ȡ')
    crawlertype = Column(String(8), comment='ץȡ')
    contenttype = Column(String(8), comment='ݷ')
    crawlersource = Column(String(128), comment='ץȡԴ|վ')
    regex_list = Column(String(1024), comment='ƥ')
    css_selector_list = Column(String(1024), comment='ҳԪȡ')
    task_time = Column(String(128), comment='ʱץȡʱ')
    personal = Column(INTEGER(1), comment='˽е')
    wechat_category = Column(String(1024), comment='΢Źںŷ')
    wechat_imgurl = Column(String(256))
    org_id = Column(String(64), comment='Id')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    wechat_desc = Column(String(1024))


class CrawlerLog(Base, BaseModel):
    __tablename__ = 'crawler_log'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    crawler_wxname = Column(String(128), comment='ں|վ')
    crawler_status = Column(String(255), comment='ץȡ״̬')
    crawler_message = Column(String(255), comment='ץȡ')
    crawler_date = Column(DateTime, comment='ץȡʱ')


class CsFileRecord(Base, BaseModel):
    __tablename__ = 'cs_file_record'
    __table_args__ = (
        Index('idx_logical_path_file_type', 'logical_path', 'file_type'),
    )

    guid = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    original_name = Column(String(128), comment='ļԭʼ')
    original_url = Column(String(256), comment='ļԭ')
    file_suffix = Column(String(128), comment='ļ׺')
    file_type = Column(String(128), comment='ļ')
    logical_name = Column(String(128), comment='ļ߼')
    logical_path = Column(String(256), comment='ļ·')
    refid = Column(Text, comment='ID')
    file_status = Column(INTEGER(128), comment='ļ״̬')
    ext1 = Column(String(128), comment='չֶ1')
    ext2 = Column(String(128), comment='չֶ2')
    ext3 = Column(String(128), comment='չֶ3')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    ext4 = Column(String(64), comment='Ƶ/Ƶʱ')


class CurriculumChapter(Base, BaseModel):
    __tablename__ = 'curriculum_chapter'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    cc_id = Column(String(32), comment='γ')
    cc_title = Column(String(128), comment='½ڱ')
    cc_firstcatalog_id = Column(String(64), comment='һĿ¼ID')
    cc_timelength = Column(INTEGER(128), comment='ʱ')
    cc_content = Column(MEDIUMTEXT, comment='½ĸ')
    cc_audio = Column(String(128), comment='½Ƶ')
    cc_buy_basenum = Column(BIGINT(8), comment='⹺')
    cc_buy_actualnum = Column(BIGINT(8), comment='ʵʹ')
    cc_collect_basenum = Column(BIGINT(8), comment='ղ')
    cc_collect_actualnum = Column(BIGINT(8), comment='ʵղ')
    cc_praise_basenum = Column(BIGINT(8), comment='')
    cc_praise_actualnum = Column(BIGINT(8), comment='ʵʵ')
    cc_fee_type = Column(String(3), comment='շ')
    cc_status = Column(String(3), comment='״̬')
    cc_release_time = Column(DateTime, comment='ϼʱ')
    uptime = Column(DateTime, comment='ʱϼʱ')
    org_id = Column(String(64), comment='ID')
    cc_territory = Column(String(64), comment='ó')
    upload_type = Column(String(3), comment='ϴļ')
    createby = Column(String(64), comment='')
    createtime = Column(DateTime, comment='ʱ')
    updateby = Column(String(64), comment='޸')
    updatetime = Column(DateTime, comment='޸ʱ')
    deletetag = Column(String(3), comment='ɾʶ')
    datum_chap = Column(String(128), comment='½')
    cc_teaid = Column(String(64), comment='ʦID')
    cc_desc = Column(String(1024))
    ci_teaid = Column(String(64), comment='ʦId')
    upload_size = Column(String(128), comment='ϴļС')
    cc_sort = Column(INTEGER(5), comment='½')
    cc_label = Column(String(165), comment='νڱǩ')
    c_res_id = Column(String(64), index=True, comment='γid')
    is_recommend = Column(INTEGER(1), comment='ǷƼ')
    recommend_reason = Column(String(100), comment='Ƽ')
    recommend_cover = Column(String(128), comment='Ƽ')
    read_num = Column(INTEGER(11), server_default=text("'0'"), comment='Ķ')
    read_base_num = Column(INTEGER(11), server_default=text("'0'"), comment='Ķ')


class CurriculumChapterFirstcatalog(Base, BaseModel):
    __tablename__ = 'curriculum_chapter_firstcatalog'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ccf_id = Column(String(32), comment='γ')
    ccf_title = Column(String(128), comment='')
    ccf_status = Column(String(3), comment='״̬')
    ccf_release_time = Column(DateTime, comment='ϼʱ')
    org_id = Column(String(64), comment='ID')
    createby = Column(String(64), comment='')
    createtime = Column(DateTime, comment='ʱ')
    updateby = Column(String(64), comment='޸')
    updatetime = Column(DateTime, comment='޸ʱ')
    deletetag = Column(String(3), comment='ɾʶ')


class CurriculumColumn(Base, BaseModel):
    __tablename__ = 'curriculum_column'
    __table_args__ = {'comment': 'Ŀ'}

    id = Column(String(64), primary_key=True, comment='id')
    code = Column(String(64), comment='Ŀcode')
    title = Column(String(15), nullable=False, comment='Ŀ')
    info = Column(String(500), comment='')
    content = Column(MEDIUMTEXT, comment='ĸ')
    cover = Column(String(100), nullable=False, comment='')
    level = Column(INTEGER(1), nullable=False, index=True, comment='Ŀ¼ȼ 1һ 2')
    parent_id = Column(String(64), nullable=False, comment='ϼĿ')
    status = Column(INTEGER(1), nullable=False, comment='״̬')
    sort = Column(INTEGER(11), nullable=False, server_default=text("'0'"), comment='')
    module_id = Column(String(64), nullable=False, comment='ģid   nav  selectedѡ liveֱ  curriculum:γ')
    create_time = Column(DateTime, nullable=False, comment='ʱ')
    create_by = Column(String(64), nullable=False, comment='')
    update_time = Column(DateTime, nullable=False, comment='޸ʱ')
    delete_tag = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='Ƿɾ')


class CurriculumColumnRel(Base, BaseModel):
    __tablename__ = 'curriculum_column_rel'
    __table_args__ = (
        Index('idx_column_rel', 'curriculum_column_id', 'rel_id', unique=True),
        {'comment': 'Ŀ'}
    )

    id = Column(String(64), primary_key=True, comment='id')
    curriculum_column_id = Column(String(64), nullable=False, comment='Ŀid')
    rel_id = Column(String(64), nullable=False, comment='id')
    rel_type = Column(INTEGER(1), nullable=False, comment='  1Ŀ  3ֱ 4Ƶ  5 Ƶ')
    sort = Column(INTEGER(11), nullable=False, server_default=text("'0'"), comment='')
    status = Column(INTEGER(1), server_default=text("'1'"), comment='״̬')
    status_update_time = Column(DateTime, comment='״̬ʱ')
    create_time = Column(DateTime, nullable=False, comment='ʱ')


class CurriculumInfo(Base, BaseModel):
    __tablename__ = 'curriculum_info'
    __table_args__ = {'comment': 'introduce_img'}

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ci_title = Column(String(128), comment='γ̱')
    ci_subtitle = Column(String(128), comment='γ̸')
    ci_briefintro = Column(MEDIUMTEXT, comment='γ̼')
    ci_label = Column(String(500), comment='γ̱ǩ')
    ci_cover = Column(String(128), comment='')
    ci_bakimg = Column(String(128), comment='鱳')
    ci_teaid = Column(String(64))
    ci_author = Column(String(32), comment='')
    ci_authorheadurl = Column(String(128), comment='ͷ')
    ci_author_position = Column(String(128), comment='ְλ')
    ci_status = Column(String(3), comment='״̬')
    ci_buy_basenum = Column(BIGINT(8), comment='⹺')
    ci_buy_actualnum = Column(BIGINT(8), comment='ʵʹ')
    ci_collect_basenum = Column(BIGINT(8), comment='ղ')
    ci_collect_actualnum = Column(BIGINT(8), comment='ʵղ')
    cc_read_basenum = Column(BIGINT(8), comment='Ķ')
    cc_read_actualnum = Column(BIGINT(8), comment='ʵĶ')
    ci_uptime = Column(DateTime, comment='ϼʱ')
    ci_istop = Column(String(3), comment='Ƿö')
    ci_top_date = Column(DateTime, comment='öʱ')
    ci_fee_type = Column(String(3), comment='շ')
    ci_flag = Column(String(3), comment='½ڱʶ')
    ci_module = Column(String(3), comment='ģ')
    ci_total_chapter = Column(INTEGER(5), comment='½')
    deletetag = Column(String(3), comment='ɾʶ')
    ci_catalog_type = Column(String(3), comment='Ŀ¼ģʽ')
    ci_chapter_updatetime = Column(DateTime, comment='½ʱ')
    ci_smail_cover = Column(String(128))
    org_id = Column(String(64), comment='ID')
    createby = Column(String(64), comment='')
    createtime = Column(DateTime, comment='ʱ')
    updateby = Column(String(64), comment='޸')
    updatetime = Column(DateTime, comment='޸ʱ')
    ci_type = Column(String(64), comment='')
    ci_territory = Column(String(64), comment='ó')
    ci_isrecommend = Column(INTEGER(5), comment='Ƽʶ')
    ci_isrecommend_time = Column(DateTime, comment='Ƽʱ')
    ci_reason = Column(String(256), comment='ѡ')
    ci_subject = Column(String(64), comment='רID')
    share_title = Column(String(128))
    share_pic = Column(String(256))
    share_desc = Column(String(256))
    ci_courseware = Column(Text)
    ci_fuli = Column(Text)
    ci_qrcode = Column(String(256))
    ci_canlisten_chapternum = Column(INTEGER(3))
    ci_teacher_info = Column(String(100), comment='ʦ')
    ci_operators_reason = Column(String(500), comment='ӪƼ')
    ci_introduce_code = Column(String(50), comment='Ⱥ/Ƽ')
    ci_open_type = Column(INTEGER(1), comment='0 :κ˲ 1̽ջԱ 2 עû  3 ')
    ci_open_pwd = Column(String(20), comment='')
    introduce_img = Column(String(128), comment='ƼγͼƬ')
    sort_priority = Column(INTEGER(11), server_default=text("'0'"), comment='')


class CurriculumInquiryOrder(Base, BaseModel):
    __tablename__ = 'curriculum_inquiry_order'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    of_ordernum = Column(String(64), comment='')
    ci_curid = Column(String(64), comment='γID')
    ci_uname = Column(String(64), comment='')
    ci_phone = Column(String(64), comment='ֻ')
    ci_desc = Column(String(64), comment='')
    ci_fileurls = Column(String(4096), comment='')
    of_amount = Column(DECIMAL(5, 2), comment='')
    ci_status = Column(String(3), comment='״̬')
    pay_status = Column(String(3), comment='֧״̬')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class CurriculumOften(Base, BaseModel):
    __tablename__ = 'curriculum_often'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    title = Column(String(64), comment='γ')
    often_time = Column(DateTime, comment='ʱ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class CurriculumPackage(Base, BaseModel):
    __tablename__ = 'curriculum_package'
    __table_args__ = {'comment': 'γ̰'}

    id = Column(String(64), primary_key=True, comment='id')
    title = Column(String(20), nullable=False, comment='γ̰')
    info = Column(String(100), comment='')
    cover = Column(String(100), comment='')
    status = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='״̬')
    tag = Column(INTEGER(5), comment='ǩ')
    sort = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='')
    create_time = Column(DateTime, nullable=False, comment='ʱ')
    create_by = Column(String(50), nullable=False)
    update_time = Column(DateTime)
    delete_tag = Column(INTEGER(1), nullable=False)


class CurriculumPackageContent(Base, BaseModel):
    __tablename__ = 'curriculum_package_content'

    id = Column(String(64), primary_key=True)
    rel_id = Column(String(64), nullable=False, comment='id')
    title = Column(String(50), nullable=False, comment='')
    cover = Column(String(100), comment='')
    content_type = Column(INTEGER(1), nullable=False, comment='')
    start_time = Column(DateTime)
    status = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='״̬')
    sort = Column(INTEGER(11), nullable=False, server_default=text("'0'"), comment='')
    create_time = Column(DateTime, nullable=False)
    create_by = Column(String(64), nullable=False, comment='')
    update_time = Column(DateTime, nullable=False)
    delete_tag = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='ɾ״̬')
    res_id = Column(String(64), comment='ԴID')


class CurriculumPrice(Base, BaseModel):
    __tablename__ = 'curriculum_price'
    __table_args__ = {'comment': '۱'}

    id = Column(String(64), primary_key=True)
    rel_id = Column(String(64), nullable=False, index=True, comment='id')
    charge_mode = Column(INTEGER(1), nullable=False, comment='ģʽ 1 2  3ֽ')
    price = Column(BIGINT(10), comment='۸')
    crossed_price = Column(BIGINT(10), comment='߼')
    promo = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='Ƿ 0  1  ')
    promo_price = Column(BIGINT(10), comment='۸')
    promo_start_time = Column(DateTime, comment='ʼ')
    promo_end_time = Column(DateTime, comment='')
    use_score = Column(INTEGER(1), server_default=text("'0'"), comment='ʹû 0ʹ 1ʹ ֶΣ')
    score = Column(INTEGER(11), comment='')
    is_role_price = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='Ƿнɫ 0û  1')
    create_time = Column(DateTime, nullable=False, comment='ʱ')
    create_by = Column(String(64), nullable=False, comment='')
    update_time = Column(DateTime, nullable=False, comment='ʱ')
    delete_tag = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='ɾ')


class CurriculumRel(Base, BaseModel):
    __tablename__ = 'curriculum_rel'
    __table_args__ = (
        Index('index_cid_relid_reltype', 'c_id', 'rel_id', 'rel_type'),
    )

    id = Column(String(64), primary_key=True, comment='id')
    c_id = Column(String(64), nullable=False, comment='γid')
    rel_id = Column(String(64), nullable=False, comment='id')
    rel_type = Column(INTEGER(1), nullable=False, comment=' 1γ 2ֱ 3 ѡ 4ѵӪ')
    create_time = Column(DateTime, nullable=False, comment='ʱ')
    create_by = Column(String(64), nullable=False, comment='')
    delete_tag = Column(INTEGER(1), nullable=False, comment='ɾʶ')


class CurriculumRe(Base, BaseModel):
    __tablename__ = 'curriculum_res'
    __table_args__ = {'comment': 'γԴ'}

    id = Column(String(64), primary_key=True, comment='id')
    title = Column(String(50), nullable=False, comment='γ')
    audio = Column(String(128), comment='γƵ')
    audio_type = Column(INTEGER(1), comment='Ƶ')
    teacher_id = Column(String(64), comment='ʦid')
    teacher_name = Column(String(128), comment='ʦ')
    content = Column(MEDIUMTEXT, comment='ĸ')
    duration = Column(INTEGER(11), comment='ʱ')
    file_size = Column(INTEGER(11), comment='ļСKB')
    org_id = Column(String(64), index=True, comment='֯id')
    room_pwd = Column(String(50), comment='')
    create_by = Column(String(64), nullable=False, comment='')
    create_time = Column(DateTime, nullable=False, comment='ʱ')
    update_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='ʱ')
    delete_tag = Column(INTEGER(1), nullable=False, comment='ɾʶ')
    read_num = Column(INTEGER(11), server_default=text("'0'"), comment='Ķ')
    read_base_num = Column(INTEGER(11), server_default=text("'0'"), comment='Ķ')
    status = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='״̬')
    sort = Column(INTEGER(11), nullable=False, server_default=text("'0'"), comment='')
    info = Column(String(255), server_default=text("''"), comment='')
    cover = Column(String(255), nullable=False, server_default=text("''"), comment='')


t_curriculum_share_config = Table(
    'curriculum_share_config', metadata,
    Column('id', String(64), nullable=False, comment=''),
    Column('title', String(50), nullable=False, comment=''),
    Column('content', String(100), nullable=False, comment=''),
    Column('cover', String(100), nullable=False, comment=''),
    Column('rel_id', String(64), nullable=False, comment='id'),
    Column('create_time', DateTime, nullable=False, comment=''),
    Column('update_time', DateTime, nullable=False, comment='ʱ'),
    Column('create_by', String(64), nullable=False, comment=''),
    comment='γ̷'
)


class CurriculumSubject(Base, BaseModel):
    __tablename__ = 'curriculum_subject'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    cs_name = Column(String(128), comment='ר')
    cs_desc = Column(String(1024), comment='ר')
    cs_imgurl = Column(String(256), comment='ҳƼͼƬ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    cs_detail = Column(MEDIUMTEXT, comment='ר')
    cs_introduce_code = Column(String(100), comment='Ⱥ Ƽ ')
    cs_open_type = Column(INTEGER(1), comment='0 :κ˲ 1 עû ')
    status = Column(INTEGER(1), comment='״̬')
    org_id = Column(String(64), comment='֯')
    update_status = Column(INTEGER(1), server_default=text("'0'"), comment='0:  1ͣ')
    read_limit = Column(INTEGER(11), server_default=text("'0'"), comment='')


class CurriculumSubjectChapter(Base, BaseModel):
    __tablename__ = 'curriculum_subject_chapter'
    __table_args__ = {'comment': 'ר½'}

    id = Column(String(64), primary_key=True, comment='id')
    cs_id = Column(String(64), nullable=False, comment='רid')
    title = Column(String(255), nullable=False, comment='½')
    teacher_id = Column(String(64), comment='ʦid')
    teacher_name = Column(String(100), comment='ʦ')
    status = Column(INTEGER(1), nullable=False, comment='״̬')
    uptime = Column(DateTime, comment='ʱϼʱ')
    release_time = Column(DateTime, comment='ϼʱ')
    fee_type = Column(INTEGER(1), comment='')
    content = Column(Text, comment='ĸ')
    teacher_info = Column(Text, comment='ʦ')
    audio = Column(String(128), nullable=False, comment='Ƶ')
    audio_size = Column(INTEGER(11), comment='ƵС')
    audio_length = Column(INTEGER(11), comment='Ƶʱ')
    audio_type = Column(INTEGER(1), comment='Ƶ')
    read_base = Column(INTEGER(11), comment='Ķ')
    read_num = Column(INTEGER(11), server_default=text("'0'"), comment='Ķ')
    sort_priority = Column(INTEGER(11), server_default=text("'0'"), comment='')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    create_time = Column(DateTime, nullable=False, comment='ʱ')
    create_by = Column(String(64), nullable=False, comment='')
    update_time = Column(DateTime, comment='ʱ')
    update_by = Column(String(64), comment='')


class CurriculumTeacher(Base, BaseModel):
    __tablename__ = 'curriculum_teacher'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    ct_headimg = Column(String(128), comment='ʦͷ')
    ct_teaname = Column(String(64), comment='ʦ')
    ct_teadesc = Column(String(1024), comment='ʦ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    ct_userId = Column(String(64), comment='û')
    ct_user_id = Column(String(64), comment='û')


t_customer_ifa_rel = Table(
    'customer_ifa_rel', metadata,
    Column('id', String(64), nullable=False, comment=''),
    Column('user_id', String(64), nullable=False, comment='ʦid'),
    Column('customer_id', String(64), nullable=False, comment='ͻid'),
    Column('create_time', DateTime, nullable=False, comment='ʱ'),
    Column('create_by', String(64), nullable=False, comment=''),
    Column('update_time', DateTime, comment='ʱ'),
    Column('update_by', String(64), comment=' '),
    Column('delete_id', INTEGER(1), nullable=False, server_default=text("'0'"), comment='ɾʶ'),
    comment='ͻʦ'
)


t_customer_info = Table(
    'customer_info', metadata,
    Column('id', String(64), nullable=False, comment=''),
    Column('customer_name', String(50), server_default=text("''"), comment='ͻ'),
    Column('create_time', DateTime, comment='ʱ'),
    Column('create_by', String(64), server_default=text("''"), comment=''),
    Column('update_time', DateTime, comment='ʱ'),
    Column('update_by', String(64), comment=''),
    Column('delete_tag', INTEGER(1), server_default=text("'0'"), comment='ɾʶ'),
    comment='ͻ'
)


t_customer_order = Table(
    'customer_order', metadata,
    Column('id', String(64), nullable=False, comment='id'),
    Column('user_id', String(64), server_default=text("''"), comment='ʦid'),
    Column('customer_id', String(64), server_default=text("''"), comment='ͻid'),
    Column('folio_name', VARCHAR(64), server_default=text("'default'"), comment='ƣĬdefaultԵû'),
    Column('fund_id', String(64), server_default=text("''"), comment='Ʒid'),
    Column('order_type', INTEGER(1), comment='1:깺  2'),
    Column('pay_date', Date, comment=''),
    Column('subscription_fee', DECIMAL(22, 6), comment='깺'),
    Column('confirm_share_date', Date, comment='ݶȷ'),
    Column('confirm_share', DECIMAL(22, 6), comment='ȷϷݶ'),
    Column('confirm_amount', DECIMAL(22, 6), comment='ȷϽ'),
    Column('nav', DECIMAL(22, 6), comment='ֵ'),
    Column('remark', String(255), comment='ע'),
    Column('create_time', DateTime, comment='ʱ'),
    Column('create_by', String(64), comment='ʱ'),
    Column('update_time', DateTime, comment='ʱ'),
    Column('update_by', String(64), comment=''),
    comment='ͻ'
)


class DaySelection(Base, BaseModel):
    __tablename__ = 'day_selection'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    ds_type = Column(String(64), comment='')
    ds_subject_id = Column(String(64), comment='ID')
    ds_id = Column(String(64), comment='ID')
    ds_sort = Column(INTEGER(128), comment='')
    ds_ext = Column(String(128), comment='չ')
    ds_isrecommend = Column(String(3), comment='ǷƼ0: 1:')
    ds_focus_topic = Column(String(3), comment='Ƿ񽹵㻰0:1:')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class DaySubject(Base, BaseModel):
    __tablename__ = 'day_subject'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    ds_title = Column(String(128), comment='')
    ds_date = Column(Date, comment='')
    ds_status = Column(String(3), comment='״̬')
    ds_ispush_content = Column(String(3), comment='Ƿ 0: 1:')
    ds_picurl = Column(String(256), comment='ʱͼƬַ')
    ds_pic_link = Column(String(256), comment='ͼƬת')
    ds_thumbnail = Column(String(256), comment='ͼ')
    ds_issettop = Column(String(3), comment='Ƿö0: 1:')
    ds_day_title = Column(String(128), comment='')
    ds_day_content = Column(Text, comment='')
    ds_taskuptime = Column(DateTime, comment='ʱϼʱ')
    ds_pt = Column(String(128), comment='ƽ̨')
    base_browse_num = Column(INTEGER(5))
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class Exam(Base, BaseModel):
    __tablename__ = 'exam'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ex_name = Column(String(256), comment='Ծ')
    ex_starttime = Column(DateTime, comment='Կʼʱ')
    ex_endtime = Column(DateTime, comment='Խʱ')
    ex_totalscore = Column(INTEGER(5), comment='')
    ex_passscore = Column(INTEGER(5), comment='ϸ')
    ex_status = Column(String(3), comment='״̬')
    org_id = Column(String(64), comment='ID')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class ExamContent(Base, BaseModel):
    __tablename__ = 'exam_content'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ex_id = Column(String(64), comment='ԾID')
    ec_type = Column(String(3), comment='Ŀ')
    ec_title = Column(String(512), comment='')
    ec_content = Column(String(1024), comment='ѡ')
    ec_right = Column(String(64), comment='ȷ')
    ear_score = Column(INTEGER(5), comment='Ŀ')
    org_id = Column(String(64), comment='ID')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class FinProRe(Base, BaseModel):
    __tablename__ = 'fin_pro_res'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    name = Column(String(64), comment='')
    abbr = Column(String(64), comment='Ƽƴ')
    bak = Column(String(128), comment='ע')
    status = Column(INTEGER(1), comment='״̬')
    flag = Column(String(3), comment='ʶ0:Ʒ 1ûԶƷ')
    resjson = Column(Text, comment='Ʒ')
    desjson = Column(MEDIUMTEXT, comment='İ')
    pro_imgurl = Column(String(256), comment='Ʒͼ')
    pro_bright = Column(Text, comment='Ʒ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    org_id = Column(String(64), comment='Id')
    pro_tag = Column(String(2048), comment='Ʒǩ')
    title_sw = Column(String(3), comment='ƿ')
    pro_title = Column(String(128), comment='б')
    pro_risk_config = Column(Text, comment='սʾ')
    investor_certification_switch = Column(INTEGER(1), comment='չܿؿ')
    risk_level = Column(INTEGER(2), comment='')
    ar_review_by = Column(String(64), comment='')
    ar_review_time = Column(DateTime, comment='ʱ')
    ar_submit_by = Column(String(64), comment='ύ')
    ar_submit_time = Column(DateTime, comment='ύʱ')
    ar_release_by = Column(String(64), comment='ϼ')
    ar_release_time = Column(DateTime, comment='ϼʱ')
    pro_type = Column(String(64), comment='Ʒ')
    ar_solt_by = Column(String(64), comment='¼')
    ar_solt_time = Column(DateTime, comment='¼ʱ')
    pro_soldout_Time = Column(DateTime, comment='Ԥ¼ʱ')
    raise_start = Column(DateTime, comment='ļʼʱ')
    raise_end = Column(DateTime, comment='ļʱ')
    pro_status = Column(String(64), comment='Ʒ״̬')
    raise_num = Column(String(64), comment='ļ')


class FriendArticle(Base, BaseModel):
    __tablename__ = 'friend_article'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    af_title = Column(VARCHAR(128), comment='')
    af_thumbnail = Column(String(256), comment='ͼ')
    af_author = Column(String(32), comment='')
    af_source = Column(String(32), comment='Դ')
    af_crawler_url = Column(String(512), comment='ץȡԴUrl')
    af_content = Column(MEDIUMTEXT, comment='')
    af_imgs = Column(Text, comment='ͼƬ')
    af_status = Column(INTEGER(3), comment='״̬')
    af_push_to = Column(String(3), comment='Ŀ 0ȫԱ 1Ŷ')
    af_push_teamid = Column(String(1024), comment='ŶID')
    af_type = Column(String(128), comment='')
    openid = Column(String(128), comment='openid')
    org_id = Column(String(128), comment='ID')
    share_msg = Column(String(2048), comment='Ϣ')
    ar_abstract = Column(String(1024), comment='ժҪ')
    ar_audio = Column(String(256), comment='Ƶ')
    ar_audio_length = Column(INTEGER(8), comment='Ƶʱ')
    af_proid = Column(String(512), comment='ƷID')
    af_company_intro = Column(String(3), comment='Ƿ˾')
    af_planid = Column(String(64), comment='ֱID')
    af_tags = Column(String(128), comment='ǩ')
    af_articleid = Column(String(64), comment='ԭID')
    af_is_protected = Column(INTEGER(128), comment='Ƿ')
    af_password = Column(String(128), comment='')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    af_review_by = Column(String(64), comment='')
    af_review_time = Column(DateTime, comment='ʱ')
    af_reject_reason = Column(String(64), comment='')
    af_reject_time = Column(String(64), comment='ʱ')


class Func(Base, BaseModel):
    __tablename__ = 'func'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='')
    f_tem_code = Column(String(16), comment='ģ')
    f_tem_name = Column(String(32), comment='ģ')
    f_code = Column(String(16), comment='')
    f_name = Column(String(32), comment='')
    f_name_tp = Column(String(32), comment='̽ѧԺӦ')
    f_router = Column(String(256), comment='·')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class HomeRemmend(Base, BaseModel):
    __tablename__ = 'home_remmend'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    remmend_data = Column(Text, comment='Զ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class IfaWechatPoster(Base, BaseModel):
    __tablename__ = 'ifa_wechat_poster'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    poster_imgurl = Column(String(256), comment='ͼƬַ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class IfaWechatStore(Base, BaseModel):
    __tablename__ = 'ifa_wechat_store'
    __table_args__ = {'comment': '΢Ϣ'}

    id = Column(String(64), primary_key=True, comment='Ψһ')
    storename = Column(String(64))
    ifaid = Column(String(64), nullable=False, comment='ʦID')
    today_guest = Column(INTEGER(11), nullable=False, comment='շÿ')
    today_new_guest = Column(INTEGER(11), nullable=False, comment='ÿ')
    sign = Column(String(64), comment='ǩ')
    today_date = Column(Date, comment='')


class ImpressionLabel(Base, BaseModel):
    __tablename__ = 'impression_label'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    il_label = Column(String(64), comment='ӡǩ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class InvestorRz(Base, BaseModel):
    __tablename__ = 'investor_rz'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    ir_explain = Column(String(512), comment='˵')
    option_a = Column(String(512), comment='ѡA')
    option_b = Column(String(512), comment='ѡB')
    staus = Column(INTEGER(3), nullable=False, server_default=text("'1'"), comment='״̬ 1: 0:')
    ir_startime = Column(DateTime, comment='ʱ')
    ir_endtime = Column(DateTime, comment='ʱ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='ɾʶ')
    title = Column(String(128), nullable=False, server_default=text("''"), comment='')
    sub_title = Column(String(512), server_default=text("''"), comment='')


class OperateActivityNewyeardraw(Base, BaseModel):
    __tablename__ = 'operate_activity_newyeardraw'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    oan_action = Column(String(3), comment='Ϊ')
    oan_username = Column(String(64), comment='')
    oan_type = Column(String(3), comment='ǩ')
    oan_share_userid = Column(String(64), comment='')
    oan_share_sourceid = Column(String(64), comment='ԴID')
    oan_resimgurl = Column(String(256))
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class Operation(Base, BaseModel):
    __tablename__ = 'operation'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    operation_type = Column(INTEGER(11), comment='־')
    sub_operation_type = Column(INTEGER(11), comment='')
    ref_id = Column(String(64), comment='ݱ')
    ref_title = Column(String(128), comment='ݱ')
    action_name = Column(INTEGER(11), comment='')
    org_id = Column(String(64), comment='ID')
    create_id = Column(String(64), comment='Id')
    create_name = Column(String(128), comment='')
    create_time = Column(DateTime, comment='ʱ')


class OrderFlow(Base, BaseModel):
    __tablename__ = 'order_flow'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ab_ordernum = Column(String(128), comment='')
    ab_price = Column(BIGINT(12), comment='Ʒ۸')
    ab_score = Column(BIGINT(12), comment='')
    ab_score_deduct = Column(BIGINT(12), comment='ֵֿ')
    ab_account_deduct = Column(BIGINT(12), comment='˻ֿ')
    ab_payment = Column(BIGINT(12), comment='֧ͨ')
    ab_pay_mode = Column(String(3), comment='֧ʽ')
    ab_total_money = Column(BIGINT(12), comment='ܶ')
    ab_type = Column(String(3), comment='Ʒ')
    ab_proid = Column(String(64), comment='ƷID')
    ab_pro_siid = Column(String(64), comment='ƷID')
    ab_si_type = Column(String(3), comment='Ʒ')
    ab_si_name = Column(String(32), comment='Ʒ')
    ab_si_code = Column(String(16), comment='Ʒ')
    ab_si_pattern = Column(String(3), comment='Ʒ񶨼ģʽ')
    ab_status = Column(String(16), comment='״̬')
    ab_rights_status = Column(String(3), comment='Ȩ״̬')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    unionid = Column(String(64), comment='΢unionid')


class Org(Base, BaseModel):
    __tablename__ = 'org'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='')
    org_code = Column(String(64), comment='Ψһʶ')
    org_name = Column(String(64), comment='')
    automatic_processing = Column(INTEGER(128), comment='Զ֤ͨ')
    isbuy_selection = Column(String(3), comment='Ƿ˾ѡ0 1')
    isbuy_todayfocus = Column(String(3), comment='Ƿ˽վ۽ 0 1')
    ar_push_labels = Column(Text, comment='ͱǩ')
    fun_codes = Column(String(1024), comment='')
    homepage_custom = Column(Text, comment='ҳ')
    content_set = Column(String(512), comment='')
    card_template = Column(INTEGER(128), comment='Ƭģ')
    accredited_investor_switch = Column(INTEGER(1), comment='ϸͶ֤')
    friend_tools_switch = Column(INTEGER(1), comment='Ȧֿ')
    tag_category_id = Column(String(64), comment='')
    aliyun_sign_name = Column(String(128), comment='ƶǩ')
    aliyun_tempcode = Column(String(128), comment='ϢģID')
    aliyun_access_key_id = Column(String(128), comment='AccessKeyId')
    aliyun_access_key_secret = Column(String(128), comment='AccessKeySecret')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class PhotoLive(Base, BaseModel):
    __tablename__ = 'photo_live'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    pl_name = Column(String(128), comment='')
    pl_start_time = Column(DateTime, comment='ʼʱ')
    pl_end_time = Column(DateTime, comment='ʱ')
    pl_address = Column(String(256), comment='ص')
    pl_cover = Column(String(256), comment='ӭҳƬ')
    pl_background = Column(String(256), comment='ҳƬ')
    pl_watermark = Column(String(64), comment='Ƭˮӡ')
    pl_share_desc = Column(String(64), comment='İ')
    pl_share_logo = Column(String(256), comment='ͼƬ')
    pl_adv = Column(String(128), comment='ײİ')
    org_id = Column(String(64), comment='Id')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class PhotoLiveExt(Base, BaseModel):
    __tablename__ = 'photo_live_ext'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    photo_live_id = Column(String(64), comment='ƬֱId')
    ple_type = Column(INTEGER(3), comment='')
    target_id = Column(String(64), comment='ĿId')
    ple_adv_logo = Column(String(256), comment='ͼƬ')
    ple_adv_desc = Column(String(64), comment='')
    org_id = Column(String(64), comment='Id')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class PhotoLiveLike(Base, BaseModel):
    __tablename__ = 'photo_live_like'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    photo_live_id = Column(String(64), comment='ƬֱId')
    user_info_id = Column(String(64), comment='ûId')
    file_id = Column(String(64), comment='ͼƬļId')
    org_id = Column(String(64), comment='Id')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class ProReservation(Base, BaseModel):
    __tablename__ = 'pro_reservation'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    pr_pro_id = Column(String(64), comment='ƷID')
    pr_user_id = Column(String(64), comment='ûid')
    pr_username = Column(String(80), comment='û')
    pr_mobile_phone = Column(String(20), comment='ûֻ')
    pr_fauser_id = Column(String(64), comment='ʦId')
    pr_team_id = Column(String(64), comment='ŶID')
    pr_team_fullpathid = Column(String(1024), comment='Ŷȫ·ID')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(String(3), comment='ɾʶ')


class ProblemFeedback(Base, BaseModel):
    __tablename__ = 'problem_feedback'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    pf_type = Column(String(32), comment='')
    pf_cont = Column(String(512), comment='')
    pf_pic = Column(String(1024), comment='ͼƬ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class QrtzCalendar(Base, BaseModel):
    __tablename__ = 'qrtz_calendars'

    SCHED_NAME = Column(String(120), primary_key=True, nullable=False)
    CALENDAR_NAME = Column(String(190), primary_key=True, nullable=False)
    CALENDAR = Column(LargeBinary, nullable=False)


class QrtzFiredTrigger(Base, BaseModel):
    __tablename__ = 'qrtz_fired_triggers'
    __table_args__ = (
        Index('IDX_QRTZ_FT_J_G', 'SCHED_NAME', 'JOB_NAME', 'JOB_GROUP'),
        Index('IDX_QRTZ_FT_JG', 'SCHED_NAME', 'JOB_GROUP'),
        Index('IDX_QRTZ_FT_T_G', 'SCHED_NAME', 'TRIGGER_NAME', 'TRIGGER_GROUP'),
        Index('IDX_QRTZ_FT_TRIG_INST_NAME', 'SCHED_NAME', 'INSTANCE_NAME'),
        Index('IDX_QRTZ_FT_TG', 'SCHED_NAME', 'TRIGGER_GROUP'),
        Index('IDX_QRTZ_FT_INST_JOB_REQ_RCVRY', 'SCHED_NAME', 'INSTANCE_NAME', 'REQUESTS_RECOVERY')
    )

    SCHED_NAME = Column(String(120), primary_key=True, nullable=False)
    ENTRY_ID = Column(String(95), primary_key=True, nullable=False)
    TRIGGER_NAME = Column(String(190), nullable=False)
    TRIGGER_GROUP = Column(String(190), nullable=False)
    INSTANCE_NAME = Column(String(190), nullable=False)
    FIRED_TIME = Column(BIGINT(13), nullable=False)
    SCHED_TIME = Column(BIGINT(13), nullable=False)
    PRIORITY = Column(INTEGER(11), nullable=False)
    STATE = Column(String(16), nullable=False)
    JOB_NAME = Column(String(190))
    JOB_GROUP = Column(String(190))
    IS_NONCONCURRENT = Column(String(1))
    REQUESTS_RECOVERY = Column(String(1))


class QrtzJobDetail(Base, BaseModel):
    __tablename__ = 'qrtz_job_details'
    __table_args__ = (
        Index('IDX_QRTZ_J_GRP', 'SCHED_NAME', 'JOB_GROUP'),
        Index('IDX_QRTZ_J_REQ_RECOVERY', 'SCHED_NAME', 'REQUESTS_RECOVERY')
    )

    SCHED_NAME = Column(String(120), primary_key=True, nullable=False)
    JOB_NAME = Column(String(190), primary_key=True, nullable=False)
    JOB_GROUP = Column(String(190), primary_key=True, nullable=False)
    DESCRIPTION = Column(String(250))
    JOB_CLASS_NAME = Column(String(250), nullable=False)
    IS_DURABLE = Column(String(1), nullable=False)
    IS_NONCONCURRENT = Column(String(1), nullable=False)
    IS_UPDATE_DATA = Column(String(1), nullable=False)
    REQUESTS_RECOVERY = Column(String(1), nullable=False)
    JOB_DATA = Column(LargeBinary)


class QrtzLock(Base, BaseModel):
    __tablename__ = 'qrtz_locks'

    SCHED_NAME = Column(String(120), primary_key=True, nullable=False)
    LOCK_NAME = Column(String(40), primary_key=True, nullable=False)


class QrtzPausedTriggerGrp(Base, BaseModel):
    __tablename__ = 'qrtz_paused_trigger_grps'

    SCHED_NAME = Column(String(120), primary_key=True, nullable=False)
    TRIGGER_GROUP = Column(String(190), primary_key=True, nullable=False)


class QrtzSchedulerState(Base, BaseModel):
    __tablename__ = 'qrtz_scheduler_state'

    SCHED_NAME = Column(String(120), primary_key=True, nullable=False)
    INSTANCE_NAME = Column(String(190), primary_key=True, nullable=False)
    LAST_CHECKIN_TIME = Column(BIGINT(13), nullable=False)
    CHECKIN_INTERVAL = Column(BIGINT(13), nullable=False)


class Quotation(Base, BaseModel):
    __tablename__ = 'quotations'
    __table_args__ = {'comment': 'ÿս'}

    id = Column(String(64), primary_key=True)
    title = Column(String(100), comment='')
    content_type = Column(INTEGER(1), comment='1: 2:ף 3')
    quotation_date = Column(Date, comment='')
    content = Column(Text, nullable=False, comment='')
    create_time = Column(DateTime, nullable=False, comment='ʱ')
    create_by = Column(String(64), nullable=False, comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    status = Column(INTEGER(1), nullable=False, comment='0:ϼ 1ϼ  2¼')
    delete_tag = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='ɾʶ ')
    advance_time = Column(Date, comment='Ԥϼʱ')


class Rebroadcast(Base, BaseModel):
    __tablename__ = 'rebroadcast'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    rd_time = Column(DateTime, comment='תʱ')
    rd_by_themeid = Column(String(64), comment='תֱID')
    rd_themeid = Column(String(64), comment='ֱID')
    company_name = Column(INTEGER(11), comment='ԤԼ')
    photo = Column(INTEGER(11), comment='')
    state = Column(INTEGER(11), comment='ط')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class ReportActvolume(Base, BaseModel):
    __tablename__ = 'report_actvolume'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    ra_team_id = Column(String(64), comment='ŶID')
    ra_team_fullpathid = Column(String(1024), comment='Ŷȫ·ID')
    ra_year = Column(INTEGER(5), comment='')
    ra_date = Column(Date, comment='')
    ra_sharearticle_num = Column(BIGINT(11), comment='´')
    ra_sharemp_num = Column(BIGINT(11), comment='Ƭ')
    ra_sharehuiwu_num = Column(BIGINT(11), comment='')
    ra_sharepro_num = Column(BIGINT(11), comment='Ʒ')
    ra_study_timelength = Column(BIGINT(11), comment='ѧϰʱ')
    ra_sharecompany_num = Column(BIGINT(11), comment='˾ϴ')
    ra_daka_num = Column(BIGINT(11), comment='ݷô򿨴')
    ra_peixun_canyu_num = Column(BIGINT(11), comment='ѵ')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(String(3), comment='ɾʶ')


class ReportCnReportform(Base, BaseModel):
    __tablename__ = 'report_cn_reportform'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    cn_teamid = Column(String(64), comment='ŶId')
    cn_headimg = Column(String(256), comment='ͷ')
    cn_username = Column(String(64), comment='')
    cn_year = Column(INTEGER(5), comment='')
    cn_val = Column(INTEGER(5), comment='ֵ')
    cn_type = Column(INTEGER(5), comment='')
    cn_article_chuda_num = Column(BIGINT(11), comment='´ͻ')
    cn_article_frist_num = Column(BIGINT(11), comment='һͻ')
    cn_article_forword_num = Column(BIGINT(11), comment='¿ͻת')
    cn_article_fission_num = Column(BIGINT(11), comment='ѱͻ')
    cn_article_clickpro_num = Column(BIGINT(11), comment='µƷ')
    cn_article_clickmp_num = Column(BIGINT(11), comment='µƬ')
    cn_article_clickim_num = Column(BIGINT(11), comment='µһ')
    cn_mp_chuda_num = Column(BIGINT(11), comment='Ƭͻ')
    cn_mp_change_num = Column(BIGINT(11), comment='Ƭ/Ƭ')
    cn_mp_grant_num = Column(BIGINT(11), comment='ƬȨ绰ͻ')
    cn_huiwu_chuda_num = Column(BIGINT(11), comment='񴥴ͻ')
    cn_huiwu_baoming_num = Column(BIGINT(11), comment='ͻ')
    cn_huiwu_daochang_num = Column(BIGINT(11), comment='񵽳')
    cn_huiwu_chengjiao_num = Column(BIGINT(11), comment='ɽͻ')
    cn_pro_chuda_num = Column(BIGINT(11), comment='Ʒͻ')
    cn_pro_yuyue_num = Column(BIGINT(11), comment='ƷԤԼͻ')
    cn_sharearticle_num = Column(BIGINT(11), comment='´')
    cn_sharemp_num = Column(BIGINT(11), comment='Ƭ')
    cn_sharehuiwu_num = Column(BIGINT(11), comment='')
    cn_sharepro_num = Column(BIGINT(11), comment='Ʒ')
    cn_sharecompany_num = Column(BIGINT(11), comment='˾ϴ')
    cn_study_timelength = Column(BIGINT(11), comment='ѧϰʱ')
    cn_daka_num = Column(BIGINT(11), comment='ݷô򿨴')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(String(3), comment='ɾʶ')


class ReportProAnalysi(Base, BaseModel):
    __tablename__ = 'report_pro_analysis'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    ta_year = Column(INTEGER(5), comment='')
    ta_month = Column(INTEGER(5), comment='')
    ta_day = Column(INTEGER(5), comment='')
    ta_teamid = Column(String(64), comment='ŶID')
    ta_fullpathid = Column(String(1024), comment='Ŷȫ·ID')
    ta_name = Column(String(128), comment='Ŷ')
    ta_pro_id = Column(String(64), comment='ƷId')
    ta_tgd = Column(BIGINT(11), comment='ƹ')
    ta_rxd = Column(BIGINT(11), comment='')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(String(3), comment='ɾʶ')


class ReportProInterest(Base, BaseModel):
    __tablename__ = 'report_pro_interest'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    rpi_proid = Column(String(64), comment='ƷID')
    rpi_userid = Column(String(64), comment='ûid')
    rpi_interest_val = Column(INTEGER(5), comment='Ȥֵ')
    rpi_article_val = Column(INTEGER(5), comment='ֵ')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(String(3), comment='ɾʶ')


class ReportTeamAnalysi(Base, BaseModel):
    __tablename__ = 'report_team_analysis'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    ta_year = Column(INTEGER(5), comment='')
    ta_month = Column(INTEGER(5), comment='')
    ta_day = Column(INTEGER(5), comment='')
    ta_teamid = Column(String(64), comment='ŶID')
    ta_fullpathid = Column(String(1024), comment='Ŷȫ·ID')
    ta_name = Column(String(128), comment='Ŷ')
    ta_hdl = Column(BIGINT(11), comment='')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(String(3), comment='ɾʶ')


class Report(Base, BaseModel):
    __tablename__ = 'reports'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    rt_timetype = Column(String(3), comment='ʱ')
    rt_type = Column(String(3), comment='')
    rt_title = Column(String(128), comment='')
    rt_thumbnail = Column(String(256), comment='ͼ')
    rt_digest = Column(String(256), comment='ժҪ')
    rt_author = Column(String(64), comment='')
    rt_headerimg = Column(String(256), comment='ͷ')
    rt_content = Column(MEDIUMTEXT, comment='')
    rt_isoriginal = Column(String(3), comment='Ƿԭ')
    rt_label = Column(String(64), comment='ǩ')
    rt_fee_type = Column(String(3), comment='շ')
    rt_status = Column(String(3), comment='״̬')
    rt_release_time = Column(DateTime, comment='ϼʱ')
    rt_vip_price = Column(BIGINT(12), comment='vipԱ')
    rt_common_price = Column(BIGINT(12), comment='ͨԱ')
    rt_files = Column(MEDIUMTEXT, comment='')
    rt_collect_basenum = Column(BIGINT(8), comment='ղ')
    rt_collect_actualnum = Column(BIGINT(8), comment='ʵղ')
    rt_report_time = Column(DateTime, comment='ʱ')
    rt_read_basenum = Column(BIGINT(10), comment='Ķ')
    rt_read_actualnum = Column(BIGINT(10), comment='ʵĶ')
    createby = Column(String(64), comment='')
    createtime = Column(DateTime, comment='ʱ')
    updateby = Column(String(64), comment='޸')
    updatetime = Column(DateTime, comment='޸ʱ')
    deletetag = Column(String(3), comment='ɾʶ')


class RiskAssessment(Base, BaseModel):
    __tablename__ = 'risk_assessment'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    risk_name = Column(String(128), comment='')
    risk_description = Column(String(1024), comment='˵')
    risk_levels = Column(String(5120), comment='յȼ')
    risk_hight_score = Column(INTEGER(5), comment='߷')
    risk_status = Column(String(128), comment='״̬ 0: 1')
    risk_startime = Column(DateTime, comment='ʱ')
    risk_endtime = Column(DateTime, comment='ʱ')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    risk_expire = Column(INTEGER(3), comment='Чڣλ£')


class RiskAssessmentItem(Base, BaseModel):
    __tablename__ = 'risk_assessment_item'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    risk_id = Column(String(64), comment='ID')
    risk_group = Column(String(3), comment='( :riskAssType)')
    risk_item_type = Column(String(3), comment='')
    risk_item_stem = Column(String(512), comment='')
    risk_item_options = Column(String(5120), comment='ѡ')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class SensitiveWord(Base, BaseModel):
    __tablename__ = 'sensitive_word'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    sensitive_words = Column(Text, comment='дб')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class ShareCustom(Base, BaseModel):
    __tablename__ = 'share_custom'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    sc_type = Column(INTEGER(10), comment='ģ')
    sc_name = Column(String(64), comment='ģ')
    sc_title = Column(String(256), comment='')
    sc_desc = Column(String(256), comment='')
    sc_log = Column(String(256), comment='logo')
    org_id = Column(String(64), comment='')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class SharePoster(Base, BaseModel):
    __tablename__ = 'share_poster'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    sp_title = Column(String(64), comment='')
    sp_subhead = Column(String(64), comment='')
    sp_copywriter = Column(String(1024), comment='İ')
    sp_image = Column(String(256), comment='ͼƬ')
    at_copy = Column(String(1024), comment='״ιעİ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    sp_status = Column(String(3), comment='״̬')


class ShyhMonthPerformance(Base, BaseModel):
    __tablename__ = 'shyh_month_performance'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    perf_date = Column(Date, comment='')
    staff_no = Column(String(128), comment='Ա')
    staff_name = Column(String(128), comment='Ա')
    staff_mobile_phone = Column(String(128), comment='ֻ')
    staff_head_img = Column(String(256), comment='ͷ')
    source_grade = Column(String(128), comment='ǰȼ')
    branch_name = Column(String(128), comment='')
    sub_branch_name = Column(String(128), comment='֧')
    branch_network_name = Column(String(128), comment='')
    kpi_item1 = Column(DECIMAL(25, 10), comment='ǹļ')
    kpi_item1_rank = Column(INTEGER(10), comment='1')
    kpi_item2 = Column(DECIMAL(25, 10), comment='ļ')
    kpi_item2_rank = Column(INTEGER(10), comment='2')
    kpi_item3 = Column(DECIMAL(25, 10), comment='')
    kpi_item3_rank = Column(INTEGER(10), comment='3')
    kpi_item4 = Column(DECIMAL(25, 10), comment='Ƹҵ')
    kpi_item4_rank = Column(INTEGER(10), comment='4')
    kpi_item5 = Column(DECIMAL(25, 10), comment='վ100ԪϿͻ')
    kpi_item5_rank = Column(INTEGER(10), comment='5')
    kpi_item6 = Column(DECIMAL(25, 10), comment='Ŵʲ')
    kpi_item6_rank = Column(INTEGER(10), comment='6')
    kpi_item7 = Column(DECIMAL(25, 10), comment='')
    kpi_item7_rank = Column(INTEGER(10), comment='7')
    kpi_item8 = Column(DECIMAL(25, 10), comment='ÿ»')
    kpi_item8_rank = Column(INTEGER(10), comment='8')
    kpi_item9 = Column(DECIMAL(25, 10), comment='籣')
    kpi_item9_rank = Column(INTEGER(10), comment='9')
    cycleFlag = Column(String(128))
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(3), comment='ɾʶ')


class ShyhPerformance(Base, BaseModel):
    __tablename__ = 'shyh_performance'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    perf_date = Column(Date, comment='')
    staff_no = Column(String(128), comment='Ա')
    staff_name = Column(String(128), comment='Ա')
    staff_mobile_phone = Column(String(128), comment='ֻ')
    staff_head_img = Column(String(256), comment='ͷ')
    staff_region = Column(String(128), comment='')
    branch_name = Column(String(128), comment='')
    sub_branch_name = Column(String(128), comment='֧')
    branch_network_name = Column(String(128), comment='')
    source_grade = Column(String(128), comment='ǰȼ')
    target_grade = Column(String(128), comment='')
    kpi_item1 = Column(DECIMAL(25, 10), comment='ǹļ')
    kpi_item1_rank = Column(INTEGER(10), comment='1')
    kpi_item1_wow = Column(INTEGER(10), comment='1')
    kpi_item2 = Column(DECIMAL(25, 10), comment='ļ')
    kpi_item2_rank = Column(INTEGER(10), comment='2')
    kpi_item2_wow = Column(INTEGER(10), comment='2')
    kpi_item3 = Column(DECIMAL(25, 10), comment='')
    kpi_item3_rank = Column(INTEGER(10), comment='3')
    kpi_item3_wow = Column(INTEGER(10), comment='3')
    kpi_item4 = Column(DECIMAL(25, 10), comment='Ƹҵ')
    kpi_item4_rank = Column(INTEGER(10), comment='4')
    kpi_item4_wow = Column(INTEGER(10), comment='4')
    kpi_item5 = Column(DECIMAL(25, 10), comment='վ100ԪϿͻ')
    kpi_item5_rank = Column(INTEGER(10), comment='5')
    kpi_item5_wow = Column(INTEGER(10), comment='5')
    kpi_item6 = Column(DECIMAL(25, 10), comment='Ŵʲ')
    kpi_item6_rank = Column(INTEGER(10), comment='6')
    kpi_item6_wow = Column(INTEGER(10), comment='6')
    kpi_item7 = Column(DECIMAL(25, 10), comment='')
    kpi_item7_rank = Column(INTEGER(10), comment='7')
    kpi_item7_wow = Column(INTEGER(10), comment='7')
    kpi_item8 = Column(DECIMAL(25, 10), comment='ÿ»')
    kpi_item8_rank = Column(INTEGER(10), comment='8')
    kpi_item8_wow = Column(INTEGER(10), comment='8')
    kpi_item9 = Column(DECIMAL(25, 10), comment='籣')
    kpi_item9_rank = Column(INTEGER(10), comment='9')
    kpi_item9_wow = Column(INTEGER(10), comment='9')
    score1 = Column(DECIMAL(12, 10), comment='ҵ÷')
    score2 = Column(DECIMAL(12, 10), comment='ֵ׵÷')
    score3 = Column(DECIMAL(12, 10), comment='ۺϹ׵÷')
    add_score = Column(DECIMAL(12, 10), comment='ӷ')
    subtract_score = Column(DECIMAL(12, 10), comment='ͷ')
    add_score_item1 = Column(DECIMAL(12, 10), comment='')
    add_score_item2 = Column(DECIMAL(12, 10), comment='')
    add_score_item3 = Column(DECIMAL(12, 10), comment='ѵ')
    add_score_item4 = Column(DECIMAL(12, 10), comment='ӷ4')
    add_score_item5 = Column(DECIMAL(12, 10), comment='ӷ5')
    subtract_score_item1 = Column(DECIMAL(12, 10), comment='Ϲ漰ϴǮ')
    subtract_score_item2 = Column(DECIMAL(12, 10), comment='ʳ')
    subtract_score_item3 = Column(DECIMAL(12, 10), comment='3')
    subtract_score_item4 = Column(DECIMAL(12, 10), comment='4')
    subtract_score_item5 = Column(DECIMAL(12, 10), comment='5')
    grade_score = Column(DECIMAL(25, 10), comment='ȼ')
    rank1 = Column(INTEGER(10), comment='ȫ')
    rank2 = Column(INTEGER(10), comment='')
    ratio2 = Column(DECIMAL(10, 9), comment='ڱ')
    grade_desc = Column(String(128), comment='')
    star = Column(INTEGER(10), comment='Ǻϼ')
    star_rank = Column(INTEGER(10), comment='')
    star_item1 = Column(String(128), comment='ǻһ')
    star_item2 = Column(String(128), comment='ǻ')
    star_item3 = Column(String(128), comment='ǻ')
    star_item4 = Column(String(128), comment='ǻ')
    star_item5 = Column(String(128), comment='ǻ')
    star_item6 = Column(String(128), comment='ǻ')
    star_item7 = Column(String(128), comment='ǻ')
    star_item8 = Column(String(128), comment='ǻ')
    star_item9 = Column(String(128), comment='ǻ')
    star_item10 = Column(String(128), comment='ǻʮ')
    star_item1_name = Column(String(128))
    star_item2_name = Column(String(128))
    cycleFlag = Column(String(128), comment='µ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(3), comment='ɾʶ')
    star_item3_name = Column(String(128))
    star_item4_name = Column(String(128))
    star_item5_name = Column(String(128))
    star_item6_name = Column(String(128))
    star_item7_name = Column(String(128))
    star_item8_name = Column(String(128))
    star_item9_name = Column(String(128))
    star_item10_name = Column(String(128))


class ShyhWeekPerformance(Base, BaseModel):
    __tablename__ = 'shyh_week_performance'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    perf_date = Column(Date, comment='')
    staff_no = Column(String(128), comment='Ա')
    staff_name = Column(String(128), comment='Ա')
    staff_mobile_phone = Column(String(128), comment='ֻ')
    staff_head_img = Column(String(256), comment='ͷ')
    source_grade = Column(String(128), comment='ǰȼ')
    branch_name = Column(String(128), comment='')
    sub_branch_name = Column(String(128), comment='֧')
    branch_network_name = Column(String(128), comment='')
    kpi_item1 = Column(DECIMAL(25, 10), comment='ǹļ')
    kpi_item1_rank = Column(INTEGER(10), comment='1')
    kpi_item2 = Column(DECIMAL(25, 10), comment='ļ')
    kpi_item2_rank = Column(INTEGER(10), comment='2')
    kpi_item3 = Column(DECIMAL(25, 10), comment='')
    kpi_item3_rank = Column(INTEGER(10), comment='3')
    kpi_item4 = Column(DECIMAL(25, 10), comment='Ƹҵ')
    kpi_item4_rank = Column(INTEGER(10), comment='4')
    kpi_item5 = Column(DECIMAL(25, 10), comment='վ100ԪϿͻ')
    kpi_item5_rank = Column(INTEGER(10), comment='5')
    kpi_item6 = Column(DECIMAL(25, 10), comment='Ŵʲ')
    kpi_item6_rank = Column(INTEGER(10), comment='6')
    kpi_item7 = Column(DECIMAL(25, 10), comment='')
    kpi_item7_rank = Column(INTEGER(10), comment='7')
    kpi_item8 = Column(DECIMAL(25, 10), comment='ÿ»')
    kpi_item8_rank = Column(INTEGER(10), comment='8')
    kpi_item9 = Column(DECIMAL(25, 10), comment='籣')
    kpi_item9_rank = Column(INTEGER(10), comment='9')
    cycleFlag = Column(String(128))
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(3), comment='ɾʶ')


class SkuInfo(Base, BaseModel):
    __tablename__ = 'sku_info'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    si_type = Column(String(3), comment='')
    si_name = Column(String(32), comment='')
    si_code = Column(String(16), comment='')
    si_pattern = Column(String(3), comment='ģʽ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class SkuPrice(Base, BaseModel):
    __tablename__ = 'sku_price'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    sp_type = Column(String(3), comment=' 0γ 1: 2vipֵ 3:˻ֵ')
    sp_id = Column(String(32), comment='ƷID')
    sp_si_id = Column(String(32), comment='ID')
    sp_price = Column(BIGINT(12), comment='ͨԱ۸')
    sp_vip_price = Column(BIGINT(12), comment='vip۸')
    sp_line_price = Column(BIGINT(12))
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class Smsrecord(Base, BaseModel):
    __tablename__ = 'smsrecord'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    leixing = Column(String(3), comment='')
    phone = Column(String(32), comment='ֻ')
    content = Column(String(128), comment='')
    createby = Column(String(64), comment='')
    createtime = Column(DateTime, comment='ʱ')
    updateby = Column(String(64), comment='޸')
    updatetime = Column(DateTime, comment='޸ʱ')
    deletetag = Column(String(3), comment='ɾʶ')


class SubjectColumn(Base, BaseModel):
    __tablename__ = 'subject_column'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    sc_name = Column(String(128), comment='')
    sc_type = Column(String(3), comment='')
    sc_thumbnail = Column(String(256), comment='ͼ')
    sc_backgroundimg = Column(String(256), comment='ͼ')
    sc_briefinfo = Column(String(512), comment='')
    sc_content_basenum = Column(BIGINT(10), comment='ƪ')
    sc_content_actualnum = Column(BIGINT(10), comment='ƪʵ')
    sc_follow_basenun = Column(BIGINT(10), comment='ע')
    sc_follow_actualnum = Column(BIGINT(10), comment='עʵ')
    sc_ishot = Column(String(3), comment='Ƿ')
    sc_status = Column(String(3), comment='״̬')
    sc_lastupdatetime = Column(DateTime, comment='ʱ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class SubjectSelection(Base, BaseModel):
    __tablename__ = 'subject_selection'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    subject_id = Column(String(128), comment='רid')
    selection_type = Column(INTEGER(64), comment='')
    selection_id = Column(String(64), comment='ID')
    selection_reason = Column(String(256), comment='ѡ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class SysConstant(Base, BaseModel):
    __tablename__ = 'sys_constant'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    constant_group = Column(String(64), comment='')
    constant_code = Column(String(64), comment='ʶ')
    constant_name = Column(String(64), comment='')
    constant_value = Column(String(256), comment='ֵ')
    constant_description = Column(String(128), comment='')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    cd_paixu = Column(INTEGER(3), comment='')
    cd_show = Column(INTEGER(3))


class SysFunction(Base, BaseModel):
    __tablename__ = 'sys_function'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    function_name = Column(String(80), comment='')
    function_type = Column(INTEGER(128), comment='')
    is_check = Column(INTEGER(128), comment='Ƿ֤Ȩ')
    p_id = Column(String(64), comment='˵Id')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class SysRole(Base, BaseModel):
    __tablename__ = 'sys_role'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    role_name = Column(String(80), comment='ɫ')
    acl = Column(String(6000), comment='Ȩб')
    org_id = Column(String(64), comment='Id')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class SysSwitch(Base, BaseModel):
    __tablename__ = 'sys_switch'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    switch_group = Column(String(64), comment='ط')
    switch_code = Column(String(64), comment='رʶ')
    switch_name = Column(String(64), comment='')
    switch_description = Column(String(128), comment='')
    switch_value = Column(String(64), comment='ֵ')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class SysUser(Base, BaseModel):
    __tablename__ = 'sys_user'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    user_name = Column(String(80), comment='û')
    user_account = Column(String(80), comment='˺')
    user_password = Column(String(80), comment='')
    user_state = Column(INTEGER(128), comment='û״̬')
    user_roles = Column(String(6000), comment='ûɫб')
    org_id = Column(String(64), comment='Id')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    is_user = Column(String(3), comment='Ƿû')
    department = Column(String(64), comment='')


class SystemNotice(Base, BaseModel):
    __tablename__ = 'system_notice'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    sn_type = Column(String(64), comment='')
    sn_content = Column(String(512), comment='')
    sn_isshow = Column(String(3), comment='չʾ״̬')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


t_system_switch = Table(
    'system_switch', metadata,
    Column('id', String(64), nullable=False, server_default=text("''"), comment='Ψһ'),
    Column('ss_name', String(64), comment=''),
    Column('ss_key', String(64), comment='key'),
    Column('ss_value', String(64), comment='value'),
    Column('ss_desc', String(256), comment=''),
    Column('createtime', DateTime, comment='ʱ'),
    Column('createby', String(64), comment=''),
    Column('updatetime', DateTime, comment='޸ʱ'),
    Column('updateby', String(64), comment='޸'),
    Column('deletetag', String(3), comment='ɾʶ')
)


class Tag(Base, BaseModel):
    __tablename__ = 'tag'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    tag_name = Column(String(20), comment='ǩ')
    tag_category_id = Column(String(64), comment='')
    tag_remark = Column(String(128), comment='ע')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class TagCategory(Base, BaseModel):
    __tablename__ = 'tag_category'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    category_name = Column(String(20), comment='')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


t_tag_rel = Table(
    'tag_rel', metadata,
    Column('id', String(64), nullable=False, comment='id'),
    Column('tag_id', String(64), nullable=False, index=True, comment='ǩid'),
    Column('rel_id', String(64), nullable=False, index=True, comment='id'),
    Column('rel_type', INTEGER(1), nullable=False, comment=''),
    Column('tag_category_id', String(64), nullable=False, comment='ǩ'),
    Column('tag_category_name', String(64), nullable=False, comment='ǩ'),
    Column('create_time', DateTime, nullable=False, comment='ʱ')
)


class TaskSchedule(Base, BaseModel):
    __tablename__ = 'task_schedule'
    __table_args__ = (
        Index('activity_id_create_by', 'activity_id', 'create_by', unique=True),
        {'comment': 'ȱ'}
    )

    id = Column(String(64, 'utf8mb4_unicode_ci'), primary_key=True)
    activity_id = Column(String(64, 'utf8mb4_unicode_ci'), nullable=False, comment='id id')
    create_by = Column(String(64, 'utf8mb4_unicode_ci'), nullable=False, comment='')
    task_pro_send = Column(String(255, 'utf8mb4_unicode_ci'))
    ext1 = Column(String(50, 'utf8mb4_unicode_ci'), comment='չֶ')
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    task_status = Column(INTEGER(3), nullable=False, server_default=text("'1'"), comment='1 2:֪ͨ')
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))


class Team(Base, BaseModel):
    __tablename__ = 'team'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    team_name = Column(String(80), comment='Ŷ')
    p_id = Column(String(64), comment='ϼŶId')
    full_path_id = Column(String(1024), comment='ȫ·')
    org_id = Column(String(64), comment='Id')
    full_path_name = Column(String(1024))
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(String(3), comment='ɾʶ')
    team_category = Column(INTEGER(128), comment='Ŷ')
    team_nature = Column(String(64), comment='Ŷҵ')
    free_join_switch = Column(INTEGER(128), comment='ɼ뿪')
    free_withdrawal_switch = Column(INTEGER(128), comment='˳')
    recruitment_switch = Column(INTEGER(128), comment='ֹͣļ')
    closed_switch = Column(INTEGER(128), comment='ֹͣӪ')
    team_desc = Column(String(128), comment='˵')
    content_reviewer = Column(Text, comment='')


class TeamArticle(Base, BaseModel):
    __tablename__ = 'team_article'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    article_id = Column(String(64), comment='Id')
    team_id = Column(String(64), comment='ŶId')
    article_type = Column(INTEGER(11), comment='')
    org_id = Column(String(64))
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class TeamProduct(Base, BaseModel):
    __tablename__ = 'team_product'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    product_id = Column(String(64), comment='ƷId')
    team_id = Column(String(64), comment='ŶId')
    org_id = Column(String(64))
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


t_test = Table(
    'test', metadata,
    Column('id', INTEGER(11)),
    Column('createby', String(12)),
    Column('faid', String(12))
)


class ThreadTask(Base, BaseModel):
    __tablename__ = 'thread_task'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    task_name = Column(String(128), comment='')
    task_type = Column(String(3), comment='')
    task_status = Column(String(3), comment='״̬')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(3), comment='ɾʶ')


class UbrFauser(Base, BaseModel):
    __tablename__ = 'ubr_fauser'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    uf_uid = Column(String(64), comment='ʦID')
    uf_uname = Column(String(32), comment='ʦ')
    uf_headimg = Column(String(256), comment='ʦͷ')
    uf_shenfen = Column(String(3), comment='ʦ')
    uf_grade = Column(String(64), comment='ȼ')
    uf_target_grade = Column(String(256))
    us_bumen = Column(String(256))
    uf_urcid = Column(String(64), comment='ڻID')
    uf_share_num = Column(BIGINT(8), comment='ܴ')
    uf_browse_personnum = Column(BIGINT(8), comment='ÿ')
    uf_browse_num = Column(BIGINT(8), comment='ÿ')
    uf_forward_personnum = Column(BIGINT(8), comment='ÿת')
    uf_forward_num = Column(BIGINT(8), comment='ÿת')
    uf_browse_visitors = Column(Text, comment='ķÿ')
    uf_forward_visitors = Column(Text, comment='תķÿ')
    uf_article_share_num = Column(BIGINT(8), comment='·ܴ')
    uf_article_browse_personnum = Column(BIGINT(8), comment='·ÿ')
    uf_article_browse_num = Column(BIGINT(8), comment='·ÿ')
    uf_article_forward_personnum = Column(BIGINT(8), comment='·ÿת')
    uf_article_forward_num = Column(BIGINT(8), comment='·ÿת')
    uf_article_browse_visitors = Column(Text, comment='ķÿ')
    uf_article_forward_visitors = Column(Text, comment='תķÿ')
    uf_pro_share_num = Column(BIGINT(8), comment='Ʒܴ')
    uf_pro_browse_personnum = Column(BIGINT(8), comment='Ʒÿ')
    uf_pro_browse_num = Column(BIGINT(8), comment='Ʒÿ')
    uf_pro_forward_personnum = Column(BIGINT(8), comment='Ʒÿת')
    uf_pro_forward_num = Column(BIGINT(8), comment='Ʒÿת')
    uf_pro_browse_visitors = Column(Text, comment='ղƷķÿ')
    uf_pro_forward_visitors = Column(Text, comment='ղƷתķÿ')
    uf_company_share_num = Column(BIGINT(8), comment='˾ܴ')
    uf_company_browse_personnum = Column(BIGINT(8), comment='˾ÿ')
    uf_company_browse_num = Column(BIGINT(8), comment='˾ÿ')
    uf_company_forward_personnum = Column(BIGINT(8), comment='˾ÿת')
    uf_company_forward_num = Column(BIGINT(8), comment='˾ÿת')
    uf_company_browse_visitors = Column(Text, comment='չ˾ķÿ')
    uf_company_forward_visitors = Column(Text, comment='չ˾תķÿ')
    uf_mp_sharen_num = Column(BIGINT(8), comment='Ƭܴ')
    uf_mp_browse_personnum = Column(BIGINT(8), comment='Ƭÿ')
    uf_mp_browse_num = Column(BIGINT(8), comment='Ƭÿ')
    uf_mp_forward_personnum = Column(BIGINT(8), comment='Ƭÿת')
    uf_mp_forward_num = Column(BIGINT(8), comment='Ƭÿת')
    uf_mp_browse_visitors = Column(Text, comment='Ƭķÿ')
    uf_mp_forward_visitors = Column(Text, comment='Ƭתķÿ')
    uf_article_tybg_share_num = Column(BIGINT(8), comment='·ܴ')
    uf_teamid = Column(String(1024), comment='Ŷ')
    uf_date = Column(Date, comment='')
    uf_orgid = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    uf_article_ppxc_browse_personnum = Column(BIGINT(8))
    uf_article_ppxc_share_num = Column(BIGINT(8))
    uf_article_tybg_browse_personnum = Column(BIGINT(8))
    uf_article_browse_visitors_tybg = Column(Text)
    uf_article_browse_visitors_ppxc = Column(Text)
    uf_activity_share_num = Column(BIGINT(8))
    uf_activity_browse_personnum = Column(BIGINT(8))
    uf_activity_browse_visitors = Column(Text)
    uf_wq_num = Column(INTEGER(11))
    uf_huiwu_share_num = Column(BIGINT(8))
    uf_huiwu_browse_personnum = Column(BIGINT(20))
    uf_huiwu_browse_num = Column(BIGINT(20))
    uf_huiwu_forward_personnum = Column(BIGINT(20))
    uf_huiwu_forward_num = Column(BIGINT(20))
    uf_peixu_timelength = Column(BIGINT(20))
    uf_peixu_canyunum = Column(BIGINT(20))
    uf_peixu_baklooknum = Column(BIGINT(20))
    uf_peixu_ids = Column(Text)


class UbrGrade(Base, BaseModel):
    __tablename__ = 'ubr_grade'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ug_name = Column(String(16), comment='ȼ')
    uf_orgid = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UbrRankCycle(Base, BaseModel):
    __tablename__ = 'ubr_rank_cycle'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    urc_name = Column(String(256), comment='')
    urc_starttime = Column(Date, comment='ʼʱ')
    urc_endtime = Column(Date, comment='ʱ')
    urc_status = Column(String(3), comment='״̬')
    urc_range = Column(String(3), comment='ͳƶԱȷΧ')
    urc_content_type = Column(String(3), comment='')
    uf_orgid = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UbrRankCycleDetail(Base, BaseModel):
    __tablename__ = 'ubr_rank_cycle_detail'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    urcd_urcid = Column(String(64), comment='ڻID')
    urcd_type = Column(String(3), comment='')
    urcd_refid = Column(String(64), comment='Id')
    urcd_title = Column(String(256), comment='')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UbrSharesource(Base, BaseModel):
    __tablename__ = 'ubr_sharesource'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    us_fausers_id = Column(String(64))
    us_uname = Column(String(128))
    us_urcid = Column(String(64), comment='ڻID')
    us_shenfen = Column(String(32))
    us_bumen = Column(String(256))
    us_type = Column(String(64), comment='Դ')
    us_title = Column(String(256), comment='Դ')
    us_refid = Column(String(64), comment='ԴID')
    us_share_personnum = Column(BIGINT(8), comment='')
    us_share_num = Column(BIGINT(8), comment='')
    us_browse_personnum = Column(BIGINT(8), comment='')
    us_browse_num = Column(BIGINT(8), comment='ʴ')
    us_forword_personnum = Column(BIGINT(8), comment='ת')
    us_forword_num = Column(BIGINT(8), comment='ת')
    us_date = Column(Date, comment='')
    us_orgid = Column(String(64), comment='ID')
    us_browse_visitors = Column(Text, comment='ķÿ')
    us_forward_visitors = Column(Text, comment='תķÿ')
    us_share_fausers = Column(Text, comment='շʦ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    us_headimg = Column(String(256))
    us_grade = Column(String(64))
    us_target_grade = Column(String(256))


class UserActivity(Base, BaseModel):
    __tablename__ = 'user_activity'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    user_id = Column(String(64), comment='ûId')
    activity_id = Column(String(64), comment='Id')
    org_id = Column(String(64), comment='Id')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UserApplication(Base, BaseModel):
    __tablename__ = 'user_application'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    username = Column(String(64), comment='')
    mobile_phone = Column(String(64), comment='ֻ')
    wechat_id = Column(String(64), comment='΢ź')
    company_name = Column(String(128), comment='˾')
    photo = Column(String(1024), comment='Ƭ')
    state = Column(INTEGER(3), comment='״̬')
    reviewer = Column(String(64), comment='')
    review_comment = Column(String(1024), comment='')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), index=True, comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    score = Column(INTEGER(3), server_default=text("'0'"), comment='÷')


class UserApplicationQuestion(Base, BaseModel):
    __tablename__ = 'user_application_question'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    user_application_id = Column(String(64), comment='ûId')
    q_type = Column(String(3), comment='Ŀ')
    q_title = Column(String(512), comment='')
    q_option = Column(String(1024), comment='ѡ')
    q_required = Column(INTEGER(3), comment='Ƿ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), index=True, comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    template_id = Column(String(64), comment='ģid')
    score = Column(INTEGER(3), server_default=text("'0'"), comment='÷')
    answer = Column(String(255), comment='')


class UserAuth(Base, BaseModel):
    __tablename__ = 'user_auth'
    __table_args__ = {'comment': 'ɫܱ'}

    id = Column(String(64), primary_key=True)
    ua_type = Column(String(16), nullable=False, comment='Ȩ')
    ua_roles = Column(String(64), nullable=False, comment='ҪɫѡegR1&S1')
    ua_source_id = Column(String(64), nullable=False, comment='ԴID')
    ua_desc = Column(String(255), nullable=False, comment='')
    create_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    update_by = Column(String(64))
    update_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(3), nullable=False, server_default=text("'0'"))
    create_by = Column(String(64))


class UserBehaviorRecord(Base, BaseModel):
    __tablename__ = 'user_behavior_record'
    __table_args__ = (
        Index('idx_routerurl_type', 'ubr_routerurl', 'ubr_type'),
    )

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ubr_type = Column(String(3), comment='')
    ubr_login_time = Column(DateTime, comment='½ʱ')
    ubr_logout_time = Column(DateTime, comment='ǳʱ')
    ubr_total_time = Column(BIGINT(8), comment='ۼʱ')
    ubr_last_time = Column(DateTime, comment='һͳʱ')
    ubr_source = Column(String(8), comment='Դ')
    ubr_deviceid = Column(String(128), comment='豸Ψһʶ')
    ubr_channel = Column(String(128), index=True, comment='')
    ubr_appversion = Column(String(16), comment='汾')
    ubr_pid_deviceid = Column(String(128), comment='Դ豸ID')
    ubr_pid_userid = Column(String(128), comment='ԴûID')
    ubr_utype = Column(String(3), comment='û')
    ubr_ushenfen = Column(String(3), comment='û')
    fromto = Column(String(256), comment='ϼ')
    ubr_routerurl = Column(String(256), comment='·')
    ubr_isshare = Column(String(3), comment='ǰǷڷ')
    ubr_ext1 = Column(String(128), comment='չֶ1')
    ubr_ext2 = Column(String(128), index=True, comment='չֶ2')
    ubr_ext3 = Column(String(128), comment='չֶ3')
    ubr_ext4 = Column(String(128), comment='չ4')
    ubr_ext5 = Column(String(128), comment='չ5')
    ubr_ext6 = Column(String(128), comment='չ6')
    ubr_ext7 = Column(String(128), comment='չ7')
    ubr_ext8 = Column(String(128), comment='չ8')
    ubr_ext9 = Column(String(128), comment='ؾID')
    ubr_ext10 = Column(String(1024), comment='»Ʒǩ')
    ubr_ext11 = Column(String(128))
    ubr_browse_uuid = Column(String(128), comment='ҳͣʶ')
    ubr_uuid = Column(String(128), comment='ԴID')
    ubr_source_refid = Column(String(128), comment='Դ')
    ubr_time_length = Column(BIGINT(8), comment='ͣʱ룩')
    ubr_openid = Column(String(128), comment='openid')
    ubr_user_links = Column(Text, comment='ͻ·')
    ubr_share_source = Column(String(128), comment='ȥʶ')
    ubr_toxcx = Column(String(16), comment='Сʽ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    ubr_team_id = Column(String(128), comment='ŶId')
    ubr_teamid = Column(String(128), comment='ʦŶID')
    ubr_full_teamid = Column(String(128), comment='ʦŶȫ·')
    ubr_time_process = Column(String(32))


class UserChannel(Base, BaseModel):
    __tablename__ = 'user_channel'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    channel_id = Column(String(64), comment='id')
    channel_name = Column(String(256), comment='')
    delete_tag = Column(INTEGER(1), comment='߼ɾ־λ')
    create_time = Column(DateTime, comment='ʱ')
    update_time = Column(DateTime, comment='Ƹʱ')
    create_by = Column(String(64), comment='')


class UserClock(Base, BaseModel):
    __tablename__ = 'user_clock'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    uc_type = Column(String(3), comment='')
    uc_status = Column(String(3), comment='ͻ״̬')
    uc_memberno = Column(String(128), comment='Ա')
    uc_reason = Column(String(512), comment='')
    uc_address = Column(String(256), comment='ַ')
    uc_lnt = Column(String(64), comment='')
    uc_lat = Column(String(64), comment='γ')
    uc_time = Column(DateTime, comment='λʱ')
    org_id = Column(String(64), comment='ID')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UserClueMessage(Base, BaseModel):
    __tablename__ = 'user_clue_message'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ucm_userid = Column(String(64), comment='ͻID')
    ucm_content = Column(String(1024), comment='Ϣ')
    ucm_timelength = Column(BIGINT(8), comment='Ķʱ')
    ucm_source = Column(String(64), comment='Դ')
    ucm_propagation_path = Column(Text, comment='·')
    ucm_type = Column(String(3), comment='Ϣ')
    ucm_read_status = Column(String(3), comment='Ķ״̬')
    ucm_who_send = Column(String(3), comment='Ϣͷ')
    ucm_faid = Column(String(64), comment='ʦID')
    ucm_refid = Column(String(64), comment='ID')
    ucm_ubrid = Column(String(64), comment='Ϊ¼id')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    msg_body = Column(String(8000), comment='Ϣ')


class UserComment(Base, BaseModel):
    __tablename__ = 'user_comment'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    uc_ref_id = Column(String(64), comment='ID')
    uc_category = Column(INTEGER(1), comment='')
    uc_content = Column(String(1024), comment='')
    uc_status = Column(INTEGER(128), comment='״̬')
    uc_is_excellent = Column(INTEGER(128), comment='Ƿѡ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class UserCompany(Base, BaseModel):
    __tablename__ = 'user_company'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    uc_fileid = Column(String(64), comment='ID')
    uc_documentid = Column(String(64), comment='ٶĵID')
    uc_filename = Column(String(128), comment='ļ')
    uc_watermark = Column(String(128), comment='ˮӡ')
    uc_logo = Column(String(128), comment='logo')
    uc_name = Column(String(128), comment='˾')
    uc_telephone = Column(String(128), comment='˾绰')
    uc_address = Column(String(512), comment='˾ַ')
    uc_info = Column(String(1024), comment='˾')
    uc_mien = Column(String(1024), comment='˾')
    org_id = Column(String(64), comment='Id')
    uc_show_type = Column(String(3), comment='չʾ 0pdf 1ͼƬ')
    uc_info_detail = Column(Text)
    uc_intro = Column(Text, comment='˾')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UserCustomer(Base, BaseModel):
    __tablename__ = 'user_customer'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    uc_openid = Column(String(128), comment='openid\\n')
    uc_source = Column(String(64), comment='Դ')
    uc_unionid = Column(String(128), comment='unionId')
    uc_userid = Column(String(64), comment='ûid')
    uc_headimg = Column(String(256), comment='ͷ')
    uc_nickname = Column(String(32), comment='ǳ')
    uc_name = Column(String(32), comment='')
    uc_phone = Column(String(16), comment='ֻ')
    uc_faid = Column(String(64), comment='ʦID')
    org_id = Column(String(128), comment='')
    beizhu = Column(String(512), comment='ע')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(INTEGER(1), comment='ɾʶ')
    uc_contact_time_isopen = Column(String(3))
    uc_contact_time = Column(String(128), comment='ϵʱ')
    uc_hobby_isopen = Column(String(3))
    uc_hobby = Column(String(128))
    uc_marriage_isopen = Column(String(3))
    uc_marriage = Column(String(3))
    uc_native_isopen = Column(String(8))
    uc_native = Column(String(64))
    uc_position_isopen = Column(String(8))
    uc_position = Column(String(128))
    uc_work_isopen = Column(String(3))
    uc_work = Column(String(128))
    uc_adress_isopen = Column(String(3))
    uc_adress = Column(String(512))
    uc_email_isopen = Column(String(3))
    uc_email = Column(String(128))
    uc_birthday_isopen = Column(String(3))
    uc_birthday = Column(DateTime, comment='')
    uc_sex_isopen = Column(String(3))
    uc_sex = Column(String(3))
    uc_status = Column(INTEGER(3), comment='ͻ״̬')


class UserCustomerProcessRecord(Base, BaseModel):
    __tablename__ = 'user_customer_process_record'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    customer_visitorid = Column(String(64), comment='ͻID')
    customer_content = Column(String(512), comment='')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(INTEGER(1), comment='ɾʶ')
    customer_status = Column(INTEGER(3), comment='ͻ״̬')
    deal_pro_id = Column(String(64), comment='ɽƷId')
    deal_datetime = Column(DateTime, comment='ɽʱ')


class UserEvaluate(Base, BaseModel):
    __tablename__ = 'user_evaluate'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ue_name = Column(String(32), comment='ͻ')
    ue_position = Column(String(32), comment='ͻְλ')
    ue_company = Column(String(128), comment='ڹ˾')
    ue_introduction = Column(String(512), comment='ͻ')
    ue_content = Column(String(1024), comment='')
    ue_type = Column(String(3), comment='')
    ue_invite_status = Column(String(3), comment='״̬')
    ue_show_status = Column(String(3), comment='չʾ״̬')
    ue_top_status = Column(String(3), comment='ö״̬')
    ue_top_time = Column(DateTime, comment='öʱ')
    ue_evaluator_id = Column(String(64), comment='ID')
    ue_be_evaluator_id = Column(String(64), comment='')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UserExam(Base, BaseModel):
    __tablename__ = 'user_exam'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ex_id = Column(String(64), comment='ԾģID')
    ex_name = Column(String(256), comment='Ծ')
    ex_starttime = Column(DateTime, comment='Կʼʱ')
    ex_endtime = Column(DateTime, comment='Խʱ')
    ex_totalscore = Column(INTEGER(5), comment='')
    ex_passscore = Column(INTEGER(5), comment='ϸ')
    ex_done_examconid = Column(String(64), comment='ǰĿ')
    ex_resscore = Column(INTEGER(5), comment='÷')
    ex_status = Column(String(3), comment='״̬')
    org_id = Column(String(64), comment='ID')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UserExamContent(Base, BaseModel):
    __tablename__ = 'user_exam_content'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ex_id = Column(String(64), comment='ԾģID')
    u_ex_id = Column(String(64), comment='ûԾID')
    ec_type = Column(String(3), comment='Ŀ')
    ec_title = Column(String(512), comment='')
    ec_content = Column(String(1024), comment='ѡ')
    ec_right = Column(String(64), comment='ȷ')
    ec_score = Column(INTEGER(5), comment='Ŀ')
    ec_answer = Column(String(64), comment='û')
    ear_resscore = Column(INTEGER(5), comment='÷')
    org_id = Column(String(64), comment='ID')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UserFinprore(Base, BaseModel):
    __tablename__ = 'user_finprores'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    pro_id = Column(String(64), comment='ƷID')
    org_id = Column(String(64), comment='ID')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    is_recommend = Column(INTEGER(1), comment='ҳչʾ')
    team_id = Column(String(64))
    team_full_path = Column(String(1024))


class UserImpressionLabel(Base, BaseModel):
    __tablename__ = 'user_impression_label'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    uil_label_id = Column(String(64), comment='ӡǩID')
    uil_label = Column(String(64), comment='ӡǩ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class UserImpressionLabelZan(Base, BaseModel):
    __tablename__ = 'user_impression_label_zan'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    uil_label_id = Column(String(64), comment='ûѡӡǩID')
    uil_faId = Column(String(64), comment='ӡǩ޼¼')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class UserIndex(Base, BaseModel):
    __tablename__ = 'user_index'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    fa_id = Column(String(64), comment='ʦId')
    index_date = Column(Date, comment='')
    follow_index = Column(DECIMAL(6, 2), comment='עָ')
    fission_index = Column(DECIMAL(6, 2), comment='ѱָ')
    visitor = Column(DECIMAL(6, 2), comment='ָ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class UserInfo(Base, BaseModel):
    __tablename__ = 'user_info'

    id = Column(VARCHAR(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ui_openid = Column(String(128), comment='΢openId')
    ui_unionId = Column(String(64), comment='unionId')
    ui_telphone = Column(String(16), comment='ֻ')
    ui_pwd = Column(String(64), comment='¼')
    ui_nickname = Column(VARCHAR(64), comment='ǳ')
    ui_headimg = Column(String(256), comment='ͷ')
    ui_username = Column(VARCHAR(64), comment='')
    ui_sex = Column(String(3), comment='Ա 0 1Ů')
    ui_birthday = Column(DateTime, comment='')
    ui_introduction = Column(VARCHAR(256), comment='˽')
    ui_type_mp = Column(String(3), comment='Ƭʽ 0СƬ 1Ƭ')
    ui_headimg_mp = Column(String(256), comment='Ƭͷ')
    ui_username_mp = Column(VARCHAR(32), comment='Ƭ')
    ui_telphone_mp = Column(String(16), comment='Ƭ绰')
    ui_mobilephone_mp = Column(String(16), comment='ֻ')
    ui_company_mp = Column(String(128), comment='Ƭ˾')
    ui_company_address_mp = Column(String(128), comment='Ƭ˾ַ')
    ui_position_mp = Column(VARCHAR(128), comment='Ƭְλ')
    ui_industry_mp = Column(String(128), comment='ҵ')
    ui_email_mp = Column(String(128), comment='Ƭ')
    ui_introduction_mp = Column(VARCHAR(256), comment='Ƭ˽')
    ui_wechat_qrcode = Column(String(256), comment='΢Ÿ˶άƬ')
    ui_wechat_xcx_qrcode = Column(String(256), comment='Сά')
    ui_type = Column(String(3), comment=' 0appע 1ƽ̨')
    ui_shenfen = Column(String(3), comment='û 0ͨû 1û 2û')
    ui_rzstatus = Column(INTEGER(3), comment='֤״̬ 0:δ֤ 1:֤')
    org_id = Column(String(64), comment='Id')
    team_id = Column(String(64), comment='ŶId')
    join_time = Column(DateTime, comment='Ŷʱ')
    staff_no = Column(VARCHAR(128), comment='Ա')
    investor_certified_status = Column(INTEGER(128), comment='ϸͶ֤״̬')
    investor_certified_time = Column(DateTime, comment='ϸͶ֤ʱ')
    to_partner = Column(String(3), comment='Ȩ')
    ui_grade = Column(String(64), comment='ȼ')
    content_review = Column(INTEGER(1), comment='')
    ui_honor = Column(String(256), comment='')
    ui_hb_userid = Column(String(64), comment='ɨעں')
    staff_region = Column(String(128))
    branch_name = Column(String(128))
    sub_branch_name = Column(String(128))
    branch_network_name = Column(String(128))
    ui_grade_name = Column(String(128))
    ui_target_grade_name = Column(String(256))
    ui_source = Column(String(32))
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    front_roles = Column(String(128), comment='ǰ˽ɫ')
    ui_check_status = Column(INTEGER(3), comment='Ƭ')
    city = Column(String(64))
    province = Column(String(64))
    country = Column(String(64))
    ui_inviter = Column(String(32))
    ui_inviter_phone = Column(String(32))
    ui_age = Column(INTEGER(3))
    ui_region = Column(String(128))
    ui_wecaht = Column(String(128))
    ui_inviter_time = Column(DateTime)
    unionid = Column(String(100), comment='΢unionId')
    level = Column(INTEGER(11), comment='0οͣ1עû2ʦ')
    age = Column(INTEGER(11), comment='')
    district = Column(String(64), comment='')
    address = Column(String(300), comment='ϸַ')
    education = Column(INTEGER(11), comment='ѧ0: δ֪1רƣ2ƣ3211ƣ4˶ʿ')
    wechat = Column(String(60), comment='΢ź')
    high_worth_customer_num = Column(INTEGER(11), comment='߾ֵͻ0:ޣ1:10һ£2:10-30ˣ3:30-50ˣ4:50ϣ')
    customer_asset = Column(INTEGER(11), comment='߾ֵͻʲã0ޣ1:100һ£2:100-2003:200-4004:400-6005:600ϣ')
    financial_planner = Column(INTEGER(1), comment='Ƿʦ')
    vip_end_time = Column(DateTime, comment='Աʱ')
    ui_register_time = Column(DateTime)
    ui_auth = Column(String(256), comment='Ȩ޼ Ӣ;ָS1-Ӫ')
    ui_channel = Column(String(32))
    review_time = Column(DateTime, comment='ʱ')
    ui_apple_userid = Column(String(256), comment='ƻȨûid')
    ifa_no = Column(String(20), comment='ʦ')
    realname = Column(String(32), comment='ʵӪά')


class UserInfoExt(Base, BaseModel):
    __tablename__ = 'user_info_ext'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    uie_userid = Column(String(64), comment='ûID')
    uie_uselogo = Column(String(256), comment='ûǰʹõԶlogo')
    uie_uploadlogo = Column(String(256), comment='ûϴԶlogo')
    uie_hbimg = Column(String(256))
    ui_setting = Column(String(5120), comment='û')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(INTEGER(1), comment='ɾʶ')
    ui_peixun_notice = Column(INTEGER(3), comment='ѵǱ֪ͨ')
    ui_huiwu_notice = Column(INTEGER(3), comment='Ǳ֪ͨ')
    ui_pro_notice = Column(INTEGER(3), comment='ƷǱ֪ͨ')
    service_year = Column(INTEGER(3), comment='')
    service_personnum = Column(INTEGER(8), comment='')
    sales_share = Column(String(64), comment='۷ݶ')
    weshop_poster = Column(String(2048), comment='΢ģ')
    weshop_poster_new = Column(Text, comment='΢ģ棨°棩')


t_user_info_history = Table(
    'user_info_history', metadata,
    Column('id', String(128), comment='Ψһ'),
    Column('ui_openid', String(128), comment='΢openId'),
    Column('ui_telphone', String(16), comment='ֻ'),
    Column('ui_nickname', String(64), comment='ǳ'),
    Column('ui_headimg', String(256), comment='ͷ'),
    Column('ui_username', String(64), comment=''),
    Column('ui_sex', String(3), comment='Ա'),
    Column('ui_birthday', DateTime, comment=''),
    Column('ui_introduction', String(256), comment='˽'),
    Column('ui_type_mp', String(3), comment='Ƭʽ'),
    Column('ui_headimg_mp', String(256), comment='Ƭͷ'),
    Column('ui_username_mp', String(32), comment='Ƭ'),
    Column('ui_telphone_mp', String(16), comment='Ƭ绰'),
    Column('ui_mobilephone_mp', String(16), comment='Ƭֻ'),
    Column('ui_company_mp', String(128), comment='Ƭ˾'),
    Column('ui_company_address_mp', String(128), comment='Ƭ˾ַ'),
    Column('ui_position_mp', String(128), comment='Ƭְλ'),
    Column('ui_email_mp', String(128), comment='Ƭ'),
    Column('ui_introduction_mp', String(256), comment='Ƭ˽'),
    Column('ui_wechat_qrcode', String(256), comment='΢Ÿ˶ά'),
    Column('ui_type', String(3), comment=''),
    Column('ui_shenfen', String(3), comment='û'),
    Column('ui_rzstatus', INTEGER(3), comment='û֤״̬'),
    Column('org_id', String(64), comment='Id'),
    Column('team_id', String(64), comment='ŶId'),
    Column('join_time', DateTime, comment='Ŷʱ'),
    Column('staff_no', String(128), comment='Ա'),
    Column('investor_certified_status', INTEGER(1), comment='ϸͶ֤״̬'),
    Column('investor_certified_time', DateTime, comment='ϸͶ֤ʱ'),
    Column('createtime', DateTime, comment='ʱ'),
    Column('createby', String(64), comment=''),
    Column('updatetime', DateTime, comment='޸ʱ'),
    Column('updateby', String(64), comment='޸'),
    Column('deletetag', String(3), comment='ɾʶ'),
    Column('version_time', DateTime, comment='汾ʱ')
)


class UserInvestorRz(Base, BaseModel):
    __tablename__ = 'user_investor_rz'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    uir_explain = Column(String(128), comment='˵')
    option_a = Column(String(128), comment='ѡA')
    option_b = Column(String(128), comment='ѡB')
    check_res = Column(String(128), comment='ûѡ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    investor_rz_id = Column(String(64), comment='ģID')


class UserLike(Base, BaseModel):
    __tablename__ = 'user_like'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ul_ref_id = Column(String(64), comment='ID')
    ul_category = Column(INTEGER(1), comment='')
    ul_status = Column(INTEGER(1), comment='״̬')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class UserLoginSign(Base, BaseModel):
    __tablename__ = 'user_login_sign'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    uls_sign = Column(String(128), comment='ǩ')
    uls_validity_time = Column(DateTime, comment='Ч')
    uls_status = Column(String(3), comment='ʹ״̬')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UserOperateLog(Base, BaseModel):
    __tablename__ = 'user_operate_log'

    id = Column(String(64), primary_key=True, comment='')
    operate_user_id = Column(String(64), nullable=False, comment='id')
    operate_type = Column(INTEGER(11), nullable=False, comment='ͣҵֵ')
    pre_operate_info = Column(String(2000), comment='ǰϢ')
    after_operate_info = Column(String(2000), comment='Ϣ')
    create_time = Column(TIMESTAMP, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    update_time = Column(TIMESTAMP, nullable=False, server_default=text("'0000-00-00 00:00:00'"))
    status = Column(INTEGER(11), nullable=False, comment='״̬,1ˣ2ɣ3ȡ')


class UserRecallRecord(Base, BaseModel):
    __tablename__ = 'user_recall_record'

    id = Column(String(64), primary_key=True)
    user_id = Column(String(64), nullable=False, index=True, comment='ûid')
    wechat = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='Ƿ΢ 0   1')
    wx_group = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='Ƿ΢Ⱥ 0   1')
    recall = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='Ƿط 0   1')
    remark = Column(String(255), comment='ע')
    create_time = Column(DateTime, nullable=False, comment='ʱ')
    create_by = Column(String(64), nullable=False, comment='')
    update_time = Column(DateTime, nullable=False, comment='ʱ')
    update_by = Column(String(64), nullable=False, comment='')
    delete_tag = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='Ƿɾ')


class UserRecallRecordLog(Base, BaseModel):
    __tablename__ = 'user_recall_record_log'

    id = Column(String(64), primary_key=True)
    user_id = Column(String(64), nullable=False, comment='ûid')
    wechat = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='Ƿ΢ 0   1')
    wx_group = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='Ƿ΢Ⱥ 0   1')
    recall = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='Ƿط 0   1')
    remark = Column(String(255), comment='ע')
    create_time = Column(DateTime, nullable=False, comment='ʱ')
    create_by = Column(String(64), nullable=False, comment='')
    update_time = Column(DateTime, nullable=False, comment='ʱ')
    update_by = Column(String(64), nullable=False, comment='')
    delete_tag = Column(INTEGER(1), nullable=False, server_default=text("'0'"), comment='Ƿɾ')
    type = Column(INTEGER(11), nullable=False, comment='type: 1:Ƿ΢ 2:ǷȺ 3:Ƿط 4:ӱע')


class UserRecommend(Base, BaseModel):
    __tablename__ = 'user_recommend'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    fa_id = Column(String(64), comment='ʦId')
    visitor_id = Column(String(64), comment='ÿID')
    index_date = Column(Date, comment='')
    browse_num = Column(BIGINT(8), comment='鿴')
    browse_lastdata = Column(INTEGER(3), comment='Ƿ鿴')
    browse_thddays = Column(INTEGER(3), comment='Ƿ鿴3')
    browse_day_timelength = Column(BIGINT(8), comment='鿴ʱ')
    browse_cont_timelength = Column(BIGINT(8), comment='鿴ݳ10')
    forword_num = Column(BIGINT(8), comment='ݱת')
    forword_browsenum = Column(BIGINT(8), comment='תݴ鿴')
    click_imnnum = Column(BIGINT(8), comment='һĴ')
    click_cont_mp_num = Column(BIGINT(8), comment='ϵƬ')
    grant_phone_num = Column(BIGINT(8), comment='ȨֻŻʽ')
    reason_num = Column(INTEGER(3), comment='Ƽû')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class UserRight(Base, BaseModel):
    __tablename__ = 'user_rights'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ur_type = Column(String(3), comment='Ȩ')
    ur_proid = Column(String(64), comment='ƷID')
    ur_limitation = Column(String(3), comment='ʱЧ')
    ur_limitation_starttime = Column(DateTime, comment='ʱЧʼʱ')
    ur_limitation_endtime = Column(DateTime, comment='ʱЧʱ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UserRightsDetail(Base, BaseModel):
    __tablename__ = 'user_rights_detail'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    urd_rights_id = Column(String(64), comment='ȨID')
    urd_type = Column(String(3), comment='')
    urd_souce = Column(String(3), comment='ȡʽ 0 1ȡ')
    urd_refid = Column(String(64), comment='¼ID')
    urd_limitation = Column(String(3), comment='ʱЧ')
    urd_limitation_starttime = Column(DateTime, comment='ʱЧʼʱ')
    urd_limitation_endtime = Column(DateTime, comment='ʱЧʱ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UserRiskAssessment(Base, BaseModel):
    __tablename__ = 'user_risk_assessment'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    risk_id = Column(String(128), comment='ID')
    risk_name = Column(String(128), comment='')
    risk_description = Column(String(1024), comment='˵')
    risk_levels = Column(String(5120), comment='յȼ')
    risk_hight_score = Column(INTEGER(5), comment='߷')
    risk_endtime = Column(DateTime, comment='Чڵʱ')
    user_total_score = Column(INTEGER(5), comment='ûܵ÷')
    user_risk_type = Column(String(64), comment='ûյȼ( 飺riskProType)')
    user_risk_hightrisk_levels = Column(String(64), comment='û')
    user_low_risk = Column(String(3), comment='Ƿǵͷտͻ')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')
    risk_expire = Column(INTEGER(3), comment='Чڣλ£')


class UserRiskAssessmentItem(Base, BaseModel):
    __tablename__ = 'user_risk_assessment_item'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    risk_assess_id = Column(String(64), comment='ûղ¼ID')
    risk_group = Column(String(3), comment='( :riskAssType)')
    risk_item_type = Column(String(3), comment='')
    risk_item_stem = Column(String(512), comment='')
    risk_item_options = Column(String(5120), comment='ѡ')
    user_answer = Column(String(64), comment='û')
    user_score = Column(INTEGER(5), comment='û÷')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class UserRistRz(Base, BaseModel):
    __tablename__ = 'user_rist_rz'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    urr_rz_phone = Column(String(64), comment='ûֻ֤')
    urr_rz_phone_date = Column(DateTime, comment='ûֻ֤ʱ')
    urr_rz_name = Column(String(32), comment='֤û')
    urr_rz_cert_type = Column(String(3), comment='Ϣ֤-֤')
    urr_rz_cert_no = Column(String(64), comment='Ϣ֤-֤')
    urr_rz_cert_date = Column(DateTime, comment='Ϣ֤ʱ')
    investor_certified_id = Column(String(64), comment='ϸͶ֤û¼')
    investor_certified_status = Column(INTEGER(1), comment='ϸͶ֤״̬')
    investor_certified_time = Column(DateTime, comment='ϸͶ֤ʱ')
    investor_riskrz_id = Column(String(64), comment='ղ֤û¼')
    investor_riskrz_status = Column(INTEGER(1), comment='ղ֤״̬')
    investor_riskrz_time = Column(DateTime, comment='ղ֤ʱ')
    expire_time = Column(DateTime, comment='ʱ')
    org_id = Column(String(128), comment='ID')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), index=True, comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(INTEGER(1), comment='ɾʶ')


class UserRole(Base, BaseModel):
    __tablename__ = 'user_role'
    __table_args__ = {'comment': 'Ȩ'}

    id = Column(String(64), primary_key=True)
    ur_code = Column(String(16), nullable=False, unique=True, comment='ûɫΨһ')
    ur_coll = Column(String(64), nullable=False, comment='ɫ')
    ur_desc = Column(String(255), comment='ɫ')
    ur_name = Column(String(128), nullable=False, comment='ûɫ̨չʾã')
    ur_action = Column(String(64), nullable=False, comment='㵱ǰȨҪִеĶ')
    ur_action_desc = Column(String(128), nullable=False, comment='')
    ur_type = Column(INTEGER(3), nullable=False, comment='ɫ 0:ܽɫ 1:ݽɫ')
    create_by = Column(String(64), nullable=False)
    create_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP"))
    update_by = Column(String(64))
    update_time = Column(DateTime, nullable=False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
    delete_tag = Column(INTEGER(1), nullable=False, server_default=text("'0'"))


class UserShield(Base, BaseModel):
    __tablename__ = 'user_shield'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    iscontain_shield_user = Column(String(3), comment='Ƿû')
    shield_userid = Column(String(64), comment='ûID')
    org_id = Column(String(64), comment='ID')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UserTalk(Base, BaseModel):
    __tablename__ = 'user_talk'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ut_content = Column(String(512), comment='')
    ut_paixu = Column(INTEGER(3), comment='')
    ut_type = Column(INTEGER(11), comment=' 0Զ廰 1²ƷԶ廰')
    org_id = Column(String(64), comment='Id')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UserTeam(Base, BaseModel):
    __tablename__ = 'user_team'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    user_id = Column(String(64), comment='ûId')
    team_id = Column(String(64), comment='ŶId')
    is_leader = Column(INTEGER(128), comment='ǷΪŶӳ')
    invited_by = Column(String(64), comment='Id')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class UserTemplate(Base, BaseModel):
    __tablename__ = 'user_template'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    ut_tem = Column(Text, comment='ģ¼')
    ut_tem_del = Column(Text, comment='ɾģ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UserTemplate20190925(Base, BaseModel):
    __tablename__ = 'user_template_20190925'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    ut_tem = Column(Text, comment='ģ¼')
    ut_tem_del = Column(Text, comment='ɾģ')
    createtime = Column(DateTime, comment='ʱ')
    createby = Column(String(64), comment='')
    updatetime = Column(DateTime, comment='޸ʱ')
    updateby = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class UserVisitorClue(Base, BaseModel):
    __tablename__ = 'user_visitor_clue'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    uc_userid = Column(String(64), comment='ͻID')
    uc_name = Column(String(32), comment='ͻ')
    uc_headimg = Column(String(256), comment='ͻͷ')
    uc_phone = Column(String(32), comment='ͻֻ')
    uc_real_phone = Column(String(32))
    uc_msg_num = Column(INTEGER(6), comment='δϢ')
    uc_recent_visit_time = Column(DateTime, comment='ʱ')
    uc_recent_visit_title = Column(String(256), comment='ݱ')
    uc_visit_lable = Column(String(128), comment='ʱǩ')
    uc_visit_content = Column(Text, comment='ݼ')
    uc_faid = Column(String(64), comment='ʦID')
    uc_fission = Column(String(3), comment='һѱ־0һѣ1ѱ')
    uc_ismycustomer = Column(INTEGER(5))
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    uc_visitor_category = Column(INTEGER(11), comment='ÿ0ͨ1صǿͻ')
    uc_recommend_val = Column(INTEGER(11), server_default=text("'11'"))
    orgid = Column(String(64), comment='')
    user_source = Column(String(3))
    first_room = Column(String(64), comment='һֱId')
    first_class_friend_room_id = Column(String(64), comment='ΪһѵֱId')
    first_class_friend_time = Column(TIMESTAMP, comment='Ϊһѵʱ')
    important_user_room_id = Column(String(128), comment='Ϊصûֱid')
    important_user_time = Column(TIMESTAMP, comment='Ϊصûʱ')
    collect_username = Column(String(64), comment=' ֱռû')
    collect_phone = Column(String(16), comment='ֱռֻ')
    collect_isdone = Column(INTEGER(3), comment='ֱǷռûϢ 0: 1:')
    collect_time = Column(DateTime, comment='ֱռûϢʱ')
    isconsult = Column(INTEGER(3), comment='Ƿѯʦ 0 1:')


class UserWechat(Base, BaseModel):
    __tablename__ = 'user_wechats'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    uw_wechatid = Column(String(64), comment='ںż¼ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class UserWhitelist(Base, BaseModel):
    __tablename__ = 'user_whitelist'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    openid = Column(String(128), comment='ûopenId')
    funcode = Column(String(256), comment='Ȩ޹')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class VipUser(Base, BaseModel):
    __tablename__ = 'vip_user'

    id = Column(String(64), primary_key=True, server_default=text("''"), comment='Ψһ')
    vp_name = Column(String(32), comment='û')
    vp_phone = Column(String(64), comment='ֻ')
    vp_sex = Column(String(3), comment='ûԱ')
    vp_birthday = Column(String(64), comment='û')
    vp_city = Column(String(64), comment='ڳ')
    vp_isfa = Column(String(16), comment='Ƿʦ')
    vp_level = Column(String(16), comment='ȼ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class WxCpUser(Base, BaseModel):
    __tablename__ = 'wx_cp_user'

    user_id = Column(String(128), primary_key=True, server_default=text("''"), comment='ҵ΢ID')
    user_name = Column(String(128), comment='')
    department_id = Column(String(128), comment='Ӫҵ')
    department_name = Column(String(128), comment='Ӫҵ')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class ZhiboAppointment(Base, BaseModel):
    __tablename__ = 'zhibo_appointment'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    za_themeid = Column(String(64), comment='ID')
    za_userid = Column(String(64), comment='ԤԼ')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class ZhiboBlack(Base, BaseModel):
    __tablename__ = 'zhibo_black'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    zb_user_id = Column(String(64), comment='ûid')
    zb_theme_id = Column(String(64), comment='ID')
    zb_room_num = Column(String(64), comment='ֱ')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(String(3), comment='ɾʶ')


class ZhiboExam(Base, BaseModel):
    __tablename__ = 'zhibo_exam'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    ze_themeid = Column(String(64), comment='ID')
    ze_teaid = Column(String(64), comment='ʦID')
    ze_title = Column(String(128), comment='Ŀ')
    ze_options = Column(String(2048), comment='ѡ')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class ZhiboExamAnswer(Base, BaseModel):
    __tablename__ = 'zhibo_exam_answer'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    zs_themeid = Column(String(64), comment='ID')
    zs_msg = Column(String(64), comment='ϢID')
    zs_userid = Column(String(64), comment='ûID')
    zs_answer = Column(String(64), comment='ѡ')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class ZhiboFile(Base, BaseModel):
    __tablename__ = 'zhibo_file'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    zf_themeid = Column(String(32), comment='ID')
    zf_url = Column(String(32), comment='ַ')
    zf_file_type = Column(String(3), comment='ϴ')
    zf_use = Column(String(3), comment=';')
    zf_no = Column(INTEGER(3), comment='')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    org_id = Column(String(64), comment='ID')


class ZhiboHost(Base, BaseModel):
    __tablename__ = 'zhibo_host'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    zh_roomnum = Column(String(32), comment='ֱ')
    zh_status = Column(String(3), comment='ֱ״̬')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    zh_room_name = Column(String(64), comment='ֱ')


class ZhiboManger(Base, BaseModel):
    __tablename__ = 'zhibo_manger'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    zm_userid = Column(String(64), comment='Ա')
    zm_roomnum = Column(String(32), comment='ֱ')
    zm_shenfen = Column(String(3), comment='Ա')
    zm_paixu = Column(INTEGER(3))
    zm_username = Column(String(32))
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    org_id = Column(String(64), comment='ID')
    zm_teaid = Column(String(64), comment='ʦID')


class ZhiboMessage(Base, BaseModel):
    __tablename__ = 'zhibo_message'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    zm_content = Column(String(1024), comment='Ϣ')
    zm_themeid = Column(String(64))
    zm_serviceid = Column(String(128), comment='΢serviceId')
    zm_format = Column(String(3), comment='Ϣʽ')
    zm_type = Column(String(3), comment='Ϣ')
    zm_askid = Column(String(64), comment='ϢID')
    zm_roomnum = Column(String(32), comment='ֱ')
    zm_audiotimelength = Column(INTEGER(11), server_default=text("'5'"))
    zm_timesplit = Column(String(3))
    zm_audiotext = Column(String(512))
    zm_status = Column(String(3))
    zm_recordtime = Column(DateTime)
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    org_id = Column(String(64), comment='ID')
    highlighted = Column(INTEGER(3), comment='Ƿص')


class ZhiboPhrase(Base, BaseModel):
    __tablename__ = 'zhibo_phrase'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    zp_type = Column(String(64), comment='')
    zp_content = Column(String(1024), comment='')
    zp_sort_num = Column(INTEGER(11), comment='')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(String(3), comment='ɾʶ')


class ZhiboSign(Base, BaseModel):
    __tablename__ = 'zhibo_sign'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    zs_themeid = Column(String(64), comment='ID')
    zs_userid = Column(String(64), comment='ǩID')
    zs_headimg = Column(String(256), comment='ǩͷ')
    zs_uname = Column(String(64), comment='ǩ')
    org_id = Column(String(64), comment='ID')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')


class ZhiboTheme(Base, BaseModel):
    __tablename__ = 'zhibo_theme'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    zt_name = Column(String(32), comment='')
    zt_starttime = Column(DateTime, comment='ʱ䣬ʾĿʼʱ')
    zt_endtime = Column(DateTime, comment='ʱ䣬ʾĽʱ')
    zt_desc = Column(String(512), comment='')
    zt_roomnum = Column(String(32))
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    zt_status = Column(Text, comment='ֱ״̬')
    zt_backimg = Column(String(128), comment='ֱͼ,')
    share_pattern = Column(INTEGER(3), comment='ģʽ')
    zt_img = Column(String(128), comment='ͼ')
    zt_iszhibo = Column(String(3), comment='Ƿֱ')
    zt_proid = Column(String(64), comment='Ʒ')
    zt_uname = Column(String(128), comment='ѵ')
    zt_flag = Column(String(3), comment='˿űʶ')
    org_id = Column(String(64), comment='ID')
    zt_password = Column(String(8), comment='')
    zt_label = Column(String(1024), comment='ֱǩ')
    zt_userids = Column(Text, comment='')
    zt_mute = Column(String(3), comment='Ƿ 0 1')
    zt_type = Column(String(64), comment='ǩ')
    zt_appointment_nums = Column(INTEGER(8))
    zt_info = Column(Text)
    zt_qrcode = Column(String(256))
    zt_fuli = Column(Text)
    zt_cardinal = Column(INTEGER(11), comment='ֱ')


class ZhiboUser(Base, BaseModel):
    __tablename__ = 'zhibo_users'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    zu_themdid = Column(String(32), comment='ID')
    zu_uid = Column(String(32), comment='֯ԱID')
    zu_type = Column(String(3), comment='')
    zu_fullpath = Column(String(512))
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    deletetag = Column(String(3), comment='ɾʶ')
    org_id = Column(String(64), comment='ID')


class Zidian(Base, BaseModel):
    __tablename__ = 'zidian'

    id = Column(String(64), primary_key=True, comment='Ψһ')
    zu = Column(String(64), comment='')
    daima = Column(String(64), comment='')
    zhi = Column(String(64), comment='ֵ')
    paixu = Column(INTEGER(4), comment='')
    create_time = Column(DateTime, comment='ʱ')
    create_by = Column(String(64), comment='')
    update_time = Column(DateTime, comment='޸ʱ')
    update_by = Column(String(64), comment='޸')
    delete_tag = Column(INTEGER(1), comment='ɾʶ')


class QrtzTrigger(Base, BaseModel):
    __tablename__ = 'qrtz_triggers'
    __table_args__ = (
        ForeignKeyConstraint(['SCHED_NAME', 'JOB_NAME', 'JOB_GROUP'], ['qrtz_job_details.SCHED_NAME', 'qrtz_job_details.JOB_NAME', 'qrtz_job_details.JOB_GROUP']),
        Index('IDX_QRTZ_T_G', 'SCHED_NAME', 'TRIGGER_GROUP'),
        Index('IDX_QRTZ_T_STATE', 'SCHED_NAME', 'TRIGGER_STATE'),
        Index('IDX_QRTZ_T_NFT_ST', 'SCHED_NAME', 'TRIGGER_STATE', 'NEXT_FIRE_TIME'),
        Index('IDX_QRTZ_T_NFT_ST_MISFIRE_GRP', 'SCHED_NAME', 'MISFIRE_INSTR', 'NEXT_FIRE_TIME', 'TRIGGER_GROUP', 'TRIGGER_STATE'),
        Index('IDX_QRTZ_T_J', 'SCHED_NAME', 'JOB_NAME', 'JOB_GROUP'),
        Index('IDX_QRTZ_T_N_STATE', 'SCHED_NAME', 'TRIGGER_NAME', 'TRIGGER_GROUP', 'TRIGGER_STATE'),
        Index('IDX_QRTZ_T_NFT_MISFIRE', 'SCHED_NAME', 'MISFIRE_INSTR', 'NEXT_FIRE_TIME'),
        Index('IDX_QRTZ_T_JG', 'SCHED_NAME', 'JOB_GROUP'),
        Index('IDX_QRTZ_T_N_G_STATE', 'SCHED_NAME', 'TRIGGER_GROUP', 'TRIGGER_STATE'),
        Index('IDX_QRTZ_T_NFT_ST_MISFIRE', 'SCHED_NAME', 'MISFIRE_INSTR', 'NEXT_FIRE_TIME', 'TRIGGER_STATE'),
        Index('IDX_QRTZ_T_C', 'SCHED_NAME', 'CALENDAR_NAME'),
        Index('IDX_QRTZ_T_NEXT_FIRE_TIME', 'SCHED_NAME', 'NEXT_FIRE_TIME')
    )

    SCHED_NAME = Column(String(120), primary_key=True, nullable=False)
    TRIGGER_NAME = Column(String(190), primary_key=True, nullable=False)
    TRIGGER_GROUP = Column(String(190), primary_key=True, nullable=False)
    JOB_NAME = Column(String(190), nullable=False)
    JOB_GROUP = Column(String(190), nullable=False)
    DESCRIPTION = Column(String(250))
    NEXT_FIRE_TIME = Column(BIGINT(13))
    PREV_FIRE_TIME = Column(BIGINT(13))
    PRIORITY = Column(INTEGER(11))
    TRIGGER_STATE = Column(String(16), nullable=False)
    TRIGGER_TYPE = Column(String(8), nullable=False)
    START_TIME = Column(BIGINT(13), nullable=False)
    END_TIME = Column(BIGINT(13))
    CALENDAR_NAME = Column(String(190))
    MISFIRE_INSTR = Column(SMALLINT(2))
    JOB_DATA = Column(LargeBinary)

    qrtz_job_detail = relationship('QrtzJobDetail')


class QrtzBlobTrigger(QrtzTrigger):
    __tablename__ = 'qrtz_blob_triggers'
    __table_args__ = (
        ForeignKeyConstraint(['SCHED_NAME', 'TRIGGER_NAME', 'TRIGGER_GROUP'], ['qrtz_triggers.SCHED_NAME', 'qrtz_triggers.TRIGGER_NAME', 'qrtz_triggers.TRIGGER_GROUP']),
        Index('SCHED_NAME', 'SCHED_NAME', 'TRIGGER_NAME', 'TRIGGER_GROUP')
    )

    SCHED_NAME = Column(String(120), primary_key=True, nullable=False)
    TRIGGER_NAME = Column(String(190), primary_key=True, nullable=False)
    TRIGGER_GROUP = Column(String(190), primary_key=True, nullable=False)
    BLOB_DATA = Column(LargeBinary)


class QrtzCronTrigger(QrtzTrigger):
    __tablename__ = 'qrtz_cron_triggers'
    __table_args__ = (
        ForeignKeyConstraint(['SCHED_NAME', 'TRIGGER_NAME', 'TRIGGER_GROUP'], ['qrtz_triggers.SCHED_NAME', 'qrtz_triggers.TRIGGER_NAME', 'qrtz_triggers.TRIGGER_GROUP']),
    )

    SCHED_NAME = Column(String(120), primary_key=True, nullable=False)
    TRIGGER_NAME = Column(String(190), primary_key=True, nullable=False)
    TRIGGER_GROUP = Column(String(190), primary_key=True, nullable=False)
    CRON_EXPRESSION = Column(String(120), nullable=False)
    TIME_ZONE_ID = Column(String(80))


class QrtzSimpleTrigger(QrtzTrigger):
    __tablename__ = 'qrtz_simple_triggers'
    __table_args__ = (
        ForeignKeyConstraint(['SCHED_NAME', 'TRIGGER_NAME', 'TRIGGER_GROUP'], ['qrtz_triggers.SCHED_NAME', 'qrtz_triggers.TRIGGER_NAME', 'qrtz_triggers.TRIGGER_GROUP']),
    )

    SCHED_NAME = Column(String(120), primary_key=True, nullable=False)
    TRIGGER_NAME = Column(String(190), primary_key=True, nullable=False)
    TRIGGER_GROUP = Column(String(190), primary_key=True, nullable=False)
    REPEAT_COUNT = Column(BIGINT(7), nullable=False)
    REPEAT_INTERVAL = Column(BIGINT(12), nullable=False)
    TIMES_TRIGGERED = Column(BIGINT(10), nullable=False)


class QrtzSimpropTrigger(QrtzTrigger):
    __tablename__ = 'qrtz_simprop_triggers'
    __table_args__ = (
        ForeignKeyConstraint(['SCHED_NAME', 'TRIGGER_NAME', 'TRIGGER_GROUP'], ['qrtz_triggers.SCHED_NAME', 'qrtz_triggers.TRIGGER_NAME', 'qrtz_triggers.TRIGGER_GROUP']),
    )

    SCHED_NAME = Column(String(120), primary_key=True, nullable=False)
    TRIGGER_NAME = Column(String(190), primary_key=True, nullable=False)
    TRIGGER_GROUP = Column(String(190), primary_key=True, nullable=False)
    STR_PROP_1 = Column(String(512))
    STR_PROP_2 = Column(String(512))
    STR_PROP_3 = Column(String(512))
    INT_PROP_1 = Column(INTEGER(11))
    INT_PROP_2 = Column(INTEGER(11))
    LONG_PROP_1 = Column(BIGINT(20))
    LONG_PROP_2 = Column(BIGINT(20))
    DEC_PROP_1 = Column(DECIMAL(13, 4))
    DEC_PROP_2 = Column(DECIMAL(13, 4))
    BOOL_PROP_1 = Column(String(1))
    BOOL_PROP_2 = Column(String(1))
